/****************************************************************/
// ComposanteConnexe.cpp: implementation of the CComposanteConnexe class.
/****************************************************************/

#include "stdafx.h"
#include "myapp.h"
#include "ComposanteConnexe.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/****************************************************************/
// Construction/Destruction
/****************************************************************/

CComposanteConnexe::CComposanteConnexe()
{
	image = new CImage ();
	image_dilatee = new CImage ();
	nb_occurences = 1;
	nom_fichier = "";
	numero = -1;
}

CComposanteConnexe::CComposanteConnexe(CImage* img, CString s, int num)
{
	image = img;
	nb_occurences = 1;
	nom_fichier = s;
	numero = num;
	image_dilatee = new CImage();
	image_dilatee->Copier(image);
	image_dilatee->setBinarisee(true);
	image_dilatee->Dilater();
}

CComposanteConnexe::~CComposanteConnexe()
{
	delete image;
	delete image_dilatee;
}

int CComposanteConnexe::get_nb_occurences ()
{
	return nb_occurences;
}

void CComposanteConnexe::set_nb_occurences (int nb)
{
	nb_occurences = nb;
}

CImage* CComposanteConnexe::get_image ()
{
	return image;
}

CImage* CComposanteConnexe::get_image_dilatee ()
{
	return image_dilatee;
}

void CComposanteConnexe::set_image_dilatee (CImage* img)
{
	image_dilatee = img;
}

CString CComposanteConnexe::get_nom_fichier ()
{
	return nom_fichier;
}

void CComposanteConnexe::set_nom_fichier (CString s)
{
	nom_fichier = s;
}

int CComposanteConnexe::get_numero ()
{
	return numero;
}

void CComposanteConnexe::set_numero (int n)
{
	numero = n;
}