// ComposanteConnexe.h: interface for the CComposanteConnexe class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMPOSANTECONNEXE_H__08BDE0E6_A413_4C0F_8278_10FD04D95E9A__INCLUDED_)
#define AFX_COMPOSANTECONNEXE_H__08BDE0E6_A413_4C0F_8278_10FD04D95E9A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Image.h"

class CComposanteConnexe : public CObject  
{
private:
	CImage *image;				// la forme au format bitmap
	CImage *image_dilatee;		// la forme au format bitmap aprs dilatation de image
	int nb_occurences;			// nb d'occurences de cette forme parmi les docs tudis
	int numero;				// le numro du fichier texte contenant les infos sur les formes
	CString nom_fichier;		// le chemin d'accs complet de ce fichier
public:
	int get_nb_occurences ();
	void set_nb_occurences (int nb);
	int get_numero ();
	void set_numero (int n);
	CImage* get_image ();
	CImage* get_image_dilatee ();
	void set_image_dilatee (CImage* img);
	CString get_nom_fichier ();
	void set_nom_fichier (CString s);

	CComposanteConnexe();
	CComposanteConnexe(CImage* img, CString s, int num);
	virtual ~CComposanteConnexe();

};

#endif // !defined(AFX_COMPOSANTECONNEXE_H__08BDE0E6_A413_4C0F_8278_10FD04D95E9A__INCLUDED_)
