// DIALOGReglage.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "MyApp.h"
#include "DIALOGReglage.h"
#include ".\dialogreglage.h"



// Bote de dialogue CDIALOGReglage

IMPLEMENT_DYNAMIC(CDIALOGReglage, CDialog)
CDIALOGReglage::CDIALOGReglage(CWnd* pParent /*=NULL*/,CObList * listeLabel,list<CNomLabel> *listeVal)
	: CDialog(CDIALOGReglage::IDD, pParent)
{
	listeRegl=listeLabel;
	liste=listeVal;
	seuildico=0.15;	
	
}

CDIALOGReglage::~CDIALOGReglage()
{
}

void CDIALOGReglage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);	
	DDX_Text(pDX, IDC_EDIT3, seuildico);
}

BOOL CDIALOGReglage::OnInitDialog()
{
	CListBox *List1=(CListBox *)GetDlgItem(IDC_LISTinit);
	
	CString nomClasse;
	POSITION pos = listeRegl->GetHeadPosition();
	while (pos)
	{
		CTypeClasse *classTemp = (CTypeClasse*)listeRegl->GetNext(pos);
		nomClasse = classTemp->getNomClasse();
		if (nomClasse != "BRUIT")
		{
			List1->AddString(nomClasse);
		}
	}
	return CDialog::OnInitDialog();
}

BEGIN_MESSAGE_MAP(CDIALOGReglage, CDialog)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// Gestionnaires de messages CDIALOGReglage

void CDIALOGReglage::OnBnClickedButton1()
{
	// TODO : ajoutez ici le code de votre gestionnaire de notification de contrle
	UpdateData(true); UpdateWindow();
	CListBox *List1=(CListBox *)GetDlgItem(IDC_LISTinit);
	CListBox *List2=(CListBox *)GetDlgItem(IDC_LISTend);
	GetDlgItem(IDC_SEUIL_DICO_ETAP4);
	int nIndex = List1->GetCurSel();
	CString szStr;
    szStr.Format("%.2lf",seuildico); 
	if((nIndex != LB_ERR))  
	{
		CString str;
		List1->GetText(nIndex,str);
		//On ajoute  la liste chaine l'lment
		CNomLabel t(str,seuildico);
		liste->push_back(t);
		
		//puis on  ajoute  la liste
		str=str+"("+ szStr+")";
		List2->AddString(str);
		List1->DeleteString( nIndex );
	}



}

void CDIALOGReglage::OnBnClickedButton2()
{
		// TODO : ajoutez ici le code de votre gestionnaire de notification de contrle
	UpdateData(true); UpdateWindow();
	CListBox *List1=(CListBox *)GetDlgItem(IDC_LISTinit);
	CListBox *List2=(CListBox *)GetDlgItem(IDC_LISTend);
	int nIndex = List2->GetCurSel();
	if((nIndex != LB_ERR))  
	{
		CString str;
		List2->GetText(nIndex,str);
		
		
		int cur=(int)str.Find("(",0);//extraction du mot
		if (cur!=0){						
			str=str.Left(cur);				
			}
		//On ajoute  la liste chaine l'lment
		CNomLabel t(str,seuildico);
		Effacer(t);//pas GL
		List1->AddString(str);
		List2->DeleteString( nIndex );
		

	}
}

void CDIALOGReglage::OnBnClickedOk()
{
	
	//
	//listeRegl->RemoveAll();
	//CListBox *List2=(CListBox *)GetDlgItem(IDC_LISTend);
	//int nb=List2->GetCount();

	//for (int i=0;i<nb;i++)
	//{
	//	CString rr("toto");
	//	list<CNomLabel> liste;//Liste de mots
	//	CNomLabel t(rr,0.3);
	//	liste.push_back(t);
	//	
	//	//listeRSeuils->AddTail(3);
	//}
	//
	OnOK();
}

///*****************nom de la fonction****************************/ 
////Effacer(CMot toFind)
///***********************but*************************************/
////Efface le CNomLabel toFind dans la liste
///*********************entres***********************************/
////CNomLabel toFind : CMot  effacer dans la liste de this
///*********************sorties***********************************/ 
////bool : Retourne vrai si le mot a t effac. Faux s'il ne s'y trouvait pas
///*********************exceptions********************************/ 
////
///***************************************************************/
bool CDIALOGReglage::Effacer(CNomLabel toFind)
{


	list<CNomLabel>* listeFind=liste;
	list<CNomLabel>::iterator theIteratorMot;
	theIteratorMot = listeFind->begin();
	while (theIteratorMot!=listeFind->end())
	{
		CNomLabel motTemp= *theIteratorMot;
		if (motTemp.nomLabel.Compare(toFind.nomLabel)==0)
		{
			listeFind->erase(theIteratorMot);
			return true;
		}
		theIteratorMot++;
	}
	return false;


}