// DialogClassifAuto.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "MyApp.h"
#include <afxdlgs.h>
#include "DialogClassifAuto.h"
#include ".\dialogclassifauto.h"
#include "constante.h"


// Bote de dialogue CDialogClassifAuto

IMPLEMENT_DYNAMIC(CDialogClassifAuto, CDialog)
CDialogClassifAuto::CDialogClassifAuto(CClassifAutoDonnees *datasIn, CWnd* pParent /*=NULL*/)
	: CDialog(CDialogClassifAuto::IDD, pParent)
{
	datas = datasIn;

	m_radioCaracMoy = true;
	m_radioGeoMoy = true;
	m_valSliderVoisReg = 0;
	m_valSliderGeoE = 0;
	m_valSliderGeoO = 0;
	m_valSliderGeoC = 0;
	m_valSliderGeoB = 0;
	m_valSliderGeoH = 0;
	m_valSliderGeoD = 0;
	m_valSliderGeoG = 0;
	m_valSliderCaracEcart = 0;
	m_valSliderCaracReg = 0;

	m_check1 = false;
	m_check2 = false;
	m_check3 = false;
	m_check4 = false;
	m_check5 = false;
	m_check6 = false;
	m_check7 = false;
	m_check10 = false;
	m_check11 = false;
	m_check12 = false;
	m_check13 = false;
	m_check14 = false;
	m_check15 = false;
	m_check16 = false;
	m_check17 = false;
	m_check18 = false;
	m_check19 = false;
	m_check20 = false;
	m_check21 = false;

	m_ordreCarac = 3;
	m_ordreGeo = 3;
	m_ordreVois = 3;

	m_editTypeOrg = _T("");
}

CDialogClassifAuto::~CDialogClassifAuto()
{
}

void CDialogClassifAuto::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_SLIDER_VALUE22, m_valSliderVoisReg);
	DDX_Text(pDX, IDC_SLIDER_VALUE16, m_valSliderGeoE);
	DDX_Text(pDX, IDC_SLIDER_VALUE15, m_valSliderGeoO);
	DDX_Text(pDX, IDC_SLIDER_VALUE14, m_valSliderGeoC);
	DDX_Text(pDX, IDC_SLIDER_VALUE13, m_valSliderGeoB);
	DDX_Text(pDX, IDC_SLIDER_VALUE12, m_valSliderGeoH);
	DDX_Text(pDX, IDC_SLIDER_VALUE11, m_valSliderGeoD);
	DDX_Text(pDX, IDC_SLIDER_VALUE10, m_valSliderGeoG);
	DDX_Text(pDX, IDC_SLIDER_VALUE9, m_valSliderCaracEcart);
	DDX_Text(pDX, IDC_SLIDER_VALUE8, m_valSliderCaracReg);
	DDX_Check(pDX, IDC_CHECK1, m_check1);
	DDX_Check(pDX, IDC_CHECK2, m_check2);
	DDX_Check(pDX, IDC_CHECK3, m_check3);
	DDX_Check(pDX, IDC_CHECK4, m_check4);
	DDX_Check(pDX, IDC_CHECK5, m_check5);
	DDX_Check(pDX, IDC_CHECK6, m_check6);
	DDX_Check(pDX, IDC_CHECK7, m_check7);
	DDX_Check(pDX, IDC_CHECK10, m_check10);
	DDX_Check(pDX, IDC_CHECK11, m_check11);
	DDX_Check(pDX, IDC_CHECK12, m_check12);
	DDX_Check(pDX, IDC_CHECK13, m_check13);
	DDX_Check(pDX, IDC_CHECK14, m_check14);
	DDX_Check(pDX, IDC_CHECK15, m_check15);
	DDX_Check(pDX, IDC_CHECK16, m_check16);
	DDX_Check(pDX, IDC_CHECK17, m_check17);
	DDX_Check(pDX, IDC_CHECK18, m_check18);
	DDX_Check(pDX, IDC_CHECK19, m_check19);
	DDX_Check(pDX, IDC_CHECK20, m_check20);
	DDX_Check(pDX, IDC_CHECK21, m_check21);
	DDX_Text(pDX, IDC_MIN1, m_valMin1);
	DDX_Text(pDX, IDC_MIN2, m_valMin2);
	DDX_Text(pDX, IDC_MIN3, m_valMin3);
	DDX_Text(pDX, IDC_MIN4, m_valMin4);
	DDX_Text(pDX, IDC_MIN5, m_valMin5);
	DDX_Text(pDX, IDC_MIN6, m_valMin6);
	DDX_Text(pDX, IDC_MIN7, m_valMin7);
	DDX_Text(pDX, IDC_MAX1, m_valMax1);
	DDX_Text(pDX, IDC_MAX2, m_valMax2);
	DDX_Text(pDX, IDC_MAX3, m_valMax3);
	DDX_Text(pDX, IDC_MAX4, m_valMax4);
	DDX_Text(pDX, IDC_MAX5, m_valMax5);
	DDX_Text(pDX, IDC_MAX6, m_valMax6);
	DDX_Text(pDX, IDC_MAX7, m_valMax7);
	DDX_CBString(pDX, IDC_LISTE_TYPES_ORG, m_editTypeOrg);
}


BEGIN_MESSAGE_MAP(CDialogClassifAuto, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_RADIO_CARAC_MOY, OnBnClickedRadioCaracMoy)
	ON_BN_CLICKED(IDC_RADIO_CARAC_MED, OnBnClickedRadioCaracMed)
	ON_BN_CLICKED(IDC_RADIO_GEO_MOY, OnBnClickedRadioGeoMoy)
	ON_BN_CLICKED(IDC_RADIO_GEO_MED, OnBnClickedRadioGeoMed)
	ON_BN_CLICKED(IDC_CHECK1, OnBnClickedCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnBnClickedCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnBnClickedCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnBnClickedCheck4)
	ON_BN_CLICKED(IDC_CHECK5, OnBnClickedCheck5)
	ON_BN_CLICKED(IDC_CHECK6, OnBnClickedCheck6)
	ON_BN_CLICKED(IDC_CHECK7, OnBnClickedCheck7)
	ON_BN_CLICKED(IDC_CHECK10, OnBnClickedCheck10)
	ON_BN_CLICKED(IDC_CHECK11, OnBnClickedCheck11)
	ON_BN_CLICKED(IDC_CHECK12, OnBnClickedCheck12)
	ON_BN_CLICKED(IDC_CHECK13, OnBnClickedCheck13)
	ON_BN_CLICKED(IDC_CHECK14, OnBnClickedCheck14)
	ON_BN_CLICKED(IDC_CHECK15, OnBnClickedCheck15)
	ON_BN_CLICKED(IDC_CHECK16, OnBnClickedCheck16)
	ON_BN_CLICKED(IDC_CHECK17, OnBnClickedCheck17)
	ON_BN_CLICKED(IDC_CHECK18, OnBnClickedCheck18)
	ON_BN_CLICKED(IDC_CHECK19, OnBnClickedCheck19)
	ON_BN_CLICKED(IDC_CHECK20, OnBnClickedCheck20)
	ON_BN_CLICKED(IDC_CHECK21, OnBnClickedCheck21)
	ON_BN_CLICKED(IDC_RADIO_ORDRE_CARAC1, OnBnClickedRadioOrdreCarac1)
	ON_BN_CLICKED(IDC_RADIO_ORDRE_CARAC2, OnBnClickedRadioOrdreCarac2)
	ON_BN_CLICKED(IDC_RADIO_ORDRE_CARAC3, OnBnClickedRadioOrdreCarac3)
	ON_BN_CLICKED(IDC_RADIO_ORDRE_CARACNUL, OnBnClickedRadioOrdreCaracnul)
	ON_BN_CLICKED(IDC_RADIO_ORDRE_GEO1, OnBnClickedRadioOrdreGeo1)
	ON_BN_CLICKED(IDC_RADIO_ORDRE_GEO2, OnBnClickedRadioOrdreGeo2)
	ON_BN_CLICKED(IDC_RADIO_ORDRE_GEO3, OnBnClickedRadioOrdreGeo3)
	ON_BN_CLICKED(IDC_RADIO_ORDRE_GEONUL, OnBnClickedRadioOrdreGeonul)
	ON_BN_CLICKED(IDC_RADIO_ORDRE_VOIS1, OnBnClickedRadioOrdreVois1)
	ON_BN_CLICKED(IDC_RADIO_ORDRE_VOIS2, OnBnClickedRadioOrdreVois2)
	ON_BN_CLICKED(IDC_RADIO_ORDRE_VOIS3, OnBnClickedRadioOrdreVois3)
	ON_BN_CLICKED(IDC_RADIO_ORDRE_VOISNUL, OnBnClickedRadioOrdreVoisnul)
	ON_BN_CLICKED(IDC_BUTTON_RET_VAL_ORG, OnBnClickedButtonRetValOrg)
END_MESSAGE_MAP()


// Gestionnaires de messages CDialogClassifAuto

BOOL CDialogClassifAuto::OnInitDialog()
{
	InitPartMode();
	InitPartCarac();
	InitPartGeo();
	InitPartVois();
	InitPartOrdre();

	CocherReglesGlobal();

	MajInterface();

	return CDialog::OnInitDialog();
}

void CDialogClassifAuto::OnBnClickedOk()
{
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());
	CLaboClassif *laboClassifTmp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif();
	CClassifAuto *classifTemp = laboClassifTmp->getClassifAuto();
	

	if ((m_ordreCarac == m_ordreGeo) && (m_ordreCarac != 3)) {AfxMessageBox("Uncorrect rule application order."); return;}
	if ((m_ordreCarac == m_ordreVois)  && (m_ordreCarac != 3)) {AfxMessageBox("Uncorrect rule application order."); return;}
	if ((m_ordreGeo == m_ordreVois) && (m_ordreGeo != 3)) {AfxMessageBox("Uncorrect rule application order."); return;}
	if (m_editTypeOrg.IsEmpty()) {AfxMessageBox("Original label is not selected"); return;}

	UpdateData(true);UpdateWindow();

	//effacement du scenario cr prcdemment:
	datas->getScenarAuto()->EffacerTout();

	//rcupration du type Org dans la liste
	datas->setTypeOrg(m_editTypeOrg);

	//creation de la classe de destination si elle n'existe pas
	//bool typeSiExiste = classifTemp->findElemListeTypesClasse(datas->getTypeDest());
	//mis a false manuellement car le nouveau type de la premiere previsualisation est supprim lorsque l'on clique
	//sur OK (fait dans DlgAssist3)
	bool typeSiExiste = false;
	if (!typeSiExiste)
	{
		CRegleType *r1=new CRegleType(datas->getTypeDest(),datas->getColorDest());
		datas->getScenarAuto()->Ajouter(r1);
		//on ne l'execute pas car toutes les regles de la classif auto
		//sont executes dans DlgAssist3
	}

	CString etiquetteOrg = datas->getTypeOrg();
	CString etiquetteSaisie = datas->getTypeDest();
	double val = -1;
	CString voisStr = "NULL";
	double valMin0 = -1,valMin1 = -1,valMin2 = -1,valMin3 = -1,valMin4 = -1,valMin5 = -1,valMin6 = -1;
	double valMax0 = -1,valMax1 = -1,valMax2 = -1,valMax3 = -1,valMax4 = -1,valMax5 = -1,valMax6 = -1;
	int nb = 0, i=0;
	CList<CString,CString> *listeVH,*listeVG,*listeVB,*listeVD,*listeVI;
	listeVH	= new CList<CString,CString>();
	listeVG	= new CList<CString,CString>();
	listeVB	= new CList<CString,CString>();
	listeVD	= new CList<CString,CString>();
	listeVI	= new CList<CString,CString>();
	CRegleCC *a;
	CRegleCG *b1;
	CRegleCG *b2;
	CRegleCG *b3;
	CRegleCG *b4;
	CRegleCG *b5;
	CRegleCG *b6;
	CRegleCG *b7;
	CRegleCV *c;
	CListBox *listeh=(CListBox *)GetDlgItem(IDC_LISTEH);
	CListBox *listeg=(CListBox *)GetDlgItem(IDC_LISTEG);
	CListBox *listeb=(CListBox *)GetDlgItem(IDC_LISTEB);
	CListBox *listed=(CListBox *)GetDlgItem(IDC_LISTED);
	CListBox *listei=(CListBox *)GetDlgItem(IDC_LISTEI);
	int *liste_voisins_gauche = new int[listeg->GetCount()];
	int *liste_voisins_droite = new int[listed->GetCount()];
	int *liste_voisins_haut = new int[listeh->GetCount()];
	int *liste_voisins_bas = new int[listeb->GetCount()];
	int *liste_voisins_inclus = new int[listei->GetCount()];
	listeg->GetSelItems(listeg->GetSelCount(),liste_voisins_gauche);
	listed->GetSelItems(listed->GetSelCount(),liste_voisins_droite);
	listeh->GetSelItems(listeh->GetSelCount(),liste_voisins_haut);
	listeb->GetSelItems(listeb->GetSelCount(),liste_voisins_bas);
	listei->GetSelItems(listei->GetSelCount(),liste_voisins_inclus);

	CRegleCarac *r = new CRegleCarac();
	int *m_tabPosCarac = new int[7];
	int *m_tabPosGeo = new int[7];
	int *m_tabPosVois = new int[5];
	int *m_tabPosGlobal = new int[3];
	bool pos0Prise = false;
	bool pos1Prise = false;
	bool pos2Prise = false;
	bool pos3Prise = false;
	bool pos4Prise = false;
	bool pos5Prise = false;

	m_tabPosCarac = datas->getTabPosETCarac();
	m_tabPosGeo = datas->getTabPosETGeo();
	m_tabPosVois = datas->getTabPosETVois();
	m_tabPosGlobal = datas->getTabPosETGlobalNonIndep();

	datas->setNbMaxCaracReg(0);
	datas->setNbMaxGeoReg(0);
	datas->setNbMaxVoisReg(0);
	datas->setNbMaxGlobalRegNonIndep(0);

	//regleCC
	if(m_ordreCarac != 3)
	{
		if (m_check1)
		{
			valMin0 = m_valMin1;
			valMax0 = m_valMax1;

			datas->SetValListeDoubleAt(datas->getListeValCaracMin(),RAPPORTLSURH_BIS,m_valMin1);
			datas->SetValListeDoubleAt(datas->getListeValCaracMax(),RAPPORTLSURH_BIS,m_valMax1);

			m_tabPosCarac[0] = RAPPORTLSURH_BIS;
			pos0Prise = true;
			datas->setNbMaxCaracReg(1);
		}else
		{
			valMin0 = -1;
			valMax0 = -1;
		}

		if (m_check2)
		{
			valMin1 = m_valMin2;
			valMax1 = m_valMax2;

			datas->SetValListeDoubleAt(datas->getListeValCaracMin(),NBELEMENTS_BIS,m_valMin2);
			datas->SetValListeDoubleAt(datas->getListeValCaracMax(),NBELEMENTS_BIS,m_valMax2);

			if (pos0Prise)
			{
				m_tabPosCarac[1] = NBELEMENTS_BIS;
				pos1Prise = true;
				datas->setNbMaxCaracReg(2);
			}
			else
			{
				m_tabPosCarac[0] = NBELEMENTS_BIS;
				pos0Prise = true;
				datas->setNbMaxCaracReg(1);
			}
		}else
		{
			valMin1 = -1;
			valMax1 = -1;
		}

		if (m_check3)
		{
			valMin2 = m_valMin3;
			valMax2 = m_valMax3;

			datas->SetValListeDoubleAt(datas->getListeValCaracMin(),RAPPORTHSURHMOYCC_BIS,m_valMin3);
			datas->SetValListeDoubleAt(datas->getListeValCaracMax(),RAPPORTHSURHMOYCC_BIS,m_valMax3);

			if (pos0Prise)
			{
				if (pos1Prise)
				{
					m_tabPosCarac[2] = RAPPORTHSURHMOYCC_BIS;
					pos2Prise = true;
					datas->setNbMaxCaracReg(3);
				}
				else
				{
					m_tabPosCarac[1] = RAPPORTHSURHMOYCC_BIS;
					pos1Prise = true;
					datas->setNbMaxCaracReg(2);
				}
			}
			else
			{
				m_tabPosCarac[0] = RAPPORTHSURHMOYCC_BIS;
				pos0Prise = true;
				datas->setNbMaxCaracReg(1);
			}
		}else
		{
			valMin2 = -1;
			valMax2 = -1;
		}

		if (m_check4)
		{
			valMin3 = m_valMin4;
			valMax3 = m_valMax4;

			datas->SetValListeDoubleAt(datas->getListeValCaracMin(),LARGEURZONE_BIS,m_valMin4);
			datas->SetValListeDoubleAt(datas->getListeValCaracMax(),LARGEURZONE_BIS,m_valMax4);

			if (pos0Prise)
			{
				if (pos1Prise)
				{
					if (pos2Prise)
					{
						m_tabPosCarac[3] = LARGEURZONE_BIS;
						pos3Prise = true;
						datas->setNbMaxCaracReg(4);
					}
					else
					{
						m_tabPosCarac[2] = LARGEURZONE_BIS;
						pos2Prise = true;
						datas->setNbMaxCaracReg(3);
					}
				}
				else
				{
					m_tabPosCarac[1] = LARGEURZONE_BIS;
					pos1Prise = true;
					datas->setNbMaxCaracReg(2);
				}
			}
			else
			{
				m_tabPosCarac[0] = LARGEURZONE_BIS;
				pos0Prise = true;
				datas->setNbMaxCaracReg(1);
			}
		}else
		{
			valMin3 = -1;
			valMax3 = -1;
		}

		if (m_check5)
		{
			valMin4 = m_valMin5;
			valMax4 = m_valMax5;

			datas->SetValListeDoubleAt(datas->getListeValCaracMin(),HAUTEURZONE_BIS,m_valMin5);
			datas->SetValListeDoubleAt(datas->getListeValCaracMax(),HAUTEURZONE_BIS,m_valMax5);

			if (pos0Prise)
			{
				if (pos1Prise)
				{
					if (pos2Prise)
					{
						if (pos3Prise)
						{
							m_tabPosCarac[4] = HAUTEURZONE_BIS;
							pos4Prise = true;
							datas->setNbMaxCaracReg(5);
						}
						else
						{
							m_tabPosCarac[3] = HAUTEURZONE_BIS;
							pos3Prise = true;
							datas->setNbMaxCaracReg(4);
						}
					}
					else
					{
						m_tabPosCarac[2] = HAUTEURZONE_BIS;
						pos2Prise = true;
						datas->setNbMaxCaracReg(3);
					}
				}
				else
				{
					m_tabPosCarac[1] = HAUTEURZONE_BIS;
					pos1Prise = true;
					datas->setNbMaxCaracReg(2);
				}
			}
			else
			{
				m_tabPosCarac[0] = HAUTEURZONE_BIS;
				pos0Prise = true;
				datas->setNbMaxCaracReg(1);
			}
		}else
		{
			valMin4 = -1;
			valMax4 = -1;
		}

		if (m_check6)
		{
			valMin5 = m_valMin6;
			valMax5 = m_valMax6;

			datas->SetValListeDoubleAt(datas->getListeValCaracMin(),DENSITEPIXBLANC_BIS,m_valMin6);
			datas->SetValListeDoubleAt(datas->getListeValCaracMax(),DENSITEPIXBLANC_BIS,m_valMax6);

			if (pos0Prise)
			{
				if (pos1Prise)
				{
					if (pos2Prise)
					{
						if (pos3Prise)
						{
							if (pos4Prise)
							{
								m_tabPosCarac[5] = DENSITEPIXBLANC_BIS;
								pos5Prise = true;
								datas->setNbMaxCaracReg(6);
							}
							else
							{
								m_tabPosCarac[4] = DENSITEPIXBLANC_BIS;
								pos4Prise = true;
								datas->setNbMaxCaracReg(5);
							}
						}
						else
						{
							m_tabPosCarac[3] = DENSITEPIXBLANC_BIS;
							pos3Prise = true;
							datas->setNbMaxCaracReg(4);
						}
					}
					else
					{
						m_tabPosCarac[2] = DENSITEPIXBLANC_BIS;
						pos2Prise = true;
						datas->setNbMaxCaracReg(3);
					}
				}
				else
				{
					m_tabPosCarac[1] = DENSITEPIXBLANC_BIS;
					pos1Prise = true;
					datas->setNbMaxCaracReg(2);
				}
			}
			else
			{
				m_tabPosCarac[0] = DENSITEPIXBLANC_BIS;
				pos0Prise = true;
				datas->setNbMaxCaracReg(1);
			}
		}else
		{
			valMin5 = -1;
			valMax5 = -1;
		}

		if (m_check7)
		{
			valMin6 = m_valMin7;
			valMax6 = m_valMax7;

			datas->SetValListeDoubleAt(datas->getListeValCaracMin(),DENSITENDGSURNBPIX_BIS,m_valMin7);
			datas->SetValListeDoubleAt(datas->getListeValCaracMax(),DENSITENDGSURNBPIX_BIS,m_valMax7);

			if (pos0Prise)
			{
				if (pos1Prise)
				{
					if (pos2Prise)
					{
						if (pos3Prise)
						{
							if (pos4Prise)
							{
								if (pos5Prise)
								{
									m_tabPosCarac[6] = DENSITENDGSURNBPIX_BIS;
									datas->setNbMaxCaracReg(7);
								}
								else
								{
									m_tabPosCarac[5] = DENSITENDGSURNBPIX_BIS;
									pos5Prise = true;
									datas->setNbMaxCaracReg(6);
								}
							}
							else
							{
								m_tabPosCarac[4] = DENSITENDGSURNBPIX_BIS;
								pos4Prise = true;
								datas->setNbMaxCaracReg(5);
							}
						}
						else
						{
							m_tabPosCarac[3] = DENSITENDGSURNBPIX_BIS;
							pos3Prise = true;
							datas->setNbMaxCaracReg(4);
						}
					}
					else
					{
						m_tabPosCarac[2] = DENSITENDGSURNBPIX_BIS;
						pos2Prise = true;
						datas->setNbMaxCaracReg(3);
					}
				}
				else
				{
					m_tabPosCarac[1] = DENSITENDGSURNBPIX_BIS;
					pos1Prise = true;
					datas->setNbMaxCaracReg(2);
				}
			}
			else
			{
				m_tabPosCarac[0] = DENSITENDGSURNBPIX_BIS;
				pos0Prise = true;
				datas->setNbMaxCaracReg(1);
			}
		}else
		{
			valMin6 = -1;
			valMax6 = -1;
		}
	}else
	{
		//vider m_tabPosCarac
	}
	a = new CRegleCC(etiquetteOrg,etiquetteSaisie,etiquetteOrg,valMin0,valMax0,(int)valMin1,(int)valMax1,valMin2,valMax2,(int)valMin3,(int)valMax3,(int)valMin4,(int)valMax4,valMin5,valMax5,(int)valMin6,(int)valMax6);
	datas->setTabPosETCarac(m_tabPosCarac);

	pos0Prise = false;
	pos1Prise = false;
	pos2Prise = false;
	pos3Prise = false;
	pos4Prise = false;
	pos5Prise = false;

	//regleCG
	//pour la classif geo, une seule regle est cre par type (ici : en mode non indep)
	if(m_ordreGeo != 3)
	{
		if (m_check10)
		{
			val = m_valSliderGeoG;
			b1 = new CRegleCG(etiquetteOrg,'G',(int)val,etiquetteSaisie,etiquetteOrg);
			datas->SetValListeDoubleAt(datas->getListeValGeo(),DEGREGAUCHE_BIS,(int)val);

			m_tabPosGeo[0] = DEGREGAUCHE_BIS;
			pos0Prise = true;
			datas->setNbMaxGeoReg(1);
		}

		if (m_check11)
		{
			val = m_valSliderGeoD;
			b2 = new CRegleCG(etiquetteOrg,'D',(int)val,etiquetteSaisie,etiquetteOrg);
			datas->SetValListeDoubleAt(datas->getListeValGeo(),DEGREDROITE_BIS,(int)val);

			if (pos0Prise)
			{
				m_tabPosGeo[1] = DEGREDROITE_BIS;
				pos1Prise = true;
				datas->setNbMaxGeoReg(2);
			}
			else
			{
				m_tabPosGeo[0] = DEGREDROITE_BIS;
				pos0Prise = true;
				datas->setNbMaxGeoReg(1);
			}
		}

		if (m_check12)
		{
			val = m_valSliderGeoH;
			b3 = new CRegleCG(etiquetteOrg,'H',(int)val,etiquetteSaisie,etiquetteOrg);
			datas->SetValListeDoubleAt(datas->getListeValGeo(),DEGREHAUT_BIS,(int)val);

			if (pos0Prise)
			{
				if (pos1Prise)
				{
					m_tabPosGeo[2] = DEGREHAUT_BIS;
					pos2Prise = true;
					datas->setNbMaxGeoReg(3);
				}
				else
				{
					m_tabPosGeo[1] = DEGREHAUT_BIS;
					pos1Prise = true;
					datas->setNbMaxGeoReg(2);
				}
			}
			else
			{
				m_tabPosGeo[0] = DEGREHAUT_BIS;
				pos0Prise = true;
				datas->setNbMaxGeoReg(1);
			}
		}

		if (m_check13)
		{
			val = m_valSliderGeoB;
			b4 = new CRegleCG(etiquetteOrg,'B',(int)val,etiquetteSaisie,etiquetteOrg);
			datas->SetValListeDoubleAt(datas->getListeValGeo(),DEGREBAS_BIS,(int)val);

			if (pos0Prise)
			{
				if (pos1Prise)
				{
					if (pos2Prise)
					{
						m_tabPosGeo[3] = DEGREBAS_BIS;
						pos3Prise = true;
						datas->setNbMaxGeoReg(4);
					}
					else
					{
						m_tabPosGeo[2] = DEGREBAS_BIS;
						pos2Prise = true;
						datas->setNbMaxGeoReg(3);
					}
				}
				else
				{
					m_tabPosGeo[1] = DEGREBAS_BIS;
					pos1Prise = true;
					datas->setNbMaxGeoReg(2);
				}
			}
			else
			{
				m_tabPosGeo[0] = DEGREBAS_BIS;
				pos0Prise = true;
				datas->setNbMaxGeoReg(1);
			}
		}

		if (m_check14)
		{
			val = m_valSliderGeoC;
			b5 = new CRegleCG(etiquetteOrg,'C',(int)val,etiquetteSaisie,etiquetteOrg);
			datas->SetValListeDoubleAt(datas->getListeValGeo(),DEGRECENTREP_BIS,(int)val);

			if (pos0Prise)
			{
				if (pos1Prise)
				{
					if (pos2Prise)
					{
						if (pos3Prise)
						{
							m_tabPosGeo[4] = DEGRECENTREP_BIS;
							pos4Prise = true;
							datas->setNbMaxGeoReg(5);
						}
						else
						{
							m_tabPosGeo[3] = DEGRECENTREP_BIS;
							pos3Prise = true;
							datas->setNbMaxGeoReg(4);
						}
					}
					else
					{
						m_tabPosGeo[2] = DEGRECENTREP_BIS;
						pos2Prise = true;
						datas->setNbMaxGeoReg(3);
					}
				}
				else
				{
					m_tabPosGeo[1] = DEGRECENTREP_BIS;
					pos1Prise = true;
					datas->setNbMaxGeoReg(2);
				}
			}
			else
			{
				m_tabPosGeo[0] = DEGRECENTREP_BIS;
				pos0Prise = true;
				datas->setNbMaxGeoReg(1);
			}
		}

		if (m_check15)
		{
			val = m_valSliderGeoO;
			b6 = new CRegleCG(etiquetteOrg,'O',(int)val,etiquetteSaisie,etiquetteOrg);
			datas->SetValListeDoubleAt(datas->getListeValGeo(),DEGRECENTREL_BIS,(int)val);

			if (pos0Prise)
			{
				if (pos1Prise)
				{
					if (pos2Prise)
					{
						if (pos3Prise)
						{
							if (pos4Prise)
							{
								m_tabPosGeo[5] = DEGRECENTREL_BIS;
								pos5Prise = true;
								datas->setNbMaxGeoReg(6);
							}
							else
							{
								m_tabPosGeo[4] = DEGRECENTREL_BIS;
								pos4Prise = true;
								datas->setNbMaxGeoReg(5);
							}
						}
						else
						{
							m_tabPosGeo[3] = DEGRECENTREL_BIS;
							pos3Prise = true;
							datas->setNbMaxGeoReg(4);
						}
					}
					else
					{
						m_tabPosGeo[2] = DEGRECENTREL_BIS;
						pos2Prise = true;
						datas->setNbMaxGeoReg(3);
					}
				}
				else
				{
					m_tabPosGeo[1] = DEGRECENTREL_BIS;
					pos1Prise = true;
					datas->setNbMaxGeoReg(2);
				}
			}
			else
			{
				m_tabPosGeo[0] = DEGRECENTREL_BIS;
				pos0Prise = true;
				datas->setNbMaxGeoReg(1);
			}
		}

		if (m_check16)
		{
			val = m_valSliderGeoE;
			b7 = new CRegleCG(etiquetteOrg,'E',(int)val,etiquetteSaisie,etiquetteOrg);
			datas->SetValListeDoubleAt(datas->getListeValGeo(),DEGRECENTREH_BIS,(int)val);

			if (pos0Prise)
			{
				if (pos1Prise)
				{
					if (pos2Prise)
					{
						if (pos3Prise)
						{
							if (pos4Prise)
							{
								if (pos5Prise)
								{
									m_tabPosGeo[6] = DEGRECENTREH_BIS;
									datas->setNbMaxGeoReg(7);
								}
								else
								{
									m_tabPosGeo[5] = DEGRECENTREH_BIS;
									pos5Prise = true;
									datas->setNbMaxGeoReg(6);
								}
							}
							else
							{
								m_tabPosGeo[4] = DEGRECENTREH_BIS;
								pos4Prise = true;
								datas->setNbMaxGeoReg(5);
							}
						}
						else
						{
							m_tabPosGeo[3] = DEGRECENTREH_BIS;
							pos3Prise = true;
							datas->setNbMaxGeoReg(4);
						}
					}
					else
					{
						m_tabPosGeo[2] = DEGRECENTREH_BIS;
						pos2Prise = true;
						datas->setNbMaxGeoReg(3);
					}
				}
				else
				{
					m_tabPosGeo[1] = DEGRECENTREH_BIS;
					pos1Prise = true;
					datas->setNbMaxGeoReg(2);
				}
			}
			else
			{
				m_tabPosGeo[0] = DEGRECENTREH_BIS;
				pos0Prise = true;
				datas->setNbMaxGeoReg(1);
			}
		}
	}
	datas->setTabPosETGeo(m_tabPosGeo);

	pos0Prise = false;
	pos1Prise = false;
	pos2Prise = false;
	pos3Prise = false;
	pos4Prise = false;

	//regleCV
	if(m_ordreVois != 3)
	{
		for (i=0;i<listeh->GetSelCount();i++) 
		{
			CString t;
			listeh->GetText(liste_voisins_haut[i],t);
			listeVH->AddTail(t);

			datas->SetValListeCTypeClasseAt(datas->getListeValVois(),VOISINHAUT_BIS,t);
		
		}

		for (i=0;i<listeg->GetSelCount();i++) 
		{
			CString t;
			listeg->GetText(liste_voisins_gauche[i],t);
			listeVG->AddTail(t);
			
			datas->SetValListeCTypeClasseAt(datas->getListeValVois(),VOISINGAUCHE_BIS,t);
			
		}

		for (i=0;i<listeb->GetSelCount();i++) 
		{
			CString t;
			listeb->GetText(liste_voisins_bas[i],t);
			listeVB->AddTail(t);

			datas->SetValListeCTypeClasseAt(datas->getListeValVois(),VOISINBAS_BIS,t);
		
		}
		
		for (i=0;i<listed->GetSelCount();i++) 
		{
			CString t;
			listed->GetText(liste_voisins_droite[i],t);
			listeVD->AddTail(t);

			datas->SetValListeCTypeClasseAt(datas->getListeValVois(),VOISINDROITE_BIS,t);
		
		}
		
		for (i=0;i<listei->GetSelCount();i++) 
		{
			CString t;
			listei->GetText(liste_voisins_inclus[i],t);
			listeVI->AddTail(t);

			datas->SetValListeCTypeClasseAt(datas->getListeValVois(),VOISININCLUSDANS_BIS,t);
		
		}
	}

	if (m_check17)
	{
		m_tabPosVois[0] = VOISINHAUT_BIS;
		pos0Prise = true;
		datas->setNbMaxVoisReg(1);
	}

	if (m_check18)
	{
		if (pos0Prise)
		{
			m_tabPosVois[1] = VOISINGAUCHE_BIS;
			pos1Prise = true;
			datas->setNbMaxVoisReg(2);
		}
		else
		{
			m_tabPosVois[0] = VOISINGAUCHE_BIS;
			pos0Prise = true;
			datas->setNbMaxVoisReg(1);
		}
	}

	if (m_check19)
	{
		if (pos0Prise)
		{
			if (pos1Prise)
			{
				m_tabPosVois[2] = VOISINBAS_BIS;
				pos2Prise = true;
				datas->setNbMaxVoisReg(3);
			}
			else
			{
				m_tabPosVois[1] = VOISINBAS_BIS;
				pos1Prise = true;
				datas->setNbMaxVoisReg(2);
			}
		}
		else
		{
			m_tabPosVois[0] = VOISINBAS_BIS;
			pos0Prise = true;
			datas->setNbMaxVoisReg(1);
		}
	}

	if (m_check20)
	{
		if (pos0Prise)
		{
			if (pos1Prise)
			{
				if (pos2Prise)
				{
					m_tabPosVois[3] = VOISINDROITE_BIS;
					pos3Prise = true;
					datas->setNbMaxVoisReg(4);
				}
				else
				{
					m_tabPosVois[2] = VOISINDROITE_BIS;
					pos2Prise = true;
					datas->setNbMaxVoisReg(3);
				}
			}
			else
			{
				m_tabPosVois[1] = VOISINDROITE_BIS;
				pos1Prise = true;
				datas->setNbMaxVoisReg(2);
			}
		}
		else
		{
			m_tabPosVois[0] = VOISINDROITE_BIS;
			pos0Prise = true;
			datas->setNbMaxVoisReg(1);
		}
	}

	if (m_check21)
	{
		if (pos0Prise)
		{
			if (pos1Prise)
			{
				if (pos2Prise)
				{
					if (pos3Prise)
					{
						m_tabPosVois[4] = VOISININCLUSDANS_BIS;
						pos4Prise = true;
						datas->setNbMaxVoisReg(5);
					}
					else
					{
						m_tabPosVois[3] = VOISININCLUSDANS_BIS;
						pos3Prise = true;
						datas->setNbMaxVoisReg(4);
					}
				}
				else
				{
					m_tabPosVois[2] = VOISININCLUSDANS_BIS;
					pos2Prise = true;
					datas->setNbMaxVoisReg(3);
				}
			}
			else
			{
				m_tabPosVois[1] = VOISININCLUSDANS_BIS;
				pos1Prise = true;
				datas->setNbMaxVoisReg(2);
			}
		}
		else
		{
			m_tabPosVois[0] = VOISININCLUSDANS_BIS;
			pos0Prise = true;
			datas->setNbMaxVoisReg(1);
		}
	}
		
	c = new CRegleCV(etiquetteOrg,listeVG,listeVD,listeVH,listeVB,listeVI,etiquetteSaisie,etiquetteOrg);
	datas->setTabPosETVois(m_tabPosVois);

	//ajouter les regles au scenario selon l'ordre slectionn
	switch (m_ordreCarac)
	{
	case 0:
		datas->getScenarAuto()->Ajouter(a);
		datas->getScenarAuto()->Ajouter(r);

		m_tabPosGlobal[0] = REGCARAC_BIS;
		datas->setNbMaxGlobalRegNonIndep(1);

		if (m_ordreGeo == 1)
		{
			if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
			if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
			if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
			if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
			if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
			if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
			if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

			m_tabPosGlobal[1] = REGGEO_BIS;
			datas->setNbMaxGlobalRegNonIndep(2);

			if (m_ordreVois == 2)
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);
				m_tabPosGlobal[2] = REGVOIS_BIS;
				datas->setNbMaxGlobalRegNonIndep(3);
			}
		}
		if (m_ordreGeo == 2)
		{
			if (m_ordreVois == 1)
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);
				
				if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
				if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
				if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
				if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
				if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
				if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
				if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

				m_tabPosGlobal[1] = REGVOIS_BIS;
				m_tabPosGlobal[2] = REGGEO_BIS;
				datas->setNbMaxGlobalRegNonIndep(3);
			}
			if (m_ordreVois == 3)
			{
				if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
				if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
				if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
				if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
				if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
				if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
				if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

				m_tabPosGlobal[1] = REGGEO_BIS;
				datas->setNbMaxGlobalRegNonIndep(2);
			}
		}
		if (m_ordreGeo == 3)
		{
			if ((m_ordreVois == 1) || (m_ordreVois == 2))
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);
				m_tabPosGlobal[1] = REGVOIS_BIS;
				datas->setNbMaxGlobalRegNonIndep(2);
			}
		}
		break;
	case 1:
		if (m_ordreGeo == 0)
		{
			if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
			if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
			if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
			if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
			if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
			if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
			if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

			datas->getScenarAuto()->Ajouter(a);
			datas->getScenarAuto()->Ajouter(r);

			m_tabPosGlobal[0] = REGGEO_BIS;
			m_tabPosGlobal[1] = REGCARAC_BIS;
			datas->setNbMaxGlobalRegNonIndep(2);

			if (m_ordreVois == 2)
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);
				m_tabPosGlobal[2] = REGVOIS_BIS;
				datas->setNbMaxGlobalRegNonIndep(3);
			}
		}
		if (m_ordreGeo == 2)
		{
			if (m_ordreVois == 0)
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);
			
				datas->getScenarAuto()->Ajouter(a);
				datas->getScenarAuto()->Ajouter(r);

				if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
				if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
				if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
				if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
				if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
				if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
				if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

				m_tabPosGlobal[0] = REGVOIS_BIS;
				m_tabPosGlobal[1] = REGCARAC_BIS;
				m_tabPosGlobal[2] = REGGEO_BIS;
				datas->setNbMaxGlobalRegNonIndep(3);
			}
			if (m_ordreVois == 3)
			{
				datas->getScenarAuto()->Ajouter(a);
				datas->getScenarAuto()->Ajouter(r);
				
				if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
				if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
				if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
				if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
				if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
				if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
				if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

				m_tabPosGlobal[0] = REGCARAC_BIS;
				m_tabPosGlobal[1] = REGGEO_BIS;
				datas->setNbMaxGlobalRegNonIndep(2);
			}
		}
		if (m_ordreGeo == 3)
		{
			if (m_ordreVois == 0)
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);
				m_tabPosGlobal[0] = REGVOIS_BIS;
				m_tabPosGlobal[1] = REGCARAC_BIS;
				datas->setNbMaxGlobalRegNonIndep(2);
			}
			datas->getScenarAuto()->Ajouter(a);
			datas->getScenarAuto()->Ajouter(r);
			
			if (m_ordreVois == 2)
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);
				m_tabPosGlobal[0] = REGCARAC_BIS;
				m_tabPosGlobal[1] = REGVOIS_BIS;
				datas->setNbMaxGlobalRegNonIndep(2);
			}

			if (m_ordreVois == 3)
			{
				m_tabPosGlobal[0] = REGCARAC_BIS;
				datas->setNbMaxGlobalRegNonIndep(1);
			}
		}
		break;
	case 2:
		if (m_ordreGeo == 0)
		{
			if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
			if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
			if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
			if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
			if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
			if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
			if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

			m_tabPosGlobal[0] = REGGEO_BIS;
			datas->setNbMaxGlobalRegNonIndep(1);

			if (m_ordreVois == 1)
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);
			
				datas->getScenarAuto()->Ajouter(a);
				datas->getScenarAuto()->Ajouter(r);

				m_tabPosGlobal[1] = REGVOIS_BIS;
				m_tabPosGlobal[2] = REGCARAC_BIS;
				datas->setNbMaxGlobalRegNonIndep(3);
			}
			if (m_ordreVois == 3)
			{
				datas->getScenarAuto()->Ajouter(a);
				datas->getScenarAuto()->Ajouter(r);

				m_tabPosGlobal[1] = REGCARAC_BIS;
				datas->setNbMaxGlobalRegNonIndep(2);
			}
		}
		if (m_ordreGeo == 1)
		{
			if (m_ordreVois == 0)
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);

				if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
				if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
				if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
				if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
				if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
				if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
				if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

				datas->getScenarAuto()->Ajouter(a);
				datas->getScenarAuto()->Ajouter(r);

				m_tabPosGlobal[0] = REGVOIS_BIS;
				m_tabPosGlobal[1] = REGGEO_BIS;
				m_tabPosGlobal[2] = REGCARAC_BIS;
				datas->setNbMaxGlobalRegNonIndep(3);
			}
			if (m_ordreVois == 3)
			{
				if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
				if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
				if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
				if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
				if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
				if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
				if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

				datas->getScenarAuto()->Ajouter(a);
				datas->getScenarAuto()->Ajouter(r);

				m_tabPosGlobal[0] = REGGEO_BIS;
				m_tabPosGlobal[1] = REGCARAC_BIS;
				datas->setNbMaxGlobalRegNonIndep(2);
			}
		}
		if (m_ordreGeo == 3)
		{
			if ((m_ordreVois == 0) || (m_ordreVois == 1))
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);
			
				datas->getScenarAuto()->Ajouter(a);
				datas->getScenarAuto()->Ajouter(r);

				m_tabPosGlobal[0] = REGVOIS_BIS;
				m_tabPosGlobal[1] = REGCARAC_BIS;
				datas->setNbMaxGlobalRegNonIndep(2);
			}
			if (m_ordreVois == 3)
			{
				datas->getScenarAuto()->Ajouter(a);
				datas->getScenarAuto()->Ajouter(r);

				m_tabPosGlobal[0] = REGCARAC_BIS;
				datas->setNbMaxGlobalRegNonIndep(1);
			}
		}
		break;
	case 3:
		if (m_ordreGeo == 0)
		{
			if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
			if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
			if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
			if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
			if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
			if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
			if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

			m_tabPosGlobal[0] = REGGEO_BIS;
			datas->setNbMaxGlobalRegNonIndep(1);

			if (m_ordreVois == 1)
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);

				m_tabPosGlobal[1] = REGVOIS_BIS;
				datas->setNbMaxGlobalRegNonIndep(2);
			}
		}
		if (m_ordreGeo == 1)
		{
			if (m_ordreVois == 0)
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);
			
				if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
				if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
				if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
				if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
				if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
				if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
				if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

				m_tabPosGlobal[0] = REGVOIS_BIS;
				m_tabPosGlobal[1] = REGGEO_BIS;
				datas->setNbMaxGlobalRegNonIndep(2);
			}
			if (m_ordreVois == 3)
			{
				if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
				if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
				if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
				if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
				if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
				if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
				if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

				m_tabPosGlobal[0] = REGGEO_BIS;
				datas->setNbMaxGlobalRegNonIndep(1);
			}
		}
		if (m_ordreGeo == 2)
		{
			if ((m_ordreVois == 0) || (m_ordreVois == 1))
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);
			
				if (m_check10) { datas->getScenarAuto()->Ajouter(b1); datas->getScenarAuto()->Ajouter(r);}
				if (m_check11) { datas->getScenarAuto()->Ajouter(b2); datas->getScenarAuto()->Ajouter(r);}
				if (m_check12) { datas->getScenarAuto()->Ajouter(b3); datas->getScenarAuto()->Ajouter(r);}
				if (m_check13) { datas->getScenarAuto()->Ajouter(b4); datas->getScenarAuto()->Ajouter(r);}
				if (m_check14) { datas->getScenarAuto()->Ajouter(b5); datas->getScenarAuto()->Ajouter(r);}
				if (m_check15) { datas->getScenarAuto()->Ajouter(b6); datas->getScenarAuto()->Ajouter(r);}
				if (m_check16) { datas->getScenarAuto()->Ajouter(b7); datas->getScenarAuto()->Ajouter(r);}

				m_tabPosGlobal[0] = REGVOIS_BIS;
				m_tabPosGlobal[1] = REGGEO_BIS;
				datas->setNbMaxGlobalRegNonIndep(2);
			}
		}
		if (m_ordreGeo == 3)
		{
			if ((m_ordreVois == 0) || (m_ordreVois == 1) || (m_ordreVois == 2))
			{
				datas->getScenarAuto()->Ajouter(c);
				datas->getScenarAuto()->Ajouter(r);

				m_tabPosGlobal[0] = REGVOIS_BIS;
				datas->setNbMaxGlobalRegNonIndep(1);
			}
		}
		break;
	}

	datas->setTabPosETGlobalNonIndep(m_tabPosGlobal);

	OnOK();
}

void CDialogClassifAuto::InitPartMode()
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();

	//changer le texte de type
	SetDlgItemText(IDC_STATIC_TYPE_GLOBAL,datas->getTypeDest());

	//charger la liste des types Org
	CComboBox *combo=(CComboBox *)GetDlgItem(IDC_LISTE_TYPES_ORG);
	CObList * liste;
	liste = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
	POSITION pos = liste->GetHeadPosition();
	int i=0;
	while (pos)
	{
		CTypeClasse *tp = (CTypeClasse *)liste->GetNext(pos);
		combo->InsertString(i,tp->getNomClasse());
		i++;
	}

	//slectionner le type Org synthetis
	combo->SelectString(0,datas->getTypeOrg());
	m_editTypeOrg = datas->getTypeOrg();
}

void CDialogClassifAuto::InitPartCarac()
{
	m_radioCaracMoy = datas->isValsMoyCarac();
	m_valSliderCaracEcart = datas->getPourcentageCaracMoy();
	m_valSliderCaracReg = datas->getTolCaracReg();

	m_initCaracTol = datas->getTolCaracReg();
	m_initCaracEcart = datas->getPourcentageCaracMoy();
	

	RemplirCasesMinCarac();
	RemplirCasesMaxCarac();

	CocherReglesCarac(true);

	((CButton*)GetDlgItem(IDC_RADIO_CARAC_MOY))->SetCheck(m_radioCaracMoy);

	//slider de la tolrance des EcartTypes de Carac
	CSliderCtrl *sliderCaracReg = (CSliderCtrl *)GetDlgItem(IDC_SLIDER8);
	sliderCaracReg->EnableWindow(m_radioNonIndep);
	sliderCaracReg->SetRange(0,50,true);
	sliderCaracReg->SetTicFreq(5);
	sliderCaracReg->SetPos(m_valSliderCaracReg);

	//slider des carts  la moyenne ou mdiane
	CSliderCtrl *sliderCaracTol = (CSliderCtrl *)GetDlgItem(IDC_SLIDER9);
	sliderCaracTol->EnableWindow(true);
	sliderCaracTol->SetRange(0,50,true);
	sliderCaracTol->SetTicFreq(5);
	sliderCaracTol->SetPos(m_valSliderCaracEcart);
}

void CDialogClassifAuto::InitPartGeo()
{
	m_radioGeoMoy = datas->isValsMoyGeo();

	RemplirCasesGeo();

	CocherReglesGeo(true);

	((CButton*)GetDlgItem(IDC_RADIO_GEO_MOY))->SetCheck(m_radioGeoMoy);

	//slider de position gauche
	CSliderCtrl *sliderGeoG = (CSliderCtrl *)GetDlgItem(IDC_SLIDER10);
	sliderGeoG->EnableWindow(true);
	sliderGeoG->SetRange(0,50,true);
	sliderGeoG->SetTicFreq(5);
	sliderGeoG->SetPos(m_valSliderGeoG);

	//slider de position droite
	CSliderCtrl *sliderGeoD = (CSliderCtrl *)GetDlgItem(IDC_SLIDER11);
	sliderGeoD->EnableWindow(true);
	sliderGeoD->SetRange(0,50,true);
	sliderGeoD->SetTicFreq(5);
	sliderGeoD->SetPos(m_valSliderGeoD);

	//slider de position haut
	CSliderCtrl *sliderGeoH = (CSliderCtrl *)GetDlgItem(IDC_SLIDER12);
	sliderGeoH->EnableWindow(true);
	sliderGeoH->SetRange(0,50,true);
	sliderGeoH->SetTicFreq(5);
	sliderGeoH->SetPos(m_valSliderGeoH);

	//slider de position bas
	CSliderCtrl *sliderGeoB = (CSliderCtrl *)GetDlgItem(IDC_SLIDER13);
	sliderGeoB->EnableWindow(true);
	sliderGeoB->SetRange(0,50,true);
	sliderGeoB->SetTicFreq(5);
	sliderGeoB->SetPos(m_valSliderGeoB);

	//slider de position centre de la page
	CSliderCtrl *sliderGeoC = (CSliderCtrl *)GetDlgItem(IDC_SLIDER14);
	sliderGeoC->EnableWindow(true);
	sliderGeoC->SetRange(0,50,true);
	sliderGeoC->SetTicFreq(5);
	sliderGeoC->SetPos(m_valSliderGeoC);

	//slider de position centre de la largeur
	CSliderCtrl *sliderGeoO = (CSliderCtrl *)GetDlgItem(IDC_SLIDER15);
	sliderGeoO->EnableWindow(true);
	sliderGeoO->SetRange(0,50,true);
	sliderGeoO->SetTicFreq(5);
	sliderGeoO->SetPos(m_valSliderGeoO);

	//slider de position centre de la hauteur
	CSliderCtrl *sliderGeoE = (CSliderCtrl *)GetDlgItem(IDC_SLIDER16);
	sliderGeoE->EnableWindow(true);
	sliderGeoE->SetRange(0,50,true);
	sliderGeoE->SetTicFreq(5);
	sliderGeoE->SetPos(m_valSliderGeoE);
}

void CDialogClassifAuto::InitPartVois()
{
	m_valSliderVoisReg = datas->getTolVoisReg();

	m_initVoisTol = datas->getTolVoisReg();

	CocherReglesVois(true);

	RemplirCasesVois();

	//slider de la tolrance des EcartTypes de Vois
	CSliderCtrl *sliderVoisReg = (CSliderCtrl *)GetDlgItem(IDC_SLIDER22);
	sliderVoisReg->EnableWindow(m_radioNonIndep);
	sliderVoisReg->SetRange(0,50,true);
	sliderVoisReg->SetTicFreq(5);
	sliderVoisReg->SetPos(m_valSliderVoisReg);
}

void CDialogClassifAuto::InitPartOrdre()
{
	//cocher les bonnes radio
	CocherRadiosOrdre();
}

void CDialogClassifAuto::RemplirCasesMinCarac()
{
	int i = 0;
	POSITION pos = datas->getListeValCaracMin()->GetHeadPosition();
	while (pos)
	{
		switch (i)
		{
		case RAPPORTLSURH_BIS :
			m_valMin1 = datas->getListeValCaracMin()->GetNext(pos);
			break;
		case NBELEMENTS_BIS :
			m_valMin2 = (int)datas->getListeValCaracMin()->GetNext(pos);
			break;
		case RAPPORTHSURHMOYCC_BIS :
			m_valMin3 = datas->getListeValCaracMin()->GetNext(pos);
			break;
		case LARGEURZONE_BIS :
			m_valMin4 = (int)datas->getListeValCaracMin()->GetNext(pos);
			break;
		case HAUTEURZONE_BIS :
			m_valMin5 = (int)datas->getListeValCaracMin()->GetNext(pos);
			break;
		case DENSITEPIXBLANC_BIS :
			m_valMin6 = datas->getListeValCaracMin()->GetNext(pos);
			break;
		case DENSITENDGSURNBPIX_BIS :
			m_valMin7 = (int)datas->getListeValCaracMin()->GetNext(pos);
			break;
		default :
			break;
		}
		i++;
	}
}

void CDialogClassifAuto::RemplirCasesMaxCarac()
{
	int i = 0;
	POSITION pos = datas->getListeValCaracMax()->GetHeadPosition();
	while (pos)
	{
		switch (i)
		{
		case RAPPORTLSURH_BIS :
			m_valMax1 = datas->getListeValCaracMax()->GetNext(pos);
			break;
		case NBELEMENTS_BIS :
			m_valMax2 = (int)datas->getListeValCaracMax()->GetNext(pos);
			break;
		case RAPPORTHSURHMOYCC_BIS :
			m_valMax3 = datas->getListeValCaracMax()->GetNext(pos);
			break;
		case LARGEURZONE_BIS :
			m_valMax4 = (int)datas->getListeValCaracMax()->GetNext(pos);
			break;
		case HAUTEURZONE_BIS :
			m_valMax5 = (int)datas->getListeValCaracMax()->GetNext(pos);
			break;
		case DENSITEPIXBLANC_BIS :
			m_valMax6 = datas->getListeValCaracMax()->GetNext(pos);
			break;
		case DENSITENDGSURNBPIX_BIS :
			m_valMax7 = (int)datas->getListeValCaracMax()->GetNext(pos);
			break;
		default :
			break;
		}
		i++;
	}
}

void CDialogClassifAuto::RemplirCasesGeo()
{
	int i = 0;
	POSITION pos = datas->getListeValGeo()->GetHeadPosition();
	while (pos)
	{
		switch (i)
		{
		case DEGREGAUCHE_BIS :
			m_valSliderGeoG = (int)datas->getListeValGeo()->GetNext(pos);
			//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
			//if (m_valSliderGeoG != 0) m_valSliderGeoG += 1; 
			//NON car effectu dans ClassifAutoDonnees (CalculValsGeo())
			break;
		case DEGREDROITE_BIS :
			m_valSliderGeoD = (int)datas->getListeValGeo()->GetNext(pos);
			//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
			//if (m_valSliderGeoD != 0) m_valSliderGeoD += 1; 
			//NON car effectu dans ClassifAutoDonnees (CalculValsGeo())
			break;
		case DEGREHAUT_BIS :
			m_valSliderGeoH = (int)datas->getListeValGeo()->GetNext(pos);
			//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
			//if (m_valSliderGeoH != 0) m_valSliderGeoH += 1; 
			//NON car effectu dans ClassifAutoDonnees (CalculValsGeo())
			break;
		case DEGREBAS_BIS :
			m_valSliderGeoB = (int)datas->getListeValGeo()->GetNext(pos);
			//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
			//if (m_valSliderGeoB != 0) m_valSliderGeoB += 1; 
			//NON car effectu dans ClassifAutoDonnees (CalculValsGeo())
			break;
		case DEGRECENTREP_BIS :
			m_valSliderGeoC = (int)datas->getListeValGeo()->GetNext(pos);
			//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
			//if (m_valSliderGeoC != 0) m_valSliderGeoC += 1; 
			//NON car effectu dans ClassifAutoDonnees (CalculValsGeo())
			break;
		case DEGRECENTREL_BIS :
			m_valSliderGeoO = (int)datas->getListeValGeo()->GetNext(pos);
			//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
			//if (m_valSliderGeoO != 0) m_valSliderGeoO += 1; 
			//NON car effectu dans ClassifAutoDonnees (CalculValsGeo())
			break;
		case DEGRECENTREH_BIS :
			m_valSliderGeoE = (int)datas->getListeValGeo()->GetNext(pos);
			//on ajoute 1% car sinon, a cause des arrondis dans les calculs, la carac ne serait aps prise en compte
			//if (m_valSliderGeoE != 0) m_valSliderGeoE += 1; 
			//NON car effectu dans ClassifAutoDonnees (CalculValsGeo())
			break;
		default :
			break;
		}
		i++;
	}
}

void CDialogClassifAuto::RemplirCasesVois()
{
	CListBox *listeh=(CListBox *)GetDlgItem(IDC_LISTEH);
	CListBox *listeg=(CListBox *)GetDlgItem(IDC_LISTEG);
	CListBox *listeb=(CListBox *)GetDlgItem(IDC_LISTEB);
	CListBox *listed=(CListBox *)GetDlgItem(IDC_LISTED);
	CListBox *listei=(CListBox *)GetDlgItem(IDC_LISTEI);

	listeh->ResetContent();
	listeg->ResetContent();
	listeb->ResetContent();
	listed->ResetContent();
	listei->ResetContent();
	
	int i=0;
	POSITION pos = datas->getListeValVois()->GetHeadPosition();
	while (pos)
	{
		CTypeClasse *clTemp = (CTypeClasse*)datas->getListeValVois()->GetNext(pos);
		switch (i)
		{
		case VOISINHAUT_BIS :
			if (clTemp != NULL) 
				listeh->InsertString(listeh->GetCount(),clTemp->getNomClasse());
			break;
		case VOISINGAUCHE_BIS :
			if (clTemp != NULL) 
				listeg->InsertString(listeg->GetCount(),clTemp->getNomClasse());
			break;
		case VOISINBAS_BIS :
			if (clTemp != NULL) 
				listeb->InsertString(listeb->GetCount(),clTemp->getNomClasse());
			break;
		case VOISINDROITE_BIS :
			if (clTemp != NULL) 
				listed->InsertString(listed->GetCount(),clTemp->getNomClasse());
			break;
		case VOISININCLUSDANS_BIS :
			if (clTemp != NULL) 
				listei->InsertString(listei->GetCount(),clTemp->getNomClasse());
			break;
		default :
			break;
		}
		i++;
	}
	listeh->InsertString(listeh->GetCount(),"RIEN");
	listeg->InsertString(listeg->GetCount(),"RIEN");
	listeb->InsertString(listeb->GetCount(),"RIEN");
	listed->InsertString(listed->GetCount(),"RIEN");
	listei->InsertString(listei->GetCount(),"RIEN");

	if (m_check17) listeh->SetSel(0);
	if (m_check18) listeg->SetSel(0);
	if (m_check19) listeb->SetSel(0);
	if (m_check20) listed->SetSel(0);
	if (m_check21) listei->SetSel(0);
}

void CDialogClassifAuto::CocherReglesCarac(bool active)
{
	int *tabPosCarac;
	tabPosCarac = datas->getTabPosETCarac();

	m_check1 = false;
	m_check2 = false;
	m_check3 = false;
	m_check4 = false;
	m_check5 = false;
	m_check6 = false;
	m_check7 = false;

	if (active)
	{
		int numReg = 0;
		for (int i=0 ; i<datas->getNbMaxCaracReg() ; i++)
		{
			numReg = tabPosCarac[i];
			switch (numReg)
			{
			case RAPPORTLSURH_BIS :
				m_check1 = true;
				break;
			case NBELEMENTS_BIS :
				m_check2 = true;
				break;
			case RAPPORTHSURHMOYCC_BIS :
				m_check3 = true;
				break;
			case LARGEURZONE_BIS :
				m_check4 = true;
				break;
			case HAUTEURZONE_BIS :
				m_check5 = true;
				break;
			case DENSITEPIXBLANC_BIS :
				m_check6 = true;
				break;
			case DENSITENDGSURNBPIX_BIS :
				m_check7 = true;
				break;
			default :
				break;
			}
		}
	}
}

void CDialogClassifAuto::CocherReglesGeo(bool active)
{
	int *tabPosGeo;
	tabPosGeo = datas->getTabPosETGeo();

	m_check10 = false;
	m_check11 = false;
	m_check12 = false;
	m_check13 = false;
	m_check14 = false;
	m_check15 = false;
	m_check16 = false;

	if (active)
	{
		int numReg = 0;
		for (int i=0 ; i<datas->getNbMaxGeoReg() ; i++)
		{
			numReg = tabPosGeo[i];
			switch (numReg)
			{
			case DEGREGAUCHE_BIS :
				m_check10 = true;
				break;
			case DEGREDROITE_BIS :
				m_check11 = true;
				break;
			case DEGREHAUT_BIS :
				m_check12 = true;
				break;
			case DEGREBAS_BIS :
				m_check13 = true;
				break;
			case DEGRECENTREP_BIS :
				m_check14 = true;
				break;
			case DEGRECENTREL_BIS :
				m_check15 = true;
				break;
			case DEGRECENTREH_BIS :
				m_check16 = true;
				break;
			default :
				break;
			}
		}
	}
}

void CDialogClassifAuto::CocherReglesVois(bool active)
{
	int *tabPosVois;
	tabPosVois = datas->getTabPosETVois();

	m_check17 = false;
	m_check18 = false;
	m_check19 = false;
	m_check20 = false;
	m_check21 = false;

	if (active)
	{
		int numReg = 0;
		for (int i=0 ; i<datas->getNbMaxVoisReg() ; i++)
		{
			numReg = tabPosVois[i];
			switch (numReg)
			{
			case VOISINHAUT_BIS :
				m_check17 = true;
				break;
			case VOISINGAUCHE_BIS :
				m_check18 = true;
				break;
			case VOISINBAS_BIS :
				m_check19 = true;
				break;
			case VOISINDROITE_BIS :
				m_check20 = true;
				break;
			case VOISININCLUSDANS_BIS :
				m_check21 = true;
				break;
			default :
				break;
			}
		}
	}
}

void CDialogClassifAuto::CocherReglesGlobal()
{
	if (m_ordreCarac == 3) CocherReglesCarac(false);
	else CocherReglesCarac(true);
	MajPartCarac();

	if (m_ordreGeo == 3) CocherReglesGeo(false);
	else CocherReglesGeo(true);
	MajPartGeo();

	if (m_ordreVois == 3) CocherReglesVois(false);
	else CocherReglesVois(true);
	MajPartVois();
}

void CDialogClassifAuto::CocherRadiosOrdre()
{
	int max = datas->getNbMaxGlobalRegNonIndep();
	int pos = -1;
	for (int i=0; i<max ; i++)
	{
		pos = datas->getTabPosETGlobalNonIndep()[i];
		switch (pos)
		{
		case REGCARAC_BIS : 
			if (i==0) m_ordreCarac = 0;
			if (i==1) m_ordreCarac = 1;
			if (i==2) m_ordreCarac = 2;
			break;
		case REGGEO_BIS : 
			if (i==0) m_ordreGeo = 0;
			if (i==1) m_ordreGeo = 1;
			if (i==2) m_ordreGeo = 2;
			break;
		case REGVOIS_BIS : 
			if (i==0) m_ordreVois = 0;
			if (i==1) m_ordreVois = 1;
			if (i==2) m_ordreVois = 2;
			break;
		}
	}
}

void CDialogClassifAuto::MajPartMode()
{
	
}

void CDialogClassifAuto::MajPartCarac()
{
	//slider de la tolrance des EcartTypes de Carac
	CSliderCtrl *sliderCaracReg = (CSliderCtrl *)GetDlgItem(IDC_SLIDER8);
	sliderCaracReg->EnableWindow(true);

	//valMin et valMax de L/H
	CEdit *eMin1 = (CEdit *)GetDlgItem(IDC_MIN1);
	CEdit *eMax1 = (CEdit *)GetDlgItem(IDC_MAX1);
	eMin1->EnableWindow(m_check1);
	eMax1->EnableWindow(m_check1);
	((CButton*)GetDlgItem(IDC_CHECK1))->SetCheck(m_check1);

	//valMin et valMax de Nbre elements
	CEdit *eMin2 = (CEdit *)GetDlgItem(IDC_MIN2);
	CEdit *eMax2 = (CEdit *)GetDlgItem(IDC_MAX2);
	eMin2->EnableWindow(m_check2);
	eMax2->EnableWindow(m_check2);
	((CButton*)GetDlgItem(IDC_CHECK2))->SetCheck(m_check2);

	//valMin et valMax de H/HmoyCC
	CEdit *eMin3 = (CEdit *)GetDlgItem(IDC_MIN3);
	CEdit *eMax3 = (CEdit *)GetDlgItem(IDC_MAX3);
	eMin3->EnableWindow(m_check3);
	eMax3->EnableWindow(m_check3);
	((CButton*)GetDlgItem(IDC_CHECK3))->SetCheck(m_check3);

	//valMin et valMax de L
	CEdit *eMin4 = (CEdit *)GetDlgItem(IDC_MIN4);
	CEdit *eMax4 = (CEdit *)GetDlgItem(IDC_MAX4);
	eMin4->EnableWindow(m_check4);
	eMax4->EnableWindow(m_check4);
	((CButton*)GetDlgItem(IDC_CHECK4))->SetCheck(m_check4);

	//valMin et valMax de H
	CEdit *eMin5 = (CEdit *)GetDlgItem(IDC_MIN5);
	CEdit *eMax5 = (CEdit *)GetDlgItem(IDC_MAX5);
	eMin5->EnableWindow(m_check5);
	eMax5->EnableWindow(m_check5);
	((CButton*)GetDlgItem(IDC_CHECK5))->SetCheck(m_check5);

	//valMin et valMax de Densit pixels blancs
	CEdit *eMin6 = (CEdit *)GetDlgItem(IDC_MIN6);
	CEdit *eMax6 = (CEdit *)GetDlgItem(IDC_MAX6);
	eMin6->EnableWindow(m_check6);
	eMax6->EnableWindow(m_check6);
	((CButton*)GetDlgItem(IDC_CHECK6))->SetCheck(m_check6);

	//valMin et valMax de Moyenne Ndg
	CEdit *eMin7 = (CEdit *)GetDlgItem(IDC_MIN7);
	CEdit *eMax7 = (CEdit *)GetDlgItem(IDC_MAX7);
	eMin7->EnableWindow(m_check7);
	eMax7->EnableWindow(m_check7);
	((CButton*)GetDlgItem(IDC_CHECK7))->SetCheck(m_check7);

}

void CDialogClassifAuto::MajPartGeo()
{
	//slider de position gauche
	CSliderCtrl *sliderGeoG = (CSliderCtrl *)GetDlgItem(IDC_SLIDER10);
	sliderGeoG->EnableWindow(m_check10);
	sliderGeoG->SetPos(m_valSliderGeoG);
	((CButton*)GetDlgItem(IDC_CHECK10))->SetCheck(m_check10);

	//slider de position droite
	CSliderCtrl *sliderGeoD = (CSliderCtrl *)GetDlgItem(IDC_SLIDER11);
	sliderGeoD->EnableWindow(m_check11);
	sliderGeoD->SetPos(m_valSliderGeoD);
	((CButton*)GetDlgItem(IDC_CHECK11))->SetCheck(m_check11);

	//slider de position haut
	CSliderCtrl *sliderGeoH = (CSliderCtrl *)GetDlgItem(IDC_SLIDER12);
	sliderGeoH->EnableWindow(m_check12);
	sliderGeoH->SetPos(m_valSliderGeoH);
	((CButton*)GetDlgItem(IDC_CHECK12))->SetCheck(m_check12);

	//slider de position bas
	CSliderCtrl *sliderGeoB = (CSliderCtrl *)GetDlgItem(IDC_SLIDER13);
	sliderGeoB->EnableWindow(m_check13);
	sliderGeoB->SetPos(m_valSliderGeoB);
	((CButton*)GetDlgItem(IDC_CHECK13))->SetCheck(m_check13);

	//slider de position centre de la page
	CSliderCtrl *sliderGeoC = (CSliderCtrl *)GetDlgItem(IDC_SLIDER14);
	sliderGeoC->EnableWindow(m_check14);
	sliderGeoC->SetPos(m_valSliderGeoC);
	((CButton*)GetDlgItem(IDC_CHECK14))->SetCheck(m_check14);

	//slider de position centre de la largeur
	CSliderCtrl *sliderGeoO = (CSliderCtrl *)GetDlgItem(IDC_SLIDER15);
	sliderGeoO->EnableWindow(m_check15);
	sliderGeoO->SetPos(m_valSliderGeoO);
	((CButton*)GetDlgItem(IDC_CHECK15))->SetCheck(m_check15);

	//slider de position centre de la hauteur
	CSliderCtrl *sliderGeoE = (CSliderCtrl *)GetDlgItem(IDC_SLIDER16);
	sliderGeoE->EnableWindow(m_check16);
	sliderGeoE->SetPos(m_valSliderGeoE);
	((CButton*)GetDlgItem(IDC_CHECK16))->SetCheck(m_check16);
}

void CDialogClassifAuto::MajPartVois()
{
	CListBox *listeh=(CListBox *)GetDlgItem(IDC_LISTEH);
	CListBox *listeg=(CListBox *)GetDlgItem(IDC_LISTEG);
	CListBox *listeb=(CListBox *)GetDlgItem(IDC_LISTEB);
	CListBox *listed=(CListBox *)GetDlgItem(IDC_LISTED);
	CListBox *listei=(CListBox *)GetDlgItem(IDC_LISTEI);

	//slider de la tolrance des EcartTypes de Vois
	CSliderCtrl *sliderVoisReg = (CSliderCtrl *)GetDlgItem(IDC_SLIDER22);
	sliderVoisReg->EnableWindow(true);

	//liste des voisins Haut
	CComboBox *comboH=(CComboBox *)GetDlgItem(IDC_LISTEH);
	comboH->EnableWindow(m_check17);
	if (!m_check17) for (int i=0 ; i<listeh->GetCount() ; i++) listeh->SetSel(i, false);
	else listeh->SetSel(0, true);
	((CButton*)GetDlgItem(IDC_CHECK17))->SetCheck(m_check17);

	//liste des voisins Gauche
	CComboBox *comboG=(CComboBox *)GetDlgItem(IDC_LISTEG);
	comboG->EnableWindow(m_check18);
	if (!m_check18) for (int i=0 ; i<listeg->GetCount() ; i++) listeg->SetSel(i, false);
	else listeg->SetSel(0, true);
	((CButton*)GetDlgItem(IDC_CHECK18))->SetCheck(m_check18);

	//liste des voisins Bas
	CComboBox *comboB=(CComboBox *)GetDlgItem(IDC_LISTEB);
	comboB->EnableWindow(m_check19);
	if (!m_check19) for (int i=0 ; i<listeb->GetCount() ; i++) listeb->SetSel(i, false);
	else listeb->SetSel(0, true);
	((CButton*)GetDlgItem(IDC_CHECK19))->SetCheck(m_check19);

	//liste des voisins Droite
	CComboBox *comboD=(CComboBox *)GetDlgItem(IDC_LISTED);
	comboD->EnableWindow(m_check20);
	if (!m_check20) for (int i=0 ; i<listed->GetCount() ; i++) listed->SetSel(i, false);
	else listed->SetSel(0, true);
	((CButton*)GetDlgItem(IDC_CHECK20))->SetCheck(m_check20);

	//liste des voisins Inclus
	CComboBox *comboI=(CComboBox *)GetDlgItem(IDC_LISTEI);
	comboI->EnableWindow(m_check21);
	if (!m_check21) for (int i=0 ; i<listei->GetCount() ; i++) listei->SetSel(i, false);
	else listei->SetSel(0, true);
	((CButton*)GetDlgItem(IDC_CHECK21))->SetCheck(m_check21);
}

void CDialogClassifAuto::MajPartOrdre()
{
	switch(m_ordreCarac)
	{
	case 0:
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARAC1))->SetCheck(true);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARAC2))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARAC3))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARACNUL))->SetCheck(false);
		break;
	case 1:
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARAC1))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARAC2))->SetCheck(true);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARAC3))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARACNUL))->SetCheck(false);
		break;
	case 2:
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARAC1))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARAC2))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARAC3))->SetCheck(true);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARACNUL))->SetCheck(false);
		break;
	case 3:
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARAC1))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARAC2))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARAC3))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_CARACNUL))->SetCheck(true);
		break;
	default :
		break;
	}

	switch(m_ordreGeo)
	{
	case 0:
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEO1))->SetCheck(true);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEO2))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEO3))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEONUL))->SetCheck(false);
		break;
	case 1:
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEO1))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEO2))->SetCheck(true);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEO3))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEONUL))->SetCheck(false);
		break;
	case 2:
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEO1))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEO2))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEO3))->SetCheck(true);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEONUL))->SetCheck(false);
		break;
	case 3:
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEO1))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEO2))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEO3))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_GEONUL))->SetCheck(true);
		break;
	default :
		break;
	}

	switch(m_ordreVois)
	{
	case 0:
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOIS1))->SetCheck(true);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOIS2))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOIS3))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOISNUL))->SetCheck(false);
		break;
	case 1:
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOIS1))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOIS2))->SetCheck(true);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOIS3))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOISNUL))->SetCheck(false);
		break;
	case 2:
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOIS1))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOIS2))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOIS3))->SetCheck(true);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOISNUL))->SetCheck(false);
		break;
	case 3:
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOIS1))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOIS2))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOIS3))->SetCheck(false);
		((CButton*)GetDlgItem(IDC_RADIO_ORDRE_VOISNUL))->SetCheck(true);
		break;
	default :
		break;
	}
}

void CDialogClassifAuto::MajInterface()
{
	MajPartMode();
	MajPartCarac();
	MajPartGeo();
	MajPartVois();
	MajPartOrdre();
}

void CDialogClassifAuto::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CClassifAuto *classifAutoTmp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto();

	UpdateData(true);
	CSliderCtrl *pSlide = (CSliderCtrl *)pScrollBar;

	int numSlider;
	numSlider = pSlide->GetDlgCtrlID();

	switch (numSlider)
	{
	case IDC_SLIDER22:
		m_valSliderVoisReg = pSlide->GetPos();
		datas->setTolVoisReg(m_valSliderVoisReg);
		datas->CalculerSuite();
		CocherReglesVois(true);
		MajInterface();
		break;
	case IDC_SLIDER16:
		m_valSliderGeoE = pSlide->GetPos();
		break;
	case IDC_SLIDER15:
		m_valSliderGeoO = pSlide->GetPos();
		break;
	case IDC_SLIDER14:
		m_valSliderGeoC = pSlide->GetPos();
		break;
	case IDC_SLIDER13:
		m_valSliderGeoB = pSlide->GetPos();
		break;
	case IDC_SLIDER12:
		m_valSliderGeoH = pSlide->GetPos();
		break;
	case IDC_SLIDER11:
		m_valSliderGeoD = pSlide->GetPos();
		break;
	case IDC_SLIDER10:
		m_valSliderGeoG = pSlide->GetPos();
		break;
	case IDC_SLIDER9:
		m_valSliderCaracEcart = pSlide->GetPos();
		datas->setPourcentageCaracMoy(m_valSliderCaracEcart);
		datas->CalculerValeurs();
		RemplirCasesMinCarac();
		RemplirCasesMaxCarac();
		break;
	case IDC_SLIDER8:
		m_valSliderCaracReg = pSlide->GetPos();
		datas->setTolCaracReg(m_valSliderCaracReg);
		datas->CalculerSuite();
		CocherReglesCarac(true);
		MajInterface();
		break;
	default:
		break;
	}
		

	UpdateData(false);UpdateWindow();
	
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
	
}

void CDialogClassifAuto::OnBnClickedRadioCaracMoy()
{
	m_radioCaracMoy = true;
	datas->setIsValsMoyCarac(m_radioCaracMoy);
	datas->CalculerValeurs();
	RemplirCasesMinCarac();
	RemplirCasesMaxCarac();
	SetDlgItemText(IDC_STATIC_TITRE_ECART_CARAC,"Ecart  la moyenne");
	MajInterface();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioCaracMed()
{
	m_radioCaracMoy = false;
	datas->setIsValsMoyCarac(m_radioCaracMoy);
	datas->CalculerValeurs();
	RemplirCasesMinCarac();
	RemplirCasesMaxCarac();
	SetDlgItemText(IDC_STATIC_TITRE_ECART_CARAC,"Ecart  la mdiane");
	MajInterface();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioGeoMoy()
{
	m_radioGeoMoy = true;
	datas->setIsValsMoyGeo(m_radioGeoMoy);
	datas->CalculerValeurs();
	RemplirCasesGeo();
	MajInterface();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioGeoMed()
{
	m_radioGeoMoy = false;
	datas->setIsValsMoyGeo(m_radioGeoMoy);
	datas->CalculerValeurs();
	RemplirCasesGeo();
	MajInterface();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedCheck1()
{
	m_check1 = !m_check1;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck2()
{
	m_check2 = !m_check2;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck3()
{
	m_check3 = !m_check3;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck4()
{
	m_check4 = !m_check4;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck5()
{
	m_check5 = !m_check5;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck6()
{
	m_check6 = !m_check6;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck7()
{
	m_check7 = !m_check7;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck10()
{
	m_check10 = !m_check10;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck11()
{
	m_check11 = !m_check11;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck12()
{
	m_check12 = !m_check12;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck13()
{
	m_check13 = !m_check13;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck14()
{
	m_check14 = !m_check14;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck15()
{
	m_check15 = !m_check15;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck16()
{
	m_check16 = !m_check16;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck17()
{
	CListBox *listeh=(CListBox *)GetDlgItem(IDC_LISTEH);
	for (int i=0 ; i<listeh->GetCount() ; i++) listeh->SetSel(i, false);

	m_check17 = !m_check17;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck18()
{
	CListBox *listeg=(CListBox *)GetDlgItem(IDC_LISTEG);
	for (int i=0 ; i<listeg->GetCount() ; i++) listeg->SetSel(i, false);

	m_check18 = !m_check18;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck19()
{
	CListBox *listeb=(CListBox *)GetDlgItem(IDC_LISTEB);
	for (int i=0 ; i<listeb->GetCount() ; i++) listeb->SetSel(i, false);

	m_check19 = !m_check19;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck20()
{
	CListBox *listed=(CListBox *)GetDlgItem(IDC_LISTED);
	for (int i=0 ; i<listed->GetCount() ; i++) listed->SetSel(i, false);

	m_check20 = !m_check20;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedCheck21()
{
	CListBox *listei=(CListBox *)GetDlgItem(IDC_LISTEI);
	for (int i=0 ; i<listei->GetCount() ; i++) listei->SetSel(i, false);

	m_check21 = !m_check21;
	MajInterface();
}

void CDialogClassifAuto::OnBnClickedRadioOrdreCarac1()
{
	m_ordreCarac = 0;
	//CocherReglesCarac(true);
	MajPartCarac();
	MajPartOrdre();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioOrdreCarac2()
{
	m_ordreCarac = 1;
	//CocherReglesCarac(true);
	MajPartOrdre();
	MajPartCarac();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioOrdreCarac3()
{
	m_ordreCarac = 2;
	//CocherReglesCarac(true);
	MajPartCarac();
	MajPartOrdre();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioOrdreCaracnul()
{
	m_ordreCarac = 3;
	CocherReglesCarac(false);
	MajPartCarac();
	MajPartOrdre();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioOrdreGeo1()
{
	m_ordreGeo = 0;
	//CocherReglesGeo(true);
	MajPartGeo();
	MajPartOrdre();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioOrdreGeo2()
{
	m_ordreGeo = 1;
	//CocherReglesGeo(true);
	MajPartGeo();
	MajPartOrdre();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioOrdreGeo3()
{
	m_ordreGeo = 2;
	//CocherReglesGeo(true);
	MajPartGeo();
	MajPartOrdre();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioOrdreGeonul()
{
	m_ordreGeo = 3;
	CocherReglesGeo(false);
	MajPartGeo();
	MajPartOrdre();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioOrdreVois1()
{
	m_ordreVois = 0;
	//CocherReglesVois(true);
	MajPartVois();
	MajPartOrdre();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioOrdreVois2()
{
	m_ordreVois = 1;
	//CocherReglesVois(true);
	MajPartVois();
	MajPartOrdre();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioOrdreVois3()
{
	m_ordreVois = 2;
	//CocherReglesVois(true);
	MajPartVois();
	MajPartOrdre();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedRadioOrdreVoisnul()
{
	m_ordreVois = 3;
	CocherReglesVois(false);
	MajPartVois();
	MajPartOrdre();
	UpdateData(false);UpdateWindow();
}

void CDialogClassifAuto::OnBnClickedButtonRetValOrg()
{
	datas->setTolCaracReg(m_initCaracTol);
	datas->setPourcentageCaracMoy(m_initCaracEcart);
	datas->setTolVoisReg(m_initVoisTol);
	m_valSliderCaracReg = m_initCaracTol;
	m_valSliderCaracEcart = m_initCaracEcart;
	m_valSliderVoisReg = m_initVoisTol;

	//slider de la tolrance des EcartTypes de Carac
	CSliderCtrl *sliderCaracReg = (CSliderCtrl *)GetDlgItem(IDC_SLIDER8);
	sliderCaracReg->SetPos(m_valSliderCaracReg);

	//slider des carts  la moyenne ou mdiane
	CSliderCtrl *sliderCaracTol = (CSliderCtrl *)GetDlgItem(IDC_SLIDER9);
	sliderCaracTol->SetPos(m_valSliderCaracEcart);

	//slider de la tolrance des EcartTypes de Vois
	CSliderCtrl *sliderVoisReg = (CSliderCtrl *)GetDlgItem(IDC_SLIDER22);
	sliderVoisReg->SetPos(m_valSliderVoisReg);

	datas->CalculerSuite();

	RemplirCasesMinCarac();
	RemplirCasesMaxCarac();
	RemplirCasesGeo();
	RemplirCasesVois();

	CocherReglesCarac(true);
	CocherReglesGeo(true);
	CocherReglesVois(true);
	CocherRadiosOrdre();

	MajInterface();
	MajInterface();

	UpdateData(false);UpdateWindow();
}
