/****************************************************************/
// DialogSuppType.cpp : implementation file
/****************************************************************/

#include "stdafx.h"
#include "myapp.h"
#include "DialogSuppType.h"
#include "MyAppDoc.h"
#include "constante.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/****************************************************************/
// CDialogSuppType dialog
/****************************************************************/

CDialogSuppType::CDialogSuppType(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogSuppType::IDD, pParent)
{
	pView = (CView *)pParent;
	//{{AFX_DATA_INIT(CDialogSuppType)
	m_radio = -1;
	m_liste = _T("");
	m_sup = FALSE;
	//}}AFX_DATA_INIT
}


void CDialogSuppType::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogSuppType)
	DDX_Radio(pDX, IDC_RADIO1, m_radio);
	DDX_CBString(pDX, IDC_LISTE, m_liste);
	DDX_Check(pDX, IDC_CHECK1, m_sup);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogSuppType, CDialog)
	//{{AFX_MSG_MAP(CDialogSuppType)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************/
// CDialogSuppType message handlers
/****************************************************************/

BOOL CDialogSuppType::OnInitDialog() 
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	
	
	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	CComboBox *combo=(CComboBox *)GetDlgItem(IDC_LISTE);
	CObList * liste;
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading types");
		break;
	}

	POSITION pt = liste->GetHeadPosition();
	while (pt != NULL)
	{
		CTypeClasse *tp = (CTypeClasse *)liste->GetNext(pt);
		int a=combo->InsertString(-1,tp->getNomClasse());
	}
	
	
	m_radio=1;
	CDialog::OnInitDialog();
	combo->SetCurSel(0);
	
	return TRUE;
}
