// DlgAssist2.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "MyApp.h"
#include "DlgAssist2.h"
#include ".\DlgAssist2.h"
#include "MainFrm.h"
#include "constante.h"
#include "DialogSelFichiers.h"


// Bote de dialogue CDlgAssist2

IMPLEMENT_DYNAMIC(CDlgAssist2, CDialog)
CDlgAssist2::CDlgAssist2(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAssist2::IDD, pParent)
{
	m_pTab = NULL;
}

CDlgAssist2::~CDlgAssist2()
{
}

BOOL CDlgAssist2::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	((CButton*)GetDlgItem(IDC_RADIO_ASSIST2_AUTO_A))->SetCheck(true);

	return TRUE;
}

void CDlgAssist2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_ASSIST2_VAL_A, m_ctrlAssist2BtnValA);
	DDX_Control(pDX, IDC_LABEL_ASSIST2_LEG_B, m_ctrlAssist2LegB);
	DDX_Control(pDX, IDC_BUTTON_ASSIST2_ETPSUIV_B, m_ctrlAssist2BtnEtpSuivB);
	DDX_Control(pDX, IDC_LABEL_ASSIST2_LEG_C, m_ctrlAssist2LegC);
	DDX_Control(pDX, IDC_BUTTON_ASSIST2_ETPSUIV_C, m_ctrlAssist2BtnEtpSuivC);
	DDX_Control(pDX, IDC_BUTTON_RAZ_TRAIT, m_ctrlAssist2BtnRAZBC);
}


BEGIN_MESSAGE_MAP(CDlgAssist2, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_ASSIST2_VAL_A, OnBnClickedButtonAssist2ValA)
	ON_BN_CLICKED(IDC_BUTTON_ASSIST2_ETPSUIV_B, OnBnClickedButtonAssist2EtpsuivB)
	ON_BN_CLICKED(IDC_BUTTON_ASSIST2_ETPSUIV_C, OnBnClickedButtonAssist2EtpsuivC)
	ON_BN_CLICKED(IDC_BUTTON_RAZ_TRAIT, OnBnClickedButtonRazTrait)
END_MESSAGE_MAP()


// Gestionnaires de messages CDlgAssist2

void CDlgAssist2::ChargerImageLaboTrait()
{
	//charge l'image du laboTrait au demarrage de cet onglet :
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());

	pAppTemp->projet->getLaboTrait()->OuvrirImageLaboTrait();
}

void CDlgAssist2::OnBnClickedButtonAssist2ValA()
{
	LRESULT choixPerso = SendDlgItemMessage(IDC_RADIO_ASSIST2_PERSO_A, BM_GETSTATE, 0, 0); 
	LRESULT choixAuto = SendDlgItemMessage(IDC_RADIO_ASSIST2_AUTO_A, BM_GETSTATE, 0, 0);

	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());

	if (choixPerso == BST_CHECKED)
	{
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab2B();

		//grise les menus Classif et Proj :
		pAppTemp->projet->getLaboTrait()->MajMenu();

		//effectue les traitements slectionns au fur et  mesure !!!
	}else if (choixAuto == BST_CHECKED)
	{
		//effectuer les traitements auto
		pAppTemp->projet->getLaboTrait()->TraitementsAuto();

		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab2C();
	}
}

void CDlgAssist2::CocherCasePerso()
{
	((CButton*)GetDlgItem(IDC_RADIO_ASSIST2_PERSO_A))->SetCheck(true);
	((CButton*)GetDlgItem(IDC_RADIO_ASSIST2_AUTO_A))->SetCheck(false);
}

void CDlgAssist2::OnBnClickedButtonAssist2EtpsuivB()
{
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());

	//crer fenetre de selection multiple de fichiers images pour classif
	CDialogSelFichiers dlg2(false);
	if ( dlg2.DoModal() == IDOK )
	{
		//ajouter la regle de calcul des caracteristiques
		CRegleCarac *r1=new CRegleCarac();
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
		r1->Executer((CMyAppDoc*)pAppTemp->projet->getLaboTrait()->getListeDocsLaboTrait()->GetHead());

		//recopier le scenario de laboTrait dans celui de laboClassif
		pAppTemp->projet->getLaboClassif()->setScenarioClassif(pAppTemp->projet->getLaboTrait()->getScenarioTrait());
		//vider le scenario de LaboTrait et afficher
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->EffacerTout();
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Afficher();
		//efface la liste de types de classe cre  cette tape (elle sera recre dans l'tape suivante)
		pAppTemp->projet->getLaboTrait()->getListeTypesClasse()->RemoveAll();

		//vider les docs contenus dans laboTrait :
		((CMyAppApp*)AfxGetApp())->FermerTousDocuments();

		//20 images charges dans le AfficherTab3A

		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab3A();
	}
}

void CDlgAssist2::OnBnClickedButtonAssist2EtpsuivC()
{
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());

	//crer fenetre de selection multiple de fichiers images pour classif
	CDialogSelFichiers dlg2(false);
	if ( dlg2.DoModal() == IDOK )
	{
		//recopier le scenario de laboTrait dans celui de laboClassif
		pAppTemp->projet->getLaboClassif()->setScenarioClassif(pAppTemp->projet->getLaboTrait()->getScenarioTrait());
		//vider le scenario de LaboTrait et afficher
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->EffacerTout();
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Afficher();
		//efface la liste de types de classe cre  cette tape (elle sera recre dans l'tape suivante)
		pAppTemp->projet->getLaboTrait()->getListeTypesClasse()->RemoveAll();

		//vider les docs contenus dans laboTrait :
		((CMyAppApp*)AfxGetApp())->FermerTousDocuments();

		//20 images charges dans le AfficherTab3A

		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab3A();
	}
}



void CDlgAssist2::OnBnClickedButtonRazTrait()
{
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());

	//supprime le doc de traitements et le recharge:
	pAppTemp->projet->getLaboTrait()->RechargerDocument();
}
