// DlgAssist3.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "MyApp.h"
#include "DlgAssist3.h"
#include "MainFrm.h"
#include "MyAppDoc.h"
#include "MyAppView.h"
#include ".\DlgAssist3.h"
#include "constante.h"
#include "DialogClassifAuto.h"
#include "ClassifAutoDonnees.h"
#include "Regle.h"

// Bote de dialogue CDlgAssist3

IMPLEMENT_DYNAMIC(CDlgAssist3, CDialog)
CDlgAssist3::CDlgAssist3(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAssist3::IDD, pParent)
{
	m_pTab = NULL;
	m_modeSelection = false;
	curPrevSel = -1;
	color = 0;
	classifEnCours = false;
	prevDone = false;
	indiceStart = -1;
	listeLabelsCrees = new CList<CString,CString>();
}

CDlgAssist3::~CDlgAssist3()
{
}

void CDlgAssist3::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_ASSIST3_VAL_A, m_ctrlAssist3BtnValA);
	DDX_Control(pDX, IDC_LABEL_ASSIST3_LEG_B, m_ctrlAssist3LegB);
	DDX_Control(pDX, IDC_BUTTON_ASSIST3_ETPSUIV_B, m_ctrlAssist3BtnEtpSuivB);
	DDX_Control(pDX, IDC_LABEL_ASSIST3_LEG_C1, m_ctrlAssist3LegC1);
	DDX_Control(pDX, IDC_EDIT_ETIQUETTE_EXPORT, m_ctrlAssist3LabelEditC);
	DDX_Control(pDX, IDC_LISTE_ZONES_SEL, m_ctrlAssist3ListC);
	DDX_Control(pDX, IDC_BUTTON_SAISIR_EXPL, m_ctrlAssist3BtnLabelC);
	DDX_Control(pDX, IDC_BUTTON_SUPP_ZONE_SEL, m_ctrlAssist3BtnSupprC);
	DDX_Control(pDX, IDC_BUTTON_RAZ, m_ctrlAssist3BtnRazC);
	DDX_Control(pDX, IDC_BUTTON_COULEUR, m_ctrlAssist3BtnCouleurC);
	DDX_Control(pDX, IDC_BUTTON_ASSIST3_PREV_C, m_ctrlAssist3BtnPrevC);
	DDX_Control(pDX, IDC_BUTTON_ASSIST3_ETPSUIV_C, m_ctrlAssist3BtnEtpSuivC);
	DDX_Control(pDX, IDC_BUTTON_ASSIST3_VAL_C, m_ctrlAssist3BtnValC);
	DDX_Control(pDX, IDC_BUTTON_ASSIST3_MODIF_C, m_ctrlAssist3BtnModifC);
	DDX_Control(pDX, IDC_STATIC_TIT_ETIQVAL, m_ctrlAssist3TextEtiqValC);
	DDX_Control(pDX, IDC_STATIC_ETIQCREE_1, m_ctrlAssist3TextEtiqCree1C);
	DDX_Control(pDX, IDC_STATIC_ETIQCREE_2, m_ctrlAssist3TextEtiqCree2C);
	DDX_Control(pDX, IDC_STATIC_ETIQCREE_3, m_ctrlAssist3TextEtiqCree3C);
	DDX_Control(pDX, IDC_STATIC_ETIQCREE_4, m_ctrlAssist3TextEtiqCree4C);
	DDX_Control(pDX, IDC_STATIC_ETIQCREE_5, m_ctrlAssist3TextEtiqCree5C);
	DDX_Control(pDX, IDC_STATIC_ETIQCREE_6, m_ctrlAssist3TextEtiqCree6C);
	DDX_Control(pDX, IDC_STATIC_ETIQCREE_7, m_ctrlAssist3TextEtiqCree7C);
	DDX_Control(pDX, IDC_STATIC_ETIQCREE_8, m_ctrlAssist3TextEtiqCree8C);
	DDX_Control(pDX, IDC_STATIC_ETIQCREE_9, m_ctrlAssist3TextEtiqCree9C);
	DDX_Control(pDX, IDC_STATIC_ETIQCREE_10, m_ctrlAssist3TextEtiqCree10C);
	DDX_Control(pDX, IDC_STATIC_ETIQCREE_11, m_ctrlAssist3TextEtiqCree11C);
	DDX_Control(pDX, IDC_STATIC_ETIQCREE_12, m_ctrlAssist3TextEtiqCree12C);
}


BEGIN_MESSAGE_MAP(CDlgAssist3, CDialog)
	ON_MESSAGE(WM_INITDIALOG,OnInitDialog) 
	ON_BN_CLICKED(IDC_BUTTON_RAZ, OnBnClickedButtonRaz)
	ON_BN_CLICKED(IDC_BUTTON_SUPP_ZONE_SEL, OnBnClickedButtonSupprSel)
	ON_LBN_SELCHANGE(IDC_LISTE_ZONES_SEL, OnLbnSelchangeListeZonesSel)
	ON_COMMAND(IDC_BUTTON_SAISIR_EXPL, OnSaisirExemples)
	ON_UPDATE_COMMAND_UI(IDC_BUTTON_SAISIR_EXPL, OnUpdateSaisirExemples)
	ON_BN_CLICKED(IDC_BUTTON_ASSIST3_VAL_A, OnBnClickedButtonAssist3ValA)
	ON_BN_CLICKED(IDC_BUTTON_ASSIST3_ETPSUIV_B, OnBnClickedButtonAssist3EtpsuivB)
	ON_BN_CLICKED(IDC_BUTTON_ASSIST3_ETPSUIV_C, OnBnClickedButtonAssist3EtpsuivC)
	ON_BN_CLICKED(IDC_BUTTON_COULEUR, OnBnClickedButtonCouleur)
	ON_BN_CLICKED(IDC_BUTTON_ASSIST3_PREV_C, OnBnClickedButtonAssist3PrevC)
	ON_BN_CLICKED(IDC_BUTTON_ASSIST3_MODIF_C, OnBnClickedButtonAssist3ModifC)
	ON_BN_CLICKED(IDC_BUTTON_ASSIST3_VAL_C, OnBnClickedButtonAssist3ValC)
END_MESSAGE_MAP()


// Gestionnaires de messages CDlgAssist3

LONG CDlgAssist3::OnInitDialog(UINT wParam, LONG lParam)
{
	//CDialogBar/*CDialog*/::OnInitDialog();
	// suppression de la commande par :
	BOOL bRet = HandleInitDialog(wParam, lParam);

	m_ctrlAssist3BtnLabelC.SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_LABEL));
	m_ctrlAssist3BtnSupprC.SetIcon(AfxGetApp()->LoadIcon(IDI_ICON_SUPPR));

	((CButton*)GetDlgItem(IDC_RADIO_ASSIST3_AUTO_A))->SetCheck(true);

	m_ctrlAssist3BtnValC.EnableWindow(false);
	m_ctrlAssist3BtnModifC.EnableWindow(false);
	m_ctrlAssist3BtnEtpSuivC.EnableWindow(true);
	m_ctrlAssist3BtnLabelC.SetState(false);

	listeLabelsCrees->RemoveAll();

	return bRet;
}

void CDlgAssist3::ChargerImagesLaboClassif()
{
	//charge les images du laboClassif au demarrage de cet onglet :
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());

	//la liste d'images a t remplie  la cloture de l'onglet prcdent
	pAppTemp->projet->getLaboClassif()->OuvrirImagesLaboClassif();
}

void CDlgAssist3::OnBnClickedButtonAssist3PrevC()
{
	//previsualisation des regles trouvees automatiquement
	
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CMainFrame *pFrmTemp = (CMainFrame *)AfxGetMainWnd();
	CClassifAuto* classifTemp = pAppTemp->projet->getLaboClassif()->getClassifAuto();
	if (!classifTemp->getListeZonesSelectionnees()->IsEmpty())
	{
		CString etiquetteSaisie;
		GetDlgItemText(IDC_EDIT_ETIQUETTE_EXPORT,etiquetteSaisie);
		if (!etiquetteSaisie.IsEmpty())
		{
			ActiverDesactiverBoutons();
			if (!prevDone)
			{
				//progressbar:
				((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Prvisualisation en cours...",pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif()->GetCount());

				//nbZones slectionnes:
				classifTemp->getDonnees()->setNbZones(classifTemp->getListeZonesSelectionnees()->GetCount());

				//recalcul des caractristiques (obligatoire sinon le calcul de densit de pix blancs 
				//n'est pas  jour car il se sert de l'image courante qui a t modifie):
				CRegleCarac *r4=new CRegleCarac();
				CObList* listeDocs = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif();
				pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r4);
				POSITION posDoc = listeDocs->GetHeadPosition();
				while (posDoc)
				{
					r4->Executer((CMyAppDoc*)listeDocs->GetNext(posDoc));
					//incrmenter la progressbar
					((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
				}
				pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Afficher();

				//indice de la premiere regle de la classif auto
				indiceStart = pAppTemp->projet->getLaboClassif()->getScenarioClassif()->getNbRegles()-1;

				//calcul des paramtres auto en fonction de l'cart type de chaque carac:
				classifTemp->ClasserAuto(etiquetteSaisie, color);
				CScenario *scenarTemp = classifTemp->getDonnees()->getScenarAuto();

				//execution du scenario:
				POSITION posDoc2 = listeDocs->GetHeadPosition();
				while (posDoc2)
				{
					scenarTemp->Executer((CMyAppDoc*)listeDocs->GetNext(posDoc2));
				}

				//incrmenter la progressbar
				((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();

				//ajout du scenario auto au scenario global et affichage
				pAppTemp->projet->getLaboClassif()->getScenarioClassif()->AjouterScenario(scenarTemp);
				pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Afficher();

				prevDone = true;
				ActiverDesactiverBoutons();

				//pFrmTemp->MessageBox("Exportation des caractristiques russie");
			}
		}else
		{
			pFrmTemp->MessageBox("Veuillez entrer une tiquette");
		}
	}else
	{
		pFrmTemp->MessageBox("Veuillez d'abord slectionner des zones");
	}
	if(!pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif()->IsEmpty())
	{
		pAppTemp->ChargerDocSelectionne();
		pAppTemp->projet->getLaboClassif()->RendreLeFocusALImageActive();
	}
}

void CDlgAssist3::OnBnClickedButtonRaz()
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CMainFrame *pFrmTemp = (CMainFrame *)AfxGetMainWnd();
	CClassifAuto *classifTemp = pAppTemp->projet->getLaboClassif()->getClassifAuto();
	CLaboClassif *laboClassifTmp = pAppTemp->projet->getLaboClassif();
	if (!classifTemp->getListeZonesSelectionnees()->IsEmpty())
	{
		if (prevDone)
		{
			SupprimerScenarPrec();
		}

		classifTemp->RAZListeZonesSelectionnees();
		CListBox *listTemp = (CListBox *)pFrmTemp->m_wndDlgAssistTab.getm_assist3()->GetDlgItem(IDC_LISTE_ZONES_SEL);
		listTemp->ResetContent();
		//pFrmTemp->MessageBox("Remise  Zro de la liste de zones slectionnes russie");

		//mise a jour de l'affichage (zones jaunes effaces):
		POSITION posTemp = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif()->GetHeadPosition();
		while (posTemp) {
			CMyAppDoc* pDocTemp = (CMyAppDoc*)pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif()->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);
			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);
			pViewTemp->Invalidate(true);
		}
		laboClassifTmp->RazClassifAuto();
		InitClassifAuto();
	}else
	{
		pFrmTemp->MessageBox("Liste dj vide");
		InitClassifAuto();
	}
	if(!pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif()->IsEmpty())
	{
		pAppTemp->ChargerDocSelectionne();
		pAppTemp->projet->getLaboClassif()->RendreLeFocusALImageActive();
	}
}


void CDlgAssist3::InitClassifAuto()
{
	//vider le label:
	SetDlgItemText(IDC_EDIT_ETIQUETTE_EXPORT,_T(""));
	//m_ctrlAssist3LabelEditC.Clear();
	color = 0;
	classifEnCours = false;
	prevDone = false;
	ActiverDesactiverBoutons();
}

void CDlgAssist3::OnBnClickedButtonSupprSel()
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CListBox *listTemp = (CListBox*)GetDlgItem(IDC_LISTE_ZONES_SEL);
	CClassifAuto* classifTemp = pAppTemp->projet->getLaboClassif()->getClassifAuto();
	if (listTemp->GetCount() != 0)
	{
		int indexLigneSel = listTemp->GetCurSel();
		if(indexLigneSel != LB_ERR)
		{
			CString nomImZoneSel = "";
			int numZoneSel = 0;

			numZoneSel = classifTemp->FiltrerListeZoneSel(listTemp, nomImZoneSel);
			CMyAppDoc* pDoc = classifTemp->TrouverDocAvecImg(nomImZoneSel);
			CZone* pZone = classifTemp->TrouverZoneAvecDoc(pDoc,numZoneSel);
			classifTemp->SupprimerZoneSel(pZone);

			listTemp->DeleteString(indexLigneSel);
		}
		ActiverDesactiverBoutons();
	}else
	{
		CMainFrame *pFrmTemp = (CMainFrame *)AfxGetMainWnd();
		pFrmTemp->MessageBox("Veuillez d'abord slectionner des zones");
		ActiverDesactiverBoutons();
	}	
	if(!pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif()->IsEmpty())
		pAppTemp->projet->getLaboClassif()->RendreLeFocusALImageActive();
}


void CDlgAssist3::OnLbnSelchangeListeZonesSel()
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CListBox *listTemp = (CListBox*)GetDlgItem(IDC_LISTE_ZONES_SEL);
	CClassifAuto* classifTemp = pAppTemp->projet->getLaboClassif()->getClassifAuto();
	if (listTemp->GetCount() != 0)
	{
		int indexLigneSel = listTemp->GetCurSel();
		if(indexLigneSel != LB_ERR)
		{
			CString nomImZoneSel = "";
			int numZoneSel = 0;


			numZoneSel = classifTemp->FiltrerListeZoneSel(listTemp, nomImZoneSel);
			CMyAppDoc* pDoc = classifTemp->TrouverDocAvecImg(nomImZoneSel);
			CZone* pZone = classifTemp->TrouverZoneAvecDoc(pDoc,numZoneSel);

			POSITION posView = pDoc->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDoc->GetNextView(posView);
			ASSERT(pViewTemp);
			
			classifTemp->setZoneSel(pZone);

			pAppTemp->ChargerDoc(pDoc);

			pViewTemp->GetParentFrame()->ActivateFrame(SW_SHOWMAXIMIZED);
			pViewTemp->Invalidate(true);	

		}
	}
	if(!pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif()->IsEmpty())
		pAppTemp->projet->getLaboClassif()->RendreLeFocusALImageActive();
}

void CDlgAssist3::OnSaisirExemples() 
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();

	pAppTemp->projet->getLaboClassif()->ModeSelection();

	m_modeSelection = !m_modeSelection;
	//m_ctrlAssist3BtnLabelC.SetState(m_modeSelection);

	ActiverDesactiverBoutons();

	if(!pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif()->IsEmpty())
		pAppTemp->projet->getLaboClassif()->RendreLeFocusALImageActive();
}

void CDlgAssist3::OnUpdateSaisirExemples(CCmdUI* pCmdUI) 
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	//pAppTemp->projet->UpdateModeSelection(pCmdUI);
	pCmdUI->SetCheck(!m_modeSelection);
}

void CDlgAssist3::CocherCasePerso()
{
	((CButton*)GetDlgItem(IDC_RADIO_ASSIST3_PERSO_A))->SetCheck(true);
	((CButton*)GetDlgItem(IDC_RADIO_ASSIST3_AUTO_A))->SetCheck(false);
}

void CDlgAssist3::OnBnClickedButtonAssist3ValA()
{
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());

	LRESULT choixPerso = SendDlgItemMessage(IDC_RADIO_ASSIST3_PERSO_A, BM_GETSTATE, 0, 0); 
	LRESULT choixAssist = SendDlgItemMessage(IDC_RADIO_ASSIST3_AUTO_A, BM_GETSTATE, 0, 0);

	if (choixPerso == BST_CHECKED)
	{
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab3B();

		//grise les menus Trait et Proj :
		pAppTemp->projet->getLaboClassif()->MajMenu();

		//effectue les classifs au fur et  mesure
	}else if (choixAssist == BST_CHECKED)
	{
		//afficher la partie assist
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab3C();
	}
}

void CDlgAssist3::OnBnClickedButtonAssist3EtpsuivB()
{
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());

	//recopier le scenario de laboClassif dans celui de laboProj
	pAppTemp->projet->getLaboProj()->setScenarioProj(pAppTemp->projet->getLaboClassif()->getScenarioClassif());
	//recopier la liste des types classes car on en a besoin dans les exportations
	//(pour appliquer le dico des formes a ts les types de zones existant)
	//(elle sera remise  zero juste avant l'application  tout l'ouvrage)
	pAppTemp->projet->getLaboProj()->setListeTypesClasse(pAppTemp->projet->getLaboClassif()->getListeTypesClasse());
	//vider le scenario de LaboClassif et afficher
	pAppTemp->projet->getLaboClassif()->getScenarioClassif()->EffacerTout();
	pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Afficher();
	//efface la liste de types de classe cre  cette tape (elle sera recre dans l'tape suivante)
	pAppTemp->projet->getLaboClassif()->getListeTypesClasse()->RemoveAll();

	//vider les docs contenus dans laboClassif :
	((CMyAppApp*)AfxGetApp())->FermerTousDocuments();

	//chargement du 4eme onglet
	((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab4();

	//grise les menus Trait et Classif :
	pAppTemp->projet->getLaboProj()->MajMenu();
}

void CDlgAssist3::OnBnClickedButtonAssist3EtpsuivC()
{
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());

	//recopier le scenario de laboClassif dans celui de laboProj
	pAppTemp->projet->getLaboProj()->setScenarioProj(pAppTemp->projet->getLaboClassif()->getScenarioClassif());
	//recopier la liste des types classes car on en a besoin dans les exportations
	//(pour appliquer le dico des formes a ts les types de zones existant)
	//(elle sera remise  zero juste avant l'application  tout l'ouvrage)
	pAppTemp->projet->getLaboProj()->setListeTypesClasse(pAppTemp->projet->getLaboClassif()->getListeTypesClasse());
	//vider le scenario de LaboClassif et afficher
	pAppTemp->projet->getLaboClassif()->getScenarioClassif()->EffacerTout();
	pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Afficher();
	//efface la liste de types de classe cre  cette tape (elle sera recre dans l'tape suivante)
	pAppTemp->projet->getLaboClassif()->getListeTypesClasse()->RemoveAll();

	//vider les docs contenus dans laboClassif :
	((CMyAppApp*)AfxGetApp())->FermerTousDocuments();

	//chargement du 4eme onglet
	((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab4();

	//grise les menus Trait et Classif :
	pAppTemp->projet->getLaboProj()->MajMenu();
}

void CDlgAssist3::OnBnClickedButtonCouleur()
{
	CClassifAuto* classifTemp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto();

	//choisi la couleur du label
	CColorDialog * colordialog = new CColorDialog(color);
	colordialog->DoModal();	
	color = colordialog->GetColor();
	
}

void CDlgAssist3::OnBnClickedButtonAssist3ModifC()
{
	CClassifAutoDonnees *pDatas = new CClassifAutoDonnees();
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());
	CClassifAuto *classifTemp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto();
	CLaboClassif *laboClassifTmp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif();

	//obtention des donnees
	classifTemp->getCopieDonnees(pDatas);

	laboClassifTmp->getScenarioClassif()->Afficher();

	//ouverture de la boite de dialogue avec les donnes:
	CDialogClassifAuto *dlgClassifAuto=new CDialogClassifAuto(pDatas,this);
	if (dlgClassifAuto->DoModal()==IDOK )
	{
		if (pDatas != classifTemp->getDonnees())
		{
			prevDone = false;

			((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto()->setCopieDonnees(pDatas);

			SupprimerScenarPrec();

			//reprvisualisation :
			indiceStart = pAppTemp->projet->getLaboClassif()->getScenarioClassif()->getNbRegles();
			classifTemp->RAZDonnees();
			classifTemp->setCopieDonnees(pDatas);
			CScenario *scenarTemp = classifTemp->getDonnees()->getScenarAuto();

			//execution du scenario:
			CObList* listeDocs = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif();
			POSITION posDoc = listeDocs->GetHeadPosition();
			while (posDoc)
			{
				scenarTemp->Executer((CMyAppDoc*)listeDocs->GetNext(posDoc));
			}

			//ajout du scenario auto au scenario global et affichage
			pAppTemp->projet->getLaboClassif()->getScenarioClassif()->AjouterScenario(scenarTemp);
			pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Afficher();

			prevDone = true;
			ActiverDesactiverBoutons();

			((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();

		}
	}

	delete pDatas;
}

void CDlgAssist3::SupprimerScenarPrec()
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CClassifAuto *classifTemp = pAppTemp->projet->getLaboClassif()->getClassifAuto();
	CLaboClassif *laboClassifTmp = pAppTemp->projet->getLaboClassif();

	//progressbar:
	((CMainFrame*)AfxGetMainWnd())->DemarrerProgressBar("Annulation du scnario en cours...",pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif()->GetCount());

	//effaage de scenarAuto d'avant
	CRegleChangeType *r3 = new CRegleChangeType(classifTemp->getDonnees()->getTypeDest(),classifTemp->getDonnees()->getTypeOrg(),true);
	//ajouter la regle de calcul des caracteristiques
	CRegleCarac *r4=new CRegleCarac();
	//appliquer ces deux regles sans ajouter au scenario (inutile)
	CObList* listeDocs = laboClassifTmp->getListeDocsLaboClassif();
	POSITION posDoc = listeDocs->GetHeadPosition();
	while (posDoc)
	{
		CMyAppDoc *pDoc = (CMyAppDoc*)listeDocs->GetNext(posDoc);
		r3->Executer(pDoc);
		r4->Executer(pDoc);
		//incrmenter la progressbar
		((CMainFrame*)AfxGetMainWnd())->IncrementerProgressBar();
	}

	int indiceStop = laboClassifTmp->getScenarioClassif()->getNbRegles();
	for (int i =indiceStop-1 ; i>=indiceStart ; i--)
	{
		//supprime les regles du scenarAuto d'avant
		laboClassifTmp->getScenarioClassif()->Effacer(i);
	}
	laboClassifTmp->getScenarioClassif()->Afficher();
}

void CDlgAssist3::OnBnClickedButtonAssist3ValC()
{
	//application du scenario

	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CMainFrame *pFrmTemp = (CMainFrame *)AfxGetMainWnd();
	CClassifAuto *classifTemp = pAppTemp->projet->getLaboClassif()->getClassifAuto();
	CLaboClassif *laboClassifTmp = pAppTemp->projet->getLaboClassif();
	
	//raz parametres classif auto:
	if (!classifTemp->getListeZonesSelectionnees()->IsEmpty())
	{
		classifTemp->RAZListeZonesSelectionnees();
		CListBox *listTemp = (CListBox *)pFrmTemp->m_wndDlgAssistTab.getm_assist3()->GetDlgItem(IDC_LISTE_ZONES_SEL);
		listTemp->ResetContent();
		//pFrmTemp->MessageBox("Remise  Zro de la liste de zones slectionnes russie");

		//mise a jour de l'affichage (zones jaunes effaces):
		POSITION posTemp = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif()->GetHeadPosition();
		while (posTemp) {
			CMyAppDoc* pDocTemp = (CMyAppDoc*)pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif()->GetNext(posTemp);
			ASSERT_VALID(pDocTemp);
			POSITION posView = pDocTemp->GetFirstViewPosition();
			CMyAppView* pViewTemp = (CMyAppView*)pDocTemp->GetNextView(posView);
			ASSERT(pViewTemp);
			pViewTemp->Invalidate(true);
		}
		MajListeLabels();
		laboClassifTmp->RazClassifAuto();
		InitClassifAuto();
	}
	prevDone = false;
	ActiverDesactiverBoutons();
}

void CDlgAssist3::MajListeLabels()
{
	CClassifAuto *classifTemp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto();

	listeLabelsCrees->AddTail(classifTemp->getDonnees()->getTypeDest());

	int nb = listeLabelsCrees->GetCount();
	int i = 0;
	POSITION posLabels = listeLabelsCrees->GetHeadPosition();
	while (posLabels)
	{
		CString labelTmp = (CString)listeLabelsCrees->GetNext(posLabels);
		switch (i)
		{
		case 0:
			m_ctrlAssist3TextEtiqCree1C.SetWindowText("- " + labelTmp);
			break;
		case 1:
			m_ctrlAssist3TextEtiqCree2C.SetWindowText("- " + labelTmp);
			break;
		case 2:
			m_ctrlAssist3TextEtiqCree3C.SetWindowText("- " + labelTmp);
			break;
		case 3:
			m_ctrlAssist3TextEtiqCree4C.SetWindowText("- " + labelTmp);
			break;
		case 4:
			m_ctrlAssist3TextEtiqCree5C.SetWindowText("- " + labelTmp);
			break;
		case 5:
			m_ctrlAssist3TextEtiqCree6C.SetWindowText("- " + labelTmp);
			break;
		case 6:
			m_ctrlAssist3TextEtiqCree7C.SetWindowText("- " + labelTmp);
			break;
		case 7:
			m_ctrlAssist3TextEtiqCree8C.SetWindowText("- " + labelTmp);
			break;
		case 8:
			m_ctrlAssist3TextEtiqCree9C.SetWindowText("- " + labelTmp);
			break;
		case 9:
			m_ctrlAssist3TextEtiqCree10C.SetWindowText("- " + labelTmp);
			break;
		case 10:
			m_ctrlAssist3TextEtiqCree11C.SetWindowText("- " + labelTmp);
			break;
		case 11:
			m_ctrlAssist3TextEtiqCree12C.SetWindowText("- " + labelTmp);
			break;
		default:
			break;
		}
		i++;
	}

}

void CDlgAssist3::ActiverDesactiverBoutons()
{
	CClassifAuto *classifTemp = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getClassifAuto();

	if ((classifTemp->getDonnees()->getNbZones() != classifTemp->getListeZonesSelectionnees()->GetCount()))
	{
		if (classifTemp->getDonnees()->getNbZones() != 0)
		{
			if ((prevDone)&&(classifTemp->getDonnees()->getScenarAuto()->getNbRegles() != 0))
				SupprimerScenarPrec();
		}
		prevDone = false;
	}
	else
	{
		if (classifTemp->getDonnees()->getNbZones() != 0)
			prevDone = true;
	}

	m_ctrlAssist3BtnValC.EnableWindow(prevDone);
	m_ctrlAssist3BtnModifC.EnableWindow(prevDone);

	if (m_ctrlAssist3ListC.GetCount() == 0) classifEnCours = false;
	else classifEnCours = true;
	CString tmp;
	m_ctrlAssist3LabelEditC.GetWindowText(tmp);
	if (tmp == "") m_ctrlAssist3LabelEditC.EnableWindow(true);
	else m_ctrlAssist3LabelEditC.EnableWindow(!classifEnCours);
	m_ctrlAssist3BtnEtpSuivC.EnableWindow(!classifEnCours);

	((CMainFrame*)AfxGetMainWnd())->CacherProgressBar();

	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();
}
