// DlgAssist4.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "MyApp.h"
#include "DlgAssist4.h"
#include "DIALOGReglage.h"
#include ".\dlgassist4.h"
#include ".\nomlabel.h"



// Bote de dialogue CDlgAssist4

IMPLEMENT_DYNAMIC(CDlgAssist4, CDialog)
CDlgAssist4::CDlgAssist4(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAssist4::IDD, pParent)
{
	m_pTab = NULL;

	m_check1 = FALSE;
	m_check2 = FALSE;
	m_check3 = FALSE;
	m_check4 = FALSE;
	m_check5 = FALSE;

	m_seuil_dico = 0.15;
	m_editCombo1 = _T("");
	m_editCombo2 = _T("");
}

CDlgAssist4::~CDlgAssist4()
{
}

void CDlgAssist4::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_ASSIST4_APPL, m_BtnApplOuvr);
	DDX_Check(pDX, IDC_CHECK_ANA_FINE_TEXT, m_check1);
	DDX_Check(pDX, IDC_CHECK_FIC_XML_DICO_FORM, m_check2);
	DDX_Check(pDX, IDC_CHECK_IMG_LABEL, m_check3);
	DDX_Check(pDX, IDC_CHECK_IMG_LIG_TEXT, m_check4);
	DDX_Check(pDX, IDC_CHECK_HTML, m_check5);
	DDX_Text(pDX, IDC_SEUIL_DICO_ETAP4, m_seuil_dico);
	DDX_CBString(pDX, IDC_LISTE_TYPE_IMG1, m_editCombo1);
	DDX_CBString(pDX, IDC_LISTE_TYPE_IMG2, m_editCombo2);
}


BEGIN_MESSAGE_MAP(CDlgAssist4, CDialog)
	ON_MESSAGE(WM_INITDIALOG,OnInitDialog) 
	ON_BN_CLICKED(IDC_BUTTON_ASSIST4_APPL, OnBnClickedButtonAssist4Appl)
	ON_BN_CLICKED(IDC_CHECK_ANA_FINE_TEXT, OnBnClickedCheckAnaFineText)
	ON_BN_CLICKED(IDC_CHECK_FIC_XML_DICO_FORM, OnBnClickedCheckFicXmlDicoForm)
	ON_BN_CLICKED(IDC_CHECK_IMG_LABEL, OnBnClickedCheckImgLabel)
	ON_BN_CLICKED(IDC_CHECK_IMG_LIG_TEXT, OnBnClickedCheckImgLigText)
	ON_BN_CLICKED(IDC_CHECK_HTML, OnBnClickedCheckHtml)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_STN_CLICKED(IDC_STATIC_SEUIL_ETP4, OnStnClickedStaticSeuilEtp4)
END_MESSAGE_MAP()


LONG CDlgAssist4::OnInitDialog(UINT wParam, LONG lParam)
{
	//CDialogBar/*CDialog*/::OnInitDialog();
	// suppression de la commande par :
	BOOL bRet = HandleInitDialog(wParam, lParam);

	CComboBox *combo1=(CComboBox *)GetDlgItem(IDC_LISTE_TYPE_IMG1);
	CComboBox *combo2=(CComboBox *)GetDlgItem(IDC_LISTE_TYPE_IMG2);

	combo1->AddString("d'origine");
	combo1->AddString("courante");
	combo1->SelectString(0,"d'origine");
	m_editCombo1 = "d'origine";

	combo2->AddString("d'origine");
	combo2->AddString("courante");
	combo2->SelectString(0,"d'origine");
	m_editCombo2 = "d'origine";

	AfficherCacherBoutonsSupplementaires();

	return bRet;
}


// Gestionnaires de messages CDlgAssist4

void CDlgAssist4::ChargerImagesLaboProj()
{
	//charge les images du laboClassif au demarrage de cet onglet :
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());

	pAppTemp->projet->getLaboProj()->OuvrirTousDocsOuvrage();
}

void CDlgAssist4::OnBnClickedButtonAssist4Appl()
{
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());

	CMyAppDoc* pDoc = (CMyAppDoc*)pAppTemp->projet->getLaboProj()->getListeDocsLaboProj()->GetHead();
	ASSERT_VALID(pDoc);

	POSITION posView = pDoc->GetFirstViewPosition();
	CMyAppView* pViewTemp = (CMyAppView*)pDoc->GetNextView(posView);
	ASSERT(pViewTemp);

	//l'application sur tous les documents est gre dans MyAppView
	//ainsi que l'ajout des regles correspondantes aux choix des exportations
	pViewTemp->OnDocOutilsApplOuvr();
}

void CDlgAssist4::AfficherCacherBoutonsSupplementaires()
{
	m_BtnApplOuvr.EnableWindow(!((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->appliOuvrDone);
	GetDlgItem(IDC_CHECK_ANA_FINE_TEXT)->EnableWindow(!((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->exportDone);
	GetDlgItem(IDC_CHECK_FIC_XML_DICO_FORM)->EnableWindow(!((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->exportDone);
	GetDlgItem(IDC_CHECK_IMG_LABEL)->EnableWindow(!((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->exportDone);
	GetDlgItem(IDC_CHECK_IMG_LIG_TEXT)->EnableWindow(!((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->exportDone);
	GetDlgItem(IDC_CHECK_HTML)->EnableWindow(!((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->exportDone);
	GetDlgItem(IDC_STATIC_SEUIL_ETP4)->EnableWindow(!((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->exportDone);
	GetDlgItem(IDC_SEUIL_DICO_ETAP4)->EnableWindow(!((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->exportDone);
	GetDlgItem(IDC_LISTE_TYPE_IMG1)->EnableWindow(!((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->exportDone);
	GetDlgItem(IDC_LISTE_TYPE_IMG2)->EnableWindow(!((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->exportDone);
	GetDlgItem(IDC_BUTTON1)->EnableWindow(!((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->exportDone);
}

void CDlgAssist4::CreerReglesExport()
{
	UpdateData(true);UpdateWindow();

	CScenario *scenarProj = ((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->getScenarioProj();
	CProjetParam* pProjParamTemp = ((CMyAppApp*)AfxGetApp())->projet->getParamProj();
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();

	CObList * liste;
	liste = pAppTemp->projet->getLaboProj()->getListeTypesClasse();

	if (m_check1)
	{
		if (!scenarProj->regleDejaPresente("RAF"))
		{
			CRegleAnalyseFine *r1=new CRegleAnalyseFine("TEXTE");
			scenarProj->Ajouter(r1);
		}
	}

	if (m_check2)
	{
		//Si l'utilisateur prend tous les labels avec le seuil 0.15 par dfaut
		if (listeVal.size()==0)
			{
				CString nomClasse;
				POSITION pos = liste->GetHeadPosition();
				while (pos)
				{
					CTypeClasse *classTemp = (CTypeClasse*)liste->GetNext(pos);
					nomClasse = classTemp->getNomClasse();
					
					

						if (nomClasse != "BRUIT")
						{
							CRegleTAO *r2 = new CRegleTAO (nomClasse, m_seuil_dico);
							scenarProj->Ajouter(r2);
						}
				}
			}
		//Si il a spcifi les labels  exporter avec des seuils particuliers
		else
			{
				list<CNomLabel>* listeFind=&listeVal;
				list<CNomLabel>::iterator theIteratorMot;
				theIteratorMot = listeFind->begin();
				while (theIteratorMot!=listeFind->end())
				{
					CNomLabel motTemp= *theIteratorMot;
					CRegleTAO *r2 = new CRegleTAO (motTemp.nomLabel,motTemp.seuil);
					scenarProj->Ajouter(r2);
					theIteratorMot++;
				}
				

				

			}
	}
	

	if (m_check3)
	{
		if (m_editCombo1 == "d'origine")
		{
			CReglePost *r3=new CReglePost("SAUVEGARDE_O",pProjParamTemp->getM_deltaDecoup(),pProjParamTemp->getM_rapportMappage());
			scenarProj->Ajouter(r3);
		}
		if (m_editCombo1 == "courante")
		{
			CReglePost *r3=new CReglePost("SAUVEGARDE_C",pProjParamTemp->getM_deltaDecoup(),pProjParamTemp->getM_rapportMappage());
			scenarProj->Ajouter(r3);
		}
	}

	if (m_check4)
	{
		if (m_editCombo2 == "d'origine")
		{
			CReglePost *r4=new CReglePost("SAUVEGARDE_LIGNES_O",pProjParamTemp->getM_deltaDecoup(),pProjParamTemp->getM_rapportMappage());
			scenarProj->Ajouter(r4);
		}
		if (m_editCombo2 == "courante")
		{
			CReglePost *r4=new CReglePost("SAUVEGARDE_LIGNES_C",pProjParamTemp->getM_deltaDecoup(),pProjParamTemp->getM_rapportMappage());
			scenarProj->Ajouter(r4);
		}
	}

	if (m_check5)
	{
		CReglePost *r5=new CReglePost("HTML",pProjParamTemp->getM_deltaDecoup(),pProjParamTemp->getM_rapportMappage());
		scenarProj->Ajouter(r5);
	}
}



void CDlgAssist4::OnBnClickedCheckAnaFineText()
{
	m_check1 = !m_check1;

	UpdateData(false); UpdateWindow();
}

void CDlgAssist4::OnBnClickedCheckFicXmlDicoForm()
{
	m_check2 = !m_check2;

	UpdateData(false); UpdateWindow();
}

void CDlgAssist4::OnBnClickedCheckImgLabel()
{
	m_check3 = !m_check3;

	UpdateData(false); UpdateWindow();
}

void CDlgAssist4::OnBnClickedCheckImgLigText()
{
	m_check4 = !m_check4;

	if(m_check4 == 1)
	{
		//on est oblige de faire l'analyse fine textuelle
		m_check1 = 1;
	}

	UpdateData(false); UpdateWindow();
}

void CDlgAssist4::OnBnClickedCheckHtml()
{
	m_check5 = !m_check5;

	UpdateData(false); UpdateWindow();
}



//Reglage des labels  exporter pour RETRO.
//ON regle les labels qui seront exports et le seuil associ  chaque label
void CDlgAssist4::OnBnClickedButton1()
{
	
	if (listeVal.size()>0)
		listeVal.clear();

	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CObList * listeLabel;
	listeLabel = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
	
	CDIALOGReglage *dlgReglage=new CDIALOGReglage(NULL,listeLabel,&listeVal);
	dlgReglage->DoModal();

}

void CDlgAssist4::OnStnClickedStaticSeuilEtp4()
{
	// TODO : ajoutez ici le code de votre gestionnaire de notification de contrle
}
