#pragma once

class CExportResultats
{
public:

	void EcrireToutesCaracGroupees(CString nomDeLEtiquette, CString nomDuDocument, CList<CString,CString&>* listeCarac);
	void EcrireChaqueCaracParFichier(CString nomDeLEtiquette, CString nomDuDocument, CString nomDeLaCaracteristique, CString valeurDeLaCaracteristique);

	void EcrireCalculs(CString nomDeLEtiquette, CList<double>* listeBorneInf, CList<double>* listeBorneSup, CList<double>* listeMin, CList<double>* listeMax, CList<double>* listeVariance, CList<double>* listeEcartType, CList<double>* listeMoyenne, CList<double>* listeMediane);
	void EcrireCalculsClasses(CString nomDeLEtiquette, CString classeSelection, CString classeVG, CString classeVD, CString classeVH, CString classeVB, CString classeVI);


	CString ConvertirCaracEnString(int valeurDeLaCaracteristique);
	CString ConvertirCaracEnString(double valeurDeLaCaracteristique);
	CString ConvertirCaracEnString(LONG valeurDeLaCaracteristique);
	CString ConvertirCaracEnString(CPoint* valeurDeLaCaracteristique);


	CExportResultats(void);
	~CExportResultats(void);
};
