/****************************************************************/
// Journal.cpp : implementation file
/****************************************************************/

#include "stdafx.h"
#include "myapp.h"
#include "Journal.h"
#include "mainfrm.h"
#include "constante.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/****************************************************************/
// CJournal dialog
/****************************************************************/

CJournal::CJournal(CWnd* pParent /*=NULL*/)
	: CDialog(CJournal::IDD, pParent)
{
	//CTabCtrl *tab=(CTabCtrl *)GetDlgItem(IDC_TAB);
	
	//CListBox *t = (CListBox *)GetDlgItem(IDC_LOG);
//	pl->SetHorizontalExtent(80000);
	//{{AFX_DATA_INIT(CJournal)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CJournal::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJournal)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CJournal, CDialog)
	//{{AFX_MSG_MAP(CJournal)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)							// Bouton Effacer de la zone journal
	ON_BN_CLICKED(IDC_UP, OnUp)									// Bouton Up de la zone journal
	ON_BN_CLICKED(IDC_DOWN, OnDown)								// Bouton Down de la zone journal	
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJournal message handlers

void CJournal::OnUp() 
{
	CListBox *pl=(CListBox *)GetDlgItem(IDC_LOG);
	int pos = pl->GetCurSel();

	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();
	bool nonfin = false;

	switch (typeLabo)
	{
	case LABOTRAIT :
		nonfin = pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Echanger(pos,pos-1);
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Afficher();
		break;
	case LABOCLASSIF :
		nonfin = pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Echanger(pos,pos-1);
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Afficher();
		break;
	case LABOPROJET :
		nonfin = pAppTemp->projet->getLaboProj()->getScenarioProj()->Echanger(pos,pos-1);
		pAppTemp->projet->getLaboProj()->getScenarioProj()->Afficher();
		break;
	default :
		AfxMessageBox("Error while moving a set of the journal");
		break;
	}

	if (nonfin) pl->SetCurSel(pos-1); else pl->SetCurSel(pos);
	
}

void CJournal::OnDown() 
{
	CListBox *pl=(CListBox *)GetDlgItem(IDC_LOG);
	int pos = pl->GetCurSel();

	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();
	bool nonfin = false;

	switch (typeLabo)
	{
	case LABOTRAIT :
		nonfin = pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Echanger(pos,pos+1);
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Afficher();
		break;
	case LABOCLASSIF :
		nonfin = pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Echanger(pos,pos+1);
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Afficher();
		break;
	case LABOPROJET :
		nonfin = pAppTemp->projet->getLaboProj()->getScenarioProj()->Echanger(pos,pos+1);
		pAppTemp->projet->getLaboProj()->getScenarioProj()->Afficher();
		break;
	default :
		AfxMessageBox("Error while moving journal");
		break;
	}

	if (nonfin) pl->SetCurSel(pos+1); else pl->SetCurSel(pos);
	
}

void CJournal::OnClear() 
{
	CListBox *pl=(CListBox *)GetDlgItem(IDC_LOG);
	int pos = pl->GetCurSel();

	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Effacer(pos);
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Afficher();
		break;
	case LABOCLASSIF :
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Effacer(pos);
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Afficher();
		break;
	case LABOPROJET :
		pAppTemp->projet->getLaboProj()->getScenarioProj()->Effacer(pos);
		pAppTemp->projet->getLaboProj()->getScenarioProj()->Afficher();
		break;
	default :
		AfxMessageBox("Error while erasing journal");
		break;
	}

	pl->SetCurSel(pos);
}

