#pragma once

#include "MyApp.h"
#include "ClassifAuto.h"



class CLaboClassif
{
private:

	CObList* listeDocsLaboClassif;
	CScenario* scenarioClassif;
	CClassifAuto* classifAuto;

	CObList *listeTypesClasse;

public:

	void ModeSelection();
	void UpdateModeSelection(CCmdUI* pCmdUI);
	void ModeZoom();
	void UpdateModeZoom(CCmdUI* pCmdUI);

	CScenario* getScenarioClassif(void){return scenarioClassif;}
	void setScenarioClassif(CScenario* scenarIn);

	CClassifAuto* getClassifAuto(){return classifAuto;}
	
	CObList* getListeTypesClasse(){return listeTypesClasse;}
	void getCopieListeTypesClasse(CObList* listeIn);
	void setListeTypesClasse(CObList* listeIn);
	void addElemListeTypesClasse(CTypeClasse* typeIn);
	bool findElemListeTypesClasse(CString t);
	bool supprElemListeTypesClasse(CTypeClasse* typeIn);
	void supprAllListeTypesClasse();
	

	CObList* getListeDocsLaboClassif(){return listeDocsLaboClassif;}
	void setListeDocuments(CObList* listeIn);
	void addElemListeDocuments(CMyAppDoc* docIn);
	bool supprElemListeDocuments(CMyAppDoc* docIn);
	void supprAllListeDocuments();

	void AfficherDocSuivant();
	void AfficherDocPrecedent();
	void RendreLeFocusALImageActive();

	void MajMenu();
	void RazClassifAuto();
	void OuvrirImagesLaboClassif();
	void ApplicationScenarioStartup();

	void ViderLabo();

	CLaboClassif(void);
	~CLaboClassif(void);
};
