#pragma once

#include "MyApp.h"
#include "MyAppDoc.h"


class CLaboProjet
{
private:

	CObList* listeDocsLaboProj;
	CScenario* scenarioProj;

	CObList *listeTypesClasse;

	

public:
	CListeCC* liste_permanente;
	bool appliOuvrDone;
	bool exportDone;

	void ModeZoom();
	void UpdateModeZoom(CCmdUI* pCmdUI);

	CScenario* getScenarioProj(void){return scenarioProj;}
	void setScenarioProj(CScenario* scenarIn);

	CObList* getListeTypesClasse(){return listeTypesClasse;}
	void setListeTypesClasse(CObList* listeIn);
	void addElemListeTypesClasse(CTypeClasse* typeIn);
	bool findElemListeTypesClasse(CString t);
	bool supprElemListeTypesClasse(CTypeClasse* typeIn);
	void supprAllListeTypesClasse();

	CObList* getListeDocsLaboProj(){return listeDocsLaboProj;}
	void setListeDocuments(CObList* listeIn);
	void addElemListeDocuments(CMyAppDoc* docIn);
	bool supprElemListeDocuments(CMyAppDoc* docIn);
	void supprAllListeDocuments();

	void AfficherDocSuivant();
	void AfficherDocPrecedent();
	void RendreLeFocusALImageActive();

	void MajMenu();
	void OuvrirTousDocsOuvrage();
	void ApplicationScenarioProjet();

	void ViderLabo();

	CLaboProjet(void);
	~CLaboProjet(void);
};
