/********************************************************************/
// ListeCC.h: interface for the CListeCC class.
//
// Gestion de la liste de composante connexe
// Permet de grer et manipuler une liste de CZones et notamment
// d'appliquer les fonctions de fusion et de recherche du plus proche
// voisin
//
/********************************************************************/

#if !defined(AFX_LISTECC_H__E8F0ECB4_068F_435E_981E_52BDEFE9EEB1__INCLUDED_)
#define AFX_LISTECC_H__E8F0ECB4_068F_435E_981E_52BDEFE9EEB1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/***********************/
//  INCLUSION
/***********************/

#include "Element.h"


/***********************/
//  CLASSE
/***********************/


class CListeCC  
{

private:

	CObList *liste;
	//CObList *liste_secondaire;
	CString type_zone;
	double seuil;
	int num_fichierCC;
	//int qte_limite; // variable qui permet de dterminer quand on doit allger la liste principale

public:

	int Similaire (CElement *e, CDocument* pDoc);
	//void AllegerListe ();
	void AmeliorerClassification ();
	void CreerFichierNbOccurence ();

	CObList* get_liste ();
	//CObList* get_liste_secondaire ();
	void set_type_zone (CString s);
	void set_seuil (double d);

	CListeCC();
	virtual ~CListeCC();

};





#endif // !defined(AFX_LISTECC_H__E8F0ECB4_068F_435E_981E_52BDEFE9EEB1__INCLUDED_)
