// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__E90E051C_9AC6_4A10_B5EC_18217C1C4673__INCLUDED_)
#define AFX_MAINFRM_H__E90E051C_9AC6_4A10_B5EC_18217C1C4673__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DialogTab.h"
#include "DialogAssistTab.h"

class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

// Attributes
public:
	//{{AFX_DATA(CMainFrame)
	enum { IDD = IDC_PROGRESS_CTRL };
	CProgressCtrl m_progBar;
	//}}AFX_DATA

// Operations
public:
	
	void ChangeStatusText(int pane,CString str,BOOL bupdate=true);
	void ChangeStatusStyle( int nIndex, UINT nID, UINT nStyle, int cxWidth );
	void RecupStatusRect(int nIndex, LPRECT lpRect );

	void CreerProgressBar();
	void DemarrerProgressBar(CString texte, int nbMax);
	void IncrementerProgressBar(CString texte="");


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
public:
	CDialogAssistTab  m_wndDlgAssistTab;
	CDialogTab  m_wndDlgTab;

	HICON m_hIcon;
	int MaxProgBar;


// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg HCURSOR OnQueryDragIcon();
	//}}AFX_MSG
	//afx_msg void OnUpdatePanels(CCmdUI *pCmdUI);

public:
	void CacherProgressBar();

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__E90E051C_9AC6_4A10_B5EC_18217C1C4673__INCLUDED_)
