// MyAppDoc.h : interface of the CMyAppDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYAPPDOC_H__444F1771_5BA6_4F8D_A371_66E0574468A9__INCLUDED_)
#define AFX_MYAPPDOC_H__444F1771_5BA6_4F8D_A371_66E0574468A9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000





#include "Atelier.h"

class CMyAppDoc : public CDocument
{
public: // create from serialization only
	CMyAppDoc();
	DECLARE_DYNCREATE(CMyAppDoc)

// Attributes
public:
	
	CString m_nom_complet;
	CString m_nom;
	CString m_extension;

	bool m_isReconnue;

	bool menuTrait;
	bool menuClassif;
	bool menuProj;

protected:


	bool m_Annuler; //si Annuler possible


// Operations
public:

	CAtelier *atelier;



	void SetAnnuler();
	void Annuler();
	bool IsAnnuler(){return m_Annuler;}
	void DonneInfo();

	bool ChargeImage(CString path);

	

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMyAppDoc)
	public:
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMyAppDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
public:

	

	
	

	//{{AFX_MSG(CMyAppDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

int pixel(int x,int y,PLWinBmp *BMP);
int ppixel(int x,int y,int val,PLWinBmp *BMP);


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYAPPDOC_H__444F1771_5BA6_4F8D_A371_66E0574468A9__INCLUDED_)
