/****************************************************************/
// MyAppView.cpp : implementation of the CMyAppView class
/****************************************************************/


/******************/
// INCLUSION
/******************/


#include "stdafx.h"
#include "MyApp.h"

#include<direct.h>
#include "MyAppDoc.h"
#include "MyAppView.h"
#include "MainFrm.h"

#include "BinDlg.h"
#include "ParamDlg.h"

#include "dialogfusion.h"
#include "DialogClassifGeo.h"
#include "DialogClassifVoisin.h"
#include "DialogClassifCar.h"
#include "DialogSuppType.h"
#include "DialogSuppInt.h"
#include "DialogParamTAO.h"
#include "DialogClassifChangeType.h"
#include "reglefusion.h"
#include "constante.h"
#include "Bloc.h"
#include "Image.h"
#include "ProjetParam.h"
#include ".\myappview.h"

/******************/
// PRECOMPILATION
/******************/

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/****************************************************************/
// CMyAppView
//
// Dclaration de la commande  lancer en cas d'action dans l'interface
// de l'application.
// On trouve l'ID de l'objet associ  la fonction qu'il lancera
// lors qu'il ce proiduira une action sur cet objet
//
/****************************************************************/



IMPLEMENT_DYNCREATE(CMyAppView, CScrollView)

BEGIN_MESSAGE_MAP(CMyAppView, CScrollView)

	//{{AFX_MSG_MAP(CMyAppView)
	ON_COMMAND(ID_PRINC_AFFICHAGE_INFO, OnAffInfo)
	ON_WM_SETCURSOR()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_AFF_CC, OnAfficheCC)							// Item Afficher les composantes connexes du sous menu Comp Connexes du menu traitement
	ON_UPDATE_COMMAND_UI(ID_AFF_CC, OnUpdateAfficheCC)
	ON_COMMAND(ID_PRINC_AFFICHAGE_CC, OnAfficheCC)							// Item Afficher les composantes connexes du sous menu Comp Connexes du menu traitement
	ON_UPDATE_COMMAND_UI(ID_PRINC_AFFICHAGE_CC, OnUpdateAfficheCC)
	ON_COMMAND(ID_AFF_ZONE, OnAffZone)							// Item Afficher les zones dcouvertes du sous menu Fusion du menu traitement
	ON_UPDATE_COMMAND_UI(ID_AFF_ZONE, OnUpdateAffZone)
	ON_COMMAND(ID_PRINC_AFFICHAGE_ZONES, OnAffZone)							// Item Afficher les zones dcouvertes du sous menu Fusion du menu traitement
	ON_UPDATE_COMMAND_UI(ID_PRINC_AFFICHAGE_ZONES, OnUpdateAffZone)
	ON_COMMAND(ID_BUTTON_IMG_ORG, OnImageOrg)						// Bouton affichage de l'image originale
	ON_UPDATE_COMMAND_UI(ID_BUTTON_IMG_ORG, OnUpdateImageOrg)
	ON_COMMAND(ID_PRINC_AFFICHAGE_IMG_ORG, OnImageOrg)						// Bouton affichage de l'image originale
	ON_UPDATE_COMMAND_UI(ID_PRINC_AFFICHAGE_IMG_ORG, OnUpdateImageOrg)
	ON_COMMAND(ID_BUTTON_IMG_COUR, OnImageCourante)				// Bouton affichage de l'image courante
	ON_UPDATE_COMMAND_UI(ID_BUTTON_IMG_COUR, OnUpdateImageCourante)	
	ON_COMMAND(ID_PRINC_AFFICHAGE_IMG_COUR, OnImageCourante)				// Bouton affichage de l'image courante
	ON_UPDATE_COMMAND_UI(ID_PRINC_AFFICHAGE_IMG_COUR, OnUpdateImageCourante)	
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_IMG,OnUpdateImageInd)

	ON_COMMAND(ID_DOC_EDIT_RETAB_IMG_ORG, OnDocEditRetablirImgOrigine)
	ON_COMMAND(ID_DOC_EDIT_COPIER, OnDocEditCopier)
	ON_COMMAND(ID_DOC_EDIT_COLLER, OnDocEditColler)
	ON_COMMAND(ID_DOC_TRAIT_BIN, OnDocTraitBin)
	ON_COMMAND(ID_DOC_TRAIT_BIN_NIBLACK, OnDocTraitBinNiblack)
	ON_COMMAND(ID_DOC_TRAIT_INV, OnDocTraitInv)
	ON_COMMAND(ID_DOC_TRAIT_PRET, OnDocTraitPret)
	ON_COMMAND(ID_DOC_TRAIT_MORPH_ERO, OnDocTraitMorphEro)
	ON_COMMAND(ID_DOC_TRAIT_MORPH_DIL, OnDocTraitMorphDil)
	ON_COMMAND(ID_DOC_TRAIT_MORPH_OUV, OnDocTraitMorphOuv)
	ON_COMMAND(ID_DOC_TRAIT_MORPH_FERM, OnDocTraitMorphFerm)
	ON_COMMAND(ID_DOC_TRAIT_CARTENDG_H, OnDocTraitCartendgH)
	ON_COMMAND(ID_DOC_TRAIT_CARTENDG_V, OnDocTraitCartendgV)
	ON_COMMAND(ID_DOC_TRAIT_CARTENDG_HV, OnDocTraitCartendgHv)
	ON_COMMAND(ID_DOC_TRAIT_CALCUL_CC, OnDocTraitCalculCc)
	ON_COMMAND(ID_DOC_TRAIT_FUSION_GLOB, OnDocTraitFusionGlob)
	ON_COMMAND(ID_DOC_TRAIT_FUS_FH_NORM, OnDocTraitFusFhNorm)
	ON_COMMAND(ID_DOC_TRAIT_FUS_FH_CDG, OnDocTraitFusFhCdg)
	ON_COMMAND(ID_DOC_TRAIT_FUS_FV_NORM, OnDocTraitFusFvNorm)
	ON_COMMAND(ID_DOC_TRAIT_FUS_FV_CDG, OnDocTraitFusFvCdg)
	ON_COMMAND(ID_DOC_TRAIT_RAFRAICH_CARAC, OnDocTraitRafraichCarac)
	ON_COMMAND(ID_DOC_CLASSIF_CHANGE_TYPE, OnDocClassifChangeType)
	ON_COMMAND(ID_DOC_CLASSIF_GEO, OnDocClassifGeo)
	ON_COMMAND(ID_DOC_CLASSIF_VOIS, OnDocClassifVois)
	ON_COMMAND(ID_DOC_CLASSIF_CARAC_CC, OnDocClassifCaracCc)
	ON_COMMAND(ID_DOC_CLASSIF_SUPP_ZONE, OnDocClassifSuppZone)
	ON_COMMAND(ID_DOC_CLASSIF_SUPP_INTER_ZONE, OnDocClassifSuppInterZone)
	ON_COMMAND(ID_DOC_OUTILS_APPL_OUVR, OnDocOutilsApplOuvr)

	ON_UPDATE_COMMAND_UI(ID_DOC_EDIT_RETAB_IMG_ORG, OnUpdateDocEditRetablirImgOrigine)
	ON_UPDATE_COMMAND_UI(ID_DOC_EDIT_COPIER, OnUpdateDocEditCopier)
	ON_UPDATE_COMMAND_UI(ID_DOC_EDIT_COLLER, OnUpdateDocEditColler)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_BIN, OnUpdateDocTraitBin)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_BIN_NIBLACK, OnUpdateDocTraitBinNiblack)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_INV, OnUpdateDocTraitInv)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_PRET, OnUpdateDocTraitPret)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_MORPH_ERO, OnUpdateDocTraitMorphEro)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_MORPH_DIL, OnUpdateDocTraitMorphDil)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_MORPH_OUV, OnUpdateDocTraitMorphOuv)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_MORPH_FERM, OnUpdateDocTraitMorphFerm)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_CARTENDG_H, OnUpdateDocTraitCartendgH)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_CARTENDG_V, OnUpdateDocTraitCartendgV)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_CARTENDG_HV, OnUpdateDocTraitCartendgHv)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_CALCUL_CC, OnUpdateDocTraitCalculCc)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_FUSION_GLOB, OnUpdateDocTraitFusionGlob)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_FUS_FH_NORM, OnUpdateDocTraitFusFhNorm)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_FUS_FH_CDG, OnUpdateDocTraitFusFhCdg)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_FUS_FV_NORM, OnUpdateDocTraitFusFvNorm)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_FUS_FV_CDG, OnUpdateDocTraitFusFvCdg)
	ON_UPDATE_COMMAND_UI(ID_DOC_TRAIT_RAFRAICH_CARAC, OnUpdateDocTraitRafraichCarac)
	ON_UPDATE_COMMAND_UI(ID_DOC_CLASSIF_CHANGE_TYPE, OnUpdateDocClassifChangeType)
	ON_UPDATE_COMMAND_UI(ID_DOC_CLASSIF_GEO, OnUpdateDocClassifGeo)
	ON_UPDATE_COMMAND_UI(ID_DOC_CLASSIF_VOIS, OnUpdateDocClassifVois)
	ON_UPDATE_COMMAND_UI(ID_DOC_CLASSIF_CARAC_CC, OnUpdateDocClassifCaracCc)
	ON_UPDATE_COMMAND_UI(ID_DOC_CLASSIF_SUPP_ZONE, OnUpdateDocClassifSuppZone)
	ON_UPDATE_COMMAND_UI(ID_DOC_CLASSIF_SUPP_INTER_ZONE, OnUpdateDocClassifSuppInterZone)
	ON_UPDATE_COMMAND_UI(ID_DOC_OUTILS_APPL_OUVR, OnUpdateDocOutilsApplOuvr)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_DISPLAY_RAMEL, OnDisplayRamel)
END_MESSAGE_MAP()


CMyAppView::CMyAppView():m_selectionmode(false),m_zoommode(false),m_zoomcoeff(1)
{
	// TODO: add construction code here
	m_hauteur=GetSystemMetrics(SM_CYFULLSCREEN);
	m_largeur=GetSystemMetrics(SM_CXFULLSCREEN);
	
	m_curZoom=AfxGetApp()->LoadCursor(IDC_ZOOM);
	track=false;
	index = -1;
	P1=(0,0);
	P2=(0,0);

	affiche_cc = false;
	affiche_zone = false;

	Image_Copiee = false;
	Courante_ou_Origine = false;
	EnableToolTips(true);

	m_selectionDone = false;
}

CMyAppView::~CMyAppView()
{
	if(m_curZoom!=NULL) DestroyCursor(m_curZoom);
}

BOOL CMyAppView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

void CMyAppView::OnDraw(CDC* pDC)
{
	CMyAppDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	//permet de surligner la zone slectionne dans la liste
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CClassifAuto* classifTemp = pAppTemp->projet->getLaboClassif()->getClassifAuto();

	CPoint *offset=new CPoint(CScrollView::GetScrollPosition());

	//if (Courante_ou_Origine) pDoc->atelier->Afficher_Image_Courante(pDC,m_zoomcoeff);
	//else pDoc->atelier->Afficher_Image_Origine(pDC,m_zoomcoeff);
    pDoc->atelier->Afficher_Image_Origine(pDC,m_zoomcoeff);

	if (affiche_cc) pDoc->atelier->Affiche_CC(pDC,m_zoomcoeff,index);
	if (affiche_zone) pDoc->atelier->Affiche_Zone(pDC,m_zoomcoeff);

	//affiche en entour jaune les zones slectionnes
	pDoc->atelier->liste_de_zones->AfficherZonesSelectionnees(pDC,m_zoomcoeff,pDoc);

	//affiche en quadrill violet la zone selectionne (dans la liste)
	classifTemp->SurlignerZoneSel(this);

	if (m_selectionmode && !m_selectionDone)
	{
		/*P1.x -= offset->x;
		P1.y -= offset->y;
		P2.x -= offset->x;
		P2.y -= offset->y;*/
	//CBrush *brush=new CBrush(HS_DIAGCROSS,RGB(200,100,255));
		CPen *pen=new CPen(PS_SOLID,10,RGB(255,255,0));
		pDC->Draw3dRect(CRect(P1,P2),212,212);
		//ecran->FillRect(r,brush);
		//pDC->DrawEdge(CRect(P1,P2),EDGE_BUMP,BF_RECT);
		//pDC->FrameRect( CRect(P1,P2), brush );
		//ecran->Rectangle(x1,y1,xf,yf);
	//pDC->FillRect(CRect(P1,P2),brush);
		//pDC->Rectangle(CRect(P1,P2));
		//pDC->Draw3dRect(CRect(P1,P2),0,0);
	}

	CSize taille;
	taille.cx=(long)(pDoc->atelier->getImageCourante()->getLargeur()*m_zoomcoeff);
	taille.cy=(long)(pDoc->atelier->getImageCourante()->getHauteur()*m_zoomcoeff);

	SetScrollSizes(MM_TEXT,taille);	
}

void CMyAppView::GriserMenuTrait()
{
	GetDocument()->menuTrait = false;
}

void CMyAppView::GriserMenuClassif()
{
	GetDocument()->menuClassif = false;
}

void CMyAppView::GriserMenuProj()
{
	GetDocument()->menuProj = false;
}

void CMyAppView::DeGriserMenuTrait()
{
	GetDocument()->menuTrait = true;
}

void CMyAppView::DeGriserMenuClassif()
{
	GetDocument()->menuClassif = true;
}

void CMyAppView::DeGriserMenuProj()
{
	GetDocument()->menuProj = true;
}

void CMyAppView::IncZoomCoeff(bool val)
{
	if(val)
	{
		m_zoomcoeff*=1.1;
	}
	else
	{
		m_zoomcoeff*=0.9;
	}
}

#ifdef _DEBUG


void CMyAppView::AssertValid() const
{
	CView::AssertValid();
}

void CMyAppView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMyAppDoc* CMyAppView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMyAppDoc)));
	return (CMyAppDoc*)m_pDocument;
}


#endif //_DEBUG

void CMyAppView::OnInitialUpdate() 
{
	CScrollView::OnInitialUpdate();

	CMyAppDoc * pDoc=GetDocument();
	ASSERT_VALID(pDoc);

	if(pDoc->atelier->getImageCourante()->getPointeur()!=NULL){

		CSize Taille(pDoc->atelier->getImageCourante()->getTaille());	// Recupre la taille de l'image

		SetScrollSizes(MM_TEXT,Taille);	// Applique la taille max aux scrollbars

		ResizeParentToFit();	// Colle les bord de la fenetre a l'image quand elle est plus petite que l'cran

		CRect rect;

		GetClientRect(&rect);

		double largeur_zone_cliente = rect.Width();

		m_zoomcoeff =  largeur_zone_cliente / pDoc->atelier->getImageCourante()->getLargeur();

		((CMainFrame*)AfxGetMainWnd())->ChangeStatusStyle(1,ID_INDICATOR_IMG,SBPS_NORMAL,100);
	}
	else{
		SetScrollSizes(MM_TEXT,CSize(0,0));
	}

	//pour afficher le document en maximis  l'ouverture
	((CMDIChildWnd *)GetParentFrame())->MDIMaximize();
}

void CMyAppView::OnUpdateImageInd(CCmdUI *pCmdUI)
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	pCmdUI->SetText(pDoc->GetTitle());
}

void CMyAppView::OnAffInfo() 
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->DonneInfo();
}

BOOL CMyAppView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if(nHitTest!=HTCLIENT)
		return CScrollView::OnSetCursor(pWnd, nHitTest, message);

	if(m_zoommode){
		SetCursor(m_curZoom);
	}
	else{
		if(m_selectionmode)
		{
			SetCursor(::LoadCursor(NULL, IDC_CROSS));
		}
		else
		{
			::LoadCursor(NULL, IDC_ARROW);
		}
	}
	return true;
}

void CMyAppView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if(IsZoom()){ 
		IncZoomCoeff();
	}
	else
	{
		/*CMyAppDoc *pDoc=GetDocument();
		ASSERT_VALID(pDoc);
		CDC *pdc = this->GetDC();*/

		if (IsSelection())
		{
			m_selectionDone = false;

			CPoint *offset=new CPoint(CScrollView::GetScrollPosition());
			point.x = (long)((point.x+offset->x));
			point.y = (long)((point.y+offset->y) );

			P1.x=point.x;
			//P1.x *= m_zoomcoeff;
			P1.y=point.y;
			//P1.y *= m_zoomcoeff;
			P2.x=point.x;
			//P2.x *= m_zoomcoeff;
			P2.y=point.y;
			//P2.y *= m_zoomcoeff;
			track=true;
		}
	}
	Invalidate(true);
	CScrollView::OnLButtonDown(nFlags, point);
}

void CMyAppView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CScrollView::OnMouseMove(nFlags, point);
	CPoint *offset=new CPoint(CScrollView::GetScrollPosition());

	
	CPoint cherche((long)((point.x+offset->x) / m_zoomcoeff),(long)((point.y+offset->y) / m_zoomcoeff));


	CDC *ecran=this->GetDC();
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->atelier->liste_de_zones->CherchePoint(&cherche,ecran,m_zoomcoeff);
	


	/*CToolTipCtrl *t=new CToolTipCtrl();
	t->Create(this,TTS_ALWAYSTIP);
	t->AddTool(this,"dsfsdfsdf");*/

	CRect r(P1,P2);
	r.NormalizeRect();
	if (track)
	{
	
		P2.x = (long)((point.x+offset->x) );
		P2.y = (long)((point.y+offset->y) );
		
		//this->InvalidateRect(r,true);
		Invalidate();
	}
	delete offset;
	this->ReleaseDC(ecran);
}

void CMyAppView::OnAfficheCC() 
{
	if (affiche_cc) affiche_cc=false;
	else affiche_cc=true;
	Invalidate(true);

}

void CMyAppView::OnUpdateAfficheCC(CCmdUI* pCmdUI) 
{
	CMyAppDoc* pDocTemp = (CMyAppDoc*)GetDocument();
	pCmdUI->SetCheck(affiche_cc);	
}

void CMyAppView::OnAffZone() 
{
	if (affiche_zone) affiche_zone=false;
	else affiche_zone=true;
	Invalidate(true);
}

void CMyAppView::OnUpdateAffZone(CCmdUI* pCmdUI) 
{
	CMyAppDoc* pDocTemp = (CMyAppDoc*)GetDocument();
	pCmdUI->SetCheck(affiche_zone);
	
}

void CMyAppView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	if(IsZoom()) IncZoomCoeff(false);
	else
	{
		CMyAppDoc *pDoc=GetDocument();
		ASSERT_VALID(pDoc);
		CDC *pdc = this->GetDC();
	}

	this->Invalidate(true);
	CScrollView::OnRButtonDown(nFlags, point);
}

void CMyAppView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	//rien
}


void CMyAppView::OnLButtonUp(UINT nFlags, CPoint point)
{
	if(IsZoom())
	{
		return;
	}
	else
	{
		if(IsSelection())
		{
			CPoint *offset=new CPoint(CScrollView::GetScrollPosition());
			point.x = (long)((point.x+offset->x) );
			point.y = (long)((point.y+offset->y) );

			P2.x=point.x;
			//P2.x *= m_zoomcoeff;
			P2.y=point.y;
			//P2.y *= m_zoomcoeff;
			track=false;
			//::ReleaseCapture();
			::SetCursor(::LoadCursor(NULL, IDC_ARROW));


			CPoint P1bis;
			CPoint P2bis;

			P1bis.x = (P1.x)/(m_zoomcoeff);
			P1bis.y = (P1.y)/(m_zoomcoeff);
			P2bis.x = (P2.x)/(m_zoomcoeff);
			P2bis.y = (P2.y)/(m_zoomcoeff);

			m_selectionDone = true;

			CDC *pDC = this->GetDC();
			
			CRect* rectangleSelection = new CRect(P1bis,P2bis);
			rectangleSelection->NormalizeRect();

			CMyAppDoc *pDoc=GetDocument();
			ASSERT_VALID(pDoc);

			pDoc->atelier->liste_de_zones->ChercherNumZonesSelectionnees(rectangleSelection);
			//pDoc->imageOrigine->listeDeZones->AfficherZonesSelectionnees(pDC,m_zoomcoeff);
			//fonction insre dans OnDraw() car OnDraw() est appele  chaque rafrachissement 
			//donc elle est excute aprs OnLButtonUp()

			m_selectionDone = true;

			this->Invalidate(true);
			CScrollView::OnLButtonUp(nFlags, point);
		}
	}
}

void CMyAppView::OnImageOrg() 
{

	if (!Courante_ou_Origine) Courante_ou_Origine=true;
	else Courante_ou_Origine=false;

	Invalidate(true);

	CMDIChildWnd * pChild = ((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	pChild->SetFocus();

}

void CMyAppView::OnUpdateImageOrg(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(!Courante_ou_Origine);	
}

void CMyAppView::OnImageCourante() 
{

	if (Courante_ou_Origine) Courante_ou_Origine=false;
	else Courante_ou_Origine=true;

	Invalidate(true);

	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		pAppTemp->projet->getLaboTrait()->RendreLeFocusALImageActive();
		break;
	case LABOCLASSIF :
		pAppTemp->projet->getLaboClassif()->RendreLeFocusALImageActive();
		break;
	case LABOPROJET :
		pAppTemp->projet->getLaboProj()->RendreLeFocusALImageActive();
		break;
	default :
		AfxMessageBox("Error while loading current image");
		break;
	}
}

void CMyAppView::OnUpdateImageCourante(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(Courante_ou_Origine);
}

void CMyAppView::OnDocEditRetablirImgOrigine()
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	//collage de l'image d'origine dans l'image courante
	CRegleSR *r1 = new CRegleSR(2);

	switch (typeLabo)
	{
	case LABOTRAIT :
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
		break;
	case LABOCLASSIF :
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
		break;
	case LABOPROJET :
		break;
	default :
		break;
	}

	r1->Executer(pDoc);
	Invalidate(true);
}

void CMyAppView::OnDocEditCopier()
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	//copie de l'image courante dans l'image temporaire
	CRegleSR *r1 = new CRegleSR(0);

	switch (typeLabo)
	{
	case LABOTRAIT :
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
		break;
	case LABOCLASSIF :
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
		break;
	case LABOPROJET :
		break;
	default :
		break;
	}
	
	r1->Executer(pDoc);
	Image_Copiee = true;
}

void CMyAppView::OnDocEditColler()
{
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	//collage de l'image temporaire dans l'image courante
	CRegleSR *r1 = new CRegleSR(1);

	switch (typeLabo)
	{
	case LABOTRAIT :
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
		break;
	case LABOCLASSIF :
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
		break;
	case LABOPROJET :
		break;
	default :
		break;
	}

	r1->Executer(pDoc);
	Invalidate(true);
}

void CMyAppView::OnDocTraitBin()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);

	CBinDlg *Dlg;

	int largeur = pDoc->atelier->getImageCourante()->getLargeur();
	int hauteur = pDoc->atelier->getImageCourante()->getHauteur();

	if (P1.x/m_zoomcoeff <0 ) P1.x = 0;
	if (P1.y/m_zoomcoeff <0 ) P1.y = 0;
	if (P2.x/m_zoomcoeff <0 ) P2.x = 0;
	if (P2.y/m_zoomcoeff <0 ) P2.y = 0;
	if (P1.x/m_zoomcoeff > largeur) P1.x= largeur*m_zoomcoeff;
	if (P2.x/m_zoomcoeff > largeur) P2.x= largeur*m_zoomcoeff;
	if (P1.y/m_zoomcoeff > hauteur) P1.y= hauteur*m_zoomcoeff;
	if (P2.y/m_zoomcoeff > hauteur) P2.y= hauteur*m_zoomcoeff;
		
	Dlg=new CBinDlg(this,CRect(P1.x/m_zoomcoeff,P1.y/m_zoomcoeff,P2.x/m_zoomcoeff,P2.y/m_zoomcoeff));
	Dlg->DoModal();
	
	this->Invalidate(false);
}

void CMyAppView::OnDocTraitBinNiblack()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);

	CRegleBin *r1=new CRegleBin(-1);
	((CMyAppApp*)AfxGetApp())->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
	r1->Executer(pDoc);
}

void CMyAppView::OnDocTraitInv()
{
	CMyAppDoc * pDoc=GetDocument();
	ASSERT_VALID(pDoc);

	CRegleMorph *r1=new CRegleMorph("INVERSION");
	((CMyAppApp*)AfxGetApp())->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
	r1->Executer(pDoc);

	this->Invalidate(false);	
}

void CMyAppView::OnDocTraitPret()
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	CProjetParam* pProjParamTemp = pAppTemp->projet->getParamProj();
	CScenario* scenar = pAppTemp->projet->getLaboTrait()->getScenarioTrait();
	//listeTypesCLasse utilise pour R5 : dans LaboTrait
	
	CMyAppDoc * pDoc=GetDocument();
	ASSERT_VALID(pDoc);


// Binarisation-R1
	CRegleBin *r1;	// dfini rgle binarisation
	if (!pProjParamTemp->getM_binAuto()) r1=new CRegleBin(pProjParamTemp->getM_seuilBinarisation());	// cration rgle binarisation : si AUTO non coch cration
	else r1=new CRegleBin(-1);							// rgle avec seuil sinon cration rgle sans seuil (mode auto)
	scenar->Ajouter(r1);
	r1->Executer(pDoc);


// Detection de contours-R2
	CRegleContour *r2=new CRegleContour(pProjParamTemp->getM_pteCcLarg(),pProjParamTemp->getM_pteCcHaut(),pProjParamTemp->getM_gdeCcLarg(),pProjParamTemp->getM_gdeCcHaut());
	scenar->Ajouter(r2);
	r2->Executer(pDoc);


// Suppression du bruit-R3
	CRegleSupType *r3=new CRegleSupType("BRUIT",BLANC, true);
	scenar->Ajouter(r3);
	r3->Executer(pDoc);


// Suppression des intersections de type image-R4
	CRegleIntersection *r4=new CRegleIntersection("IMAGE");
	scenar->Ajouter(r4);
	r4->Executer(pDoc);

// Cration du nouveau type TEXTEI (texte inclus dans image) - R5
	if (!pAppTemp->projet->getLaboTrait()->findElemListeTypesClasse("TEXTEI"))
	{
		CRegleType *r5=new CRegleType("TEXTEI",RGB(0,255,0));
		scenar->Ajouter(r5);
		r5->Executer(pDoc);
	}


// On nomme textei les zones texte incluses dans une zone de type image - R6

	CList<CString,CString> *li = new CList<CString,CString>();
	CList<CString,CString> *lg = new CList<CString,CString>();
	CList<CString,CString> *ld = new CList<CString,CString>();
	CList<CString,CString> *lh = new CList<CString,CString>();
	CList<CString,CString> *lb = new CList<CString,CString>();
	li->AddTail("IMAGE");
	li->AddTail("TEXTEI");

	CRegleCV *r6=new CRegleCV("TEXTE",lg,ld,lh,lb,li,"TEXTEI","TEXTE");
	scenar->Ajouter(r6);
	r6->Executer(pDoc);
	

// Segmentation image/texte - R7
	if (!pProjParamTemp->getM_traitTexte()) 
	{
		CRegleSupType *r7=new CRegleSupType("TEXTEI",INCOLOR,true);
		scenar->Ajouter(r7);
		r7->Executer(pDoc);
	}
	else pDoc->atelier->SegmentationImageTexte();
	
	affiche_zone=true;
	affiche_cc=true;
	this->Invalidate(true);
}

void CMyAppView::OnDocTraitMorphEro()
{
	CMyAppDoc * pDoc=GetDocument();
	ASSERT_VALID(pDoc);

	CRegleMorph *r1=new CRegleMorph("EROSION");
	((CMyAppApp*)AfxGetApp())->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
	r1->Executer(pDoc);

	this->Invalidate(false);
}

void CMyAppView::OnDocTraitMorphDil()
{
	CMyAppDoc * pDoc=GetDocument();
	ASSERT_VALID(pDoc);

	CRegleMorph *r1=new CRegleMorph("DILATATION");
	((CMyAppApp*)AfxGetApp())->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
	r1->Executer(pDoc);

	this->Invalidate(false);
}

void CMyAppView::OnDocTraitMorphOuv()
{
	CMyAppDoc * pDoc=GetDocument();
	ASSERT_VALID(pDoc);

	CRegleMorph *r1=new CRegleMorph("OUVERTURE");
	((CMyAppApp*)AfxGetApp())->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
	r1->Executer(pDoc);
	
	this->Invalidate(false);
}

void CMyAppView::OnDocTraitMorphFerm()
{
	CMyAppDoc * pDoc=GetDocument();
	ASSERT_VALID(pDoc);

	CRegleMorph *r1=new CRegleMorph("FERMETURE");
	((CMyAppApp*)AfxGetApp())->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
	r1->Executer(pDoc);

	this->Invalidate(false);
}

void CMyAppView::OnDocTraitCartendgH()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->atelier->PlageHorizontale();
}

void CMyAppView::OnDocTraitCartendgV()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->atelier->PlageVerticale();
}

void CMyAppView::OnDocTraitCartendgHv()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);

	CReglePlage *r1=new CReglePlage();
	((CMyAppApp*)AfxGetApp())->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
	r1->Executer(pDoc);

	affiche_cc=true;
	this->Invalidate(true);
}

void CMyAppView::OnDocTraitCalculCc()
{
	CMyAppDoc * pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	CProjetParam* pProjParamTemp = ((CMyAppApp*)AfxGetApp())->projet->getParamProj();

	CRegleContour *r1=new CRegleContour(pProjParamTemp->getM_pteCcLarg(),pProjParamTemp->getM_pteCcHaut(),pProjParamTemp->getM_gdeCcLarg(),pProjParamTemp->getM_gdeCcHaut());
	((CMyAppApp*)AfxGetApp())->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
	r1->Executer(pDoc);

	affiche_cc=true;
	this->Invalidate(false);
}

void CMyAppView::OnDocTraitFusionGlob()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	CProjetParam* pProjParamTemp = ((CMyAppApp*)AfxGetApp())->projet->getParamProj();
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;

	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	// Fusion horizontale
	CRegleFusion *r1=new CRegleFusion('H', pProjParamTemp->getM_seuilH(), false, "TEXTE");
	// Fusion verticale
	CRegleFusion *r2=new CRegleFusion('V', pProjParamTemp->getM_seuilV(), false, "TEXTE");
	//ajouter la regle de calcul des caracteristiques
	CRegleCarac *r4=new CRegleCarac();

	if (typeLabo == LABOTRAIT)
	{
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r2);
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r4);

		CObList* listDocs = pAppTemp->projet->getLaboTrait()->getListeDocsLaboTrait();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			CMyAppDoc* pDoc = (CMyAppDoc*)listDocs->GetNext(posDoc);
			r1->Executer(pDoc);
			r2->Executer(pDoc);
			r4->Executer(pDoc);
		}
	}

	if (typeLabo == LABOCLASSIF)
	{
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r2);
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r4);

		CObList* listDocs = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			CMyAppDoc* pDoc = (CMyAppDoc*)listDocs->GetNext(posDoc);
			r1->Executer(pDoc);
			r2->Executer(pDoc);
			r4->Executer(pDoc);
		}
	}

	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();

	affiche_zone=true;
	this->Invalidate(true);	
}

void CMyAppView::OnDocTraitFusFhNorm()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	CProjetParam* pProjParamTemp = ((CMyAppApp*)AfxGetApp())->projet->getParamProj();
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;

	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	CDialogFusion cdf(this,"Choisissez le paramtre de fusion horizontale :",pProjParamTemp->getM_seuilH());
	if (cdf.DoModal()!=IDOK ) return;
	
	CRegleFusion *r1=new CRegleFusion('H',cdf.m_edit,false,cdf.m_liste);
	//ajouter la regle de calcul des caracteristiques
	CRegleCarac *r4=new CRegleCarac();

	if (typeLabo == LABOTRAIT)
	{
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r4);

		CObList* listDocs = pAppTemp->projet->getLaboTrait()->getListeDocsLaboTrait();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			CMyAppDoc* pDoc = (CMyAppDoc*)listDocs->GetNext(posDoc);
			r1->Executer(pDoc);
			r4->Executer(pDoc);
		}
	}

	if (typeLabo == LABOCLASSIF)
	{
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r4);

		CObList* listDocs = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			CMyAppDoc* pDoc = (CMyAppDoc*)listDocs->GetNext(posDoc);
			r1->Executer(pDoc);
			r4->Executer(pDoc);
		}
	}

	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();

	affiche_zone=true;
	this->Invalidate(true);	
}

void CMyAppView::OnDocTraitFusFhCdg()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	CProjetParam* pProjParamTemp = ((CMyAppApp*)AfxGetApp())->projet->getParamProj();
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;

	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	CDialogFusion cdf(this,"Choisissez le paramtre de fusion horizontale (CDG):",pProjParamTemp->getM_seuilH());
	if (cdf.DoModal()!=IDOK ) return;

	CRegleFusion *r1=new CRegleFusion('H',cdf.m_edit,true);
	//ajouter la regle de calcul des caracteristiques
	CRegleCarac *r4=new CRegleCarac();

	if (typeLabo == LABOTRAIT)
	{
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r4);

		CObList* listDocs = pAppTemp->projet->getLaboTrait()->getListeDocsLaboTrait();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			CMyAppDoc* pDoc = (CMyAppDoc*)listDocs->GetNext(posDoc);
			r1->Executer(pDoc);
			r4->Executer(pDoc);
		}
	}

	if (typeLabo == LABOCLASSIF)
	{
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r4);

		CObList* listDocs = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			CMyAppDoc* pDoc = (CMyAppDoc*)listDocs->GetNext(posDoc);
			r1->Executer(pDoc);
			r4->Executer(pDoc);
		}
	}

	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();

	affiche_zone=true;
	this->Invalidate(true);	
}

void CMyAppView::OnDocTraitFusFvNorm()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	CProjetParam* pProjParamTemp = ((CMyAppApp*)AfxGetApp())->projet->getParamProj();
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;

	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	CDialogFusion cdf(this,"Choisissez le paramtre de fusion verticale :",pProjParamTemp->getM_seuilH());
	if (cdf.DoModal()!=IDOK ) return;

	CRegleFusion *r1=new CRegleFusion('V',cdf.m_edit,false,cdf.m_liste);
	//ajouter la regle de calcul des caracteristiques
	CRegleCarac *r4=new CRegleCarac();

	if (typeLabo == LABOTRAIT)
	{
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r4);

		CObList* listDocs = pAppTemp->projet->getLaboTrait()->getListeDocsLaboTrait();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			CMyAppDoc* pDoc = (CMyAppDoc*)listDocs->GetNext(posDoc);
			r1->Executer(pDoc);
			r4->Executer(pDoc);
		}
	}

	if (typeLabo == LABOCLASSIF)
	{
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r4);

		CObList* listDocs = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			CMyAppDoc* pDoc = (CMyAppDoc*)listDocs->GetNext(posDoc);
			r1->Executer(pDoc);
			r4->Executer(pDoc);
		}
	}

	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();

	affiche_zone=true;
	this->Invalidate(true);	
}

void CMyAppView::OnDocTraitFusFvCdg()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	CProjetParam* pProjParamTemp = ((CMyAppApp*)AfxGetApp())->projet->getParamProj();
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	int typeLabo = 0;

	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	CDialogFusion cdf(this,"Choisissez le paramtre de fusion verticale (CDG) :",pProjParamTemp->getM_seuilH());
	if (cdf.DoModal()!=IDOK ) return;

	CRegleFusion *r1=new CRegleFusion('V',cdf.m_edit,true);
	//ajouter la regle de calcul des caracteristiques
	CRegleCarac *r4=new CRegleCarac();

	if (typeLabo == LABOTRAIT)
	{
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
		pAppTemp->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r4);

		CObList* listDocs = pAppTemp->projet->getLaboTrait()->getListeDocsLaboTrait();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			CMyAppDoc* pDoc = (CMyAppDoc*)listDocs->GetNext(posDoc);
			r1->Executer(pDoc);
			r4->Executer(pDoc);
		}
	}

	if (typeLabo == LABOCLASSIF)
	{
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
		pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r4);

		CObList* listDocs = pAppTemp->projet->getLaboClassif()->getListeDocsLaboClassif();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			CMyAppDoc* pDoc = (CMyAppDoc*)listDocs->GetNext(posDoc);
			r1->Executer(pDoc);
			r4->Executer(pDoc);
		}
	}

	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();

	affiche_zone=true;
	this->Invalidate(true);	
}

void CMyAppView::OnDocTraitRafraichCarac()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);

	if (!pDoc->atelier->liste_de_zones->liste->IsEmpty())
	{
		//ajouter la regle de calcul des caracteristiques
		CRegleCarac *r1=new CRegleCarac();
		((CMyAppApp*)AfxGetApp())->projet->getLaboTrait()->getScenarioTrait()->Ajouter(r1);
		r1->Executer(pDoc);
	}else
	{
		AfxMessageBox("Please compute CC extaction before");
	}
}

void CMyAppView::OnDocClassifGeo()
{
	CDialogClassifGeo *ccg=new CDialogClassifGeo(this);
	ccg->DoModal();
	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();
}

void CMyAppView::OnDocClassifVois()
{
	CDialogClassifVoisin *ccv=new CDialogClassifVoisin(this);
	ccv->DoModal();
	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();
}

void CMyAppView::OnDocClassifCaracCc()
{
	CDialogClassifCar *ccc=new CDialogClassifCar(this);
	ccc->DoModal();
	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();
}

void CMyAppView::OnDocClassifSuppZone()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	CAtelier *atelier = pDoc->atelier;

	CDialogSuppType cdst(this);
	if (cdst.DoModal()!=IDOK ) return;

	int couleur = cdst.m_radio;
	CString type = cdst.m_liste;
	bool suppression = cdst.m_sup;

	if (cdst.m_radio == 0) couleur = NOIR;
	if (cdst.m_radio == 1) couleur = BLANC;
	if (cdst.m_radio == 2) couleur = INCOLOR;

	CRegleSupType *r1=new CRegleSupType(type,couleur,suppression);
	((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
	CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getListeDocsLaboClassif();
	POSITION posDoc = listDocs->GetHeadPosition();
	while (posDoc)
	{
		r1->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
	}

	//ajouter la regle de calcul des caracteristiques
	CRegleCarac *r4=new CRegleCarac();
	((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r4);
	posDoc = listDocs->GetHeadPosition();
	while (posDoc)
	{
		r4->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
	}
	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();
}

void CMyAppView::OnDocClassifSuppInterZone()
{
	CMyAppDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	CAtelier *atelier = pDoc->atelier;

	CDialogSuppInt cdsi(this);
	if (cdsi.DoModal()!=IDOK ) return;

	CString type = cdsi.m_liste;

	CRegleIntersection *r1=new CRegleIntersection(type);
	((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
	CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getListeDocsLaboClassif();
	POSITION posDoc = listDocs->GetHeadPosition();
	while (posDoc)
	{
		r1->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
	}

	//ajouter la regle de calcul des caracteristiques
	CRegleCarac *r4=new CRegleCarac();
	((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r4);
	posDoc = listDocs->GetHeadPosition();
	while (posDoc)
	{
		r4->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
	}
	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();
}

void CMyAppView::OnDocClassifChangeType()
{
	CDialogClassifChangeType *fenetre=new CDialogClassifChangeType(this);
	fenetre->DoModal();

	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();
}

void CMyAppView::OnDocOutilsApplOuvr()
{
	CMyAppApp *pAppTemp = ((CMyAppApp*)AfxGetApp());

	//ajout des rgles correspondantes aux choix faits dans les cases de
	//l'tape 4 de l'assistant:
	((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.getm_assist4()->CreerReglesExport();

	//application du scnario cr dans l'tape prcdente sur toutes les images contenues dans le
	//rpertoire de l'ouvrage (vidage de la liste type classes avant) :
	pAppTemp->projet->getLaboProj()->getListeTypesClasse()->RemoveAll();
	pAppTemp->projet->getLaboProj()->ApplicationScenarioProjet();
	((CMyAppApp*)AfxGetApp())->ChargerDocSelectionne();
}



void CMyAppView::OnUpdateDocEditRetablirImgOrigine(CCmdUI* pCmdUI)
{
	//permet d'activer le menu Edition pour les labos Trait et Classif mais pas Proj
	bool cond = false;
	if ((GetDocument()->menuTrait == true)||(GetDocument()->menuClassif == true))
		cond = true;
	pCmdUI->Enable(cond);
}

void CMyAppView::OnUpdateDocEditCopier(CCmdUI* pCmdUI)
{
	//permet d'activer le menu Edition pour les labos Trait et Classif mais pas Proj
	bool cond = false;
	if ((GetDocument()->menuTrait == true)||(GetDocument()->menuClassif == true))
		cond = true;
	pCmdUI->Enable(cond);
}

void CMyAppView::OnUpdateDocEditColler(CCmdUI* pCmdUI)
{
	//permet d'activer le menu Edition pour les labos Trait et Classif mais pas Proj
	bool cond = false;
	if ((GetDocument()->menuTrait == true)||(GetDocument()->menuClassif == true))
		cond = true;
	pCmdUI->Enable(cond);
}

void CMyAppView::OnUpdateDocTraitBin(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuTrait);
}

void CMyAppView::OnUpdateDocTraitBinNiblack(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuTrait);
}

void CMyAppView::OnUpdateDocTraitInv(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuTrait);
}

void CMyAppView::OnUpdateDocTraitPret(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuTrait);
}

void CMyAppView::OnUpdateDocTraitMorphEro(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuTrait);
}

void CMyAppView::OnUpdateDocTraitMorphDil(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuTrait);
}

void CMyAppView::OnUpdateDocTraitMorphOuv(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuTrait);
}

void CMyAppView::OnUpdateDocTraitMorphFerm(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuTrait);
}

void CMyAppView::OnUpdateDocTraitCartendgH(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuTrait);
}

void CMyAppView::OnUpdateDocTraitCartendgV(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuTrait);
}

void CMyAppView::OnUpdateDocTraitCartendgHv(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuTrait);
}

void CMyAppView::OnUpdateDocTraitCalculCc(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuTrait);
}

void CMyAppView::OnUpdateDocTraitFusionGlob(CCmdUI* pCmdUI)
{
	//permet d'activer le menu Edition pour les labos Trait et Classif mais pas Proj
	bool cond = false;
	if ((GetDocument()->menuTrait == true)||(GetDocument()->menuClassif == true))
		cond = true;
	pCmdUI->Enable(cond);
}

void CMyAppView::OnUpdateDocTraitFusFhNorm(CCmdUI* pCmdUI)
{
	//permet d'activer le menu Edition pour les labos Trait et Classif mais pas Proj
	bool cond = false;
	if ((GetDocument()->menuTrait == true)||(GetDocument()->menuClassif == true))
		cond = true;
	pCmdUI->Enable(cond);
}

void CMyAppView::OnUpdateDocTraitFusFhCdg(CCmdUI* pCmdUI)
{
	//permet d'activer le menu Edition pour les labos Trait et Classif mais pas Proj
	bool cond = false;
	if ((GetDocument()->menuTrait == true)||(GetDocument()->menuClassif == true))
		cond = true;
	pCmdUI->Enable(cond);
}

void CMyAppView::OnUpdateDocTraitFusFvNorm(CCmdUI* pCmdUI)
{
	//permet d'activer le menu Edition pour les labos Trait et Classif mais pas Proj
	bool cond = false;
	if ((GetDocument()->menuTrait == true)||(GetDocument()->menuClassif == true))
		cond = true;
	pCmdUI->Enable(cond);
}

void CMyAppView::OnUpdateDocTraitFusFvCdg(CCmdUI* pCmdUI)
{
	//permet d'activer le menu Edition pour les labos Trait et Classif mais pas Proj
	bool cond = false;
	if ((GetDocument()->menuTrait == true)||(GetDocument()->menuClassif == true))
		cond = true;
	pCmdUI->Enable(cond);
}

void CMyAppView::OnUpdateDocTraitRafraichCarac(CCmdUI *pCmdUI)
{
	//permet d'activer le menu Edition pour les labos Trait et Classif mais pas Proj
	bool cond = false;
	if ((GetDocument()->menuTrait == true)||(GetDocument()->menuClassif == true))
		cond = true;
	pCmdUI->Enable(cond);
}

void CMyAppView::OnUpdateDocClassifGeo(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuClassif);
}

void CMyAppView::OnUpdateDocClassifVois(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuClassif);
}

void CMyAppView::OnUpdateDocClassifCaracCc(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuClassif);
}

void CMyAppView::OnUpdateDocClassifSuppZone(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuClassif);
}

void CMyAppView::OnUpdateDocClassifSuppInterZone(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuClassif);
}

void CMyAppView::OnUpdateDocClassifChangeType(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(GetDocument()->menuClassif);
}

void CMyAppView::OnUpdateDocOutilsApplOuvr(CCmdUI* pCmdUI)
{
	if (!((CMyAppApp*)AfxGetApp())->projet->getLaboProj()->appliOuvrDone)
	{
		pCmdUI->Enable(GetDocument()->menuProj);
	}else
	{
		pCmdUI->Enable(false);
	}
}

void CMyAppView::OnDisplayRamel()
{
	// TODO : ajoutez ici le code de votre gestionnaire de commande
}
