/****************************************************************/
// ParamDlg.cpp : implementation file
/****************************************************************/

#include "stdafx.h"
#include "MyApp.h"
#include "ParamDlg.h"
#include ".\paramdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/****************************************************************/
// CParamDlg dialog
/****************************************************************/

CParamDlg::CParamDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CParamDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CParamDlg)
	m_seuilbin = 0;
	m_checkAuto = false;
	m_gdeccx = 0;
	m_gdeccy = 0;
	m_pteccx = 0;
	m_pteccy = 0;
	m_seuilh = 0;
	m_seuilv = 0;
	m_mappage = 0;
	m_deltapix = 0;
	m_checkSeg = false;
	//}}AFX_DATA_INIT
}


void CParamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CParamDlg)

	DDX_Text(pDX, IDC_SEUILBIN, m_seuilbin);
	DDX_Check(pDX, IDC_CHECK_PARAM_BIN_AUTO, m_checkAuto);
	DDX_Control(pDX, IDC_CHECK_PARAM_BIN_AUTO, m_ctrlBin);
	DDX_Text(pDX, IDC_GDECCX, m_gdeccx);
	DDX_Text(pDX, IDC_GDECCY, m_gdeccy);
	DDX_Text(pDX, IDC_PTECCX, m_pteccx);
	DDX_Text(pDX, IDC_PTECCY, m_pteccy);
	DDX_Text(pDX, IDC_SEUILH, m_seuilh);
	DDX_Text(pDX, IDC_SEUILV, m_seuilv);
	DDX_Text(pDX, IDC_MAPPAGE, m_mappage);
	DDX_Text(pDX, IDC_DELTAPIX, m_deltapix);
	DDV_MinMaxInt(pDX, m_deltapix, 0, 1000);
	DDX_Check(pDX, IDC_CHECK_PARAM_TRAITTEXTE, m_checkSeg);
	
	//}}AFX_DATA_MAP

	
}


BEGIN_MESSAGE_MAP(CParamDlg, CDialog)
	//{{AFX_MSG_MAP(CParamDlg)
	ON_BN_CLICKED(IDC_CHECK_PARAM_BIN_AUTO, OnBinAuto)
	ON_BN_CLICKED(IDC_CHECK_PARAM_TRAITTEXTE, OnBnClickedCheckParamTraittexte)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************/
// CParamDlg message handlers
/****************************************************************/

void CParamDlg::OnBinAuto() 
{
	CEdit *e;
	e = (CEdit *)GetDlgItem(IDC_SEUILBIN);
	m_checkAuto = !m_checkAuto;
	e->ShowWindow(!m_checkAuto);

	UpdateData(false);	
}

BOOL CParamDlg::OnInitDialog() 
{
	return CDialog::OnInitDialog();  
}

void CParamDlg::MajChamps()
{
	m_seuilbin = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_seuilBinarisation();
	//le cochage/decochage de "IDC_CHECK_PARAM_BIN_AUTO":
	m_checkAuto = (BOOL)(((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_binAuto());
	m_gdeccx = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_gdeCcLarg();
	m_gdeccy = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_gdeCcHaut();
	m_pteccx = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_pteCcLarg();
	m_pteccy = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_pteCcHaut();
	m_seuilh = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_seuilH();
	m_seuilv = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_seuilV();
	m_mappage = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_rapportMappage();
	m_deltapix = ((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_deltaDecoup();
	//le cochage/decochage de "IDC_CHECK_PARAM_TRAITTEXTE":
	m_checkSeg = (BOOL)(((CMyAppApp*)AfxGetApp())->projet->getParamProj()->getM_traitTexte());
	
	CEdit *e;
	e = (CEdit *)GetDlgItem(IDC_SEUILBIN);
	e->ShowWindow(!m_checkAuto);

	UpdateData(false);
}

void CParamDlg::OnBnClickedCheckParamTraittexte()
{
	m_checkSeg = !m_checkSeg;
}
