/****************************************************************/
// Projet.h: interface for the CProjet class.
//
// La classe CProjet ...
//
/****************************************************************/


#pragma once

#include "MyApp.h"
//#include "MyAppDoc.h" //a dcommenter si il y a un CMyAppDoc ici, dans le .h
						//et commenter celui dans le .cpp
#include "ProjetParam.h"
#include "LaboTrait.h"
#include "LaboClassif.h"
#include "LaboProjet.h"

/*********************/
// CLASSE
/*********************/

class CProjet
{
private:
	CProjetParam* paramProj;

	CLaboTrait* laboTrait;
	CLaboClassif* laboClassif;
	CLaboProjet* laboProj;

public:
	//CScenario scenarioGlobal; //a virer : faire un setScenario  la validation de chaque etape

public:
	void ViderProjet();
	void ViderProjetSansLabo();
	int QuelLaboEnCours();

	void CreerFichierProjetXml(CString chFic);
	bool LireFichierProjetXml(CString chFic);
	CString RecupererCStringXmlFichier(CString chFic);
	bool MaJFichierProjetXml();
	void CreerStructureRep();
	bool SupprimerRepertoireImgCourantes();

	CProjetParam* getParamProj(){return paramProj;}
	CLaboTrait* getLaboTrait(){return laboTrait;}
	CLaboClassif* getLaboClassif(){return laboClassif;}
	CLaboProjet* getLaboProj(){return laboProj;}


	CProjet();
	virtual ~CProjet();
};
