#include "stdafx.h"
#include ".\projetparam.h"

CProjetParam::CProjetParam(void)
{
	m_repTravail.Empty();
	m_repResultats.Empty();
	m_repOuvrage.Empty();
	m_ficSauvegarde.Empty();
	m_ficXml.Empty();
	m_imLaboTrait.Empty();
	m_listeImageClassif = new CList<CString,CString>();
	m_numEtapeAssist = 0;
	m_nomProjet.Empty();

	m_seuilBinarisation = 0;
	m_binAuto = false;
	m_gdeCcLarg = 0;
	m_gdeCcHaut = 0;
	m_pteCcLarg = 0;
	m_pteCcHaut = 0;
	m_seuilH = 0;
	m_seuilV = 0;
	m_rapportMappage = 0;
	m_deltaDecoup = 0;
	m_traitTexte = false;
}

CProjetParam::~CProjetParam(void)
{
}

void CProjetParam::setM_listeImageClassif(CList<CString,CString>* listeIn)
{
	POSITION posTemp = listeIn->GetHeadPosition();
	while (posTemp)
	{
		m_listeImageClassif->AddTail(listeIn->GetNext(posTemp));
	}
}

void CProjetParam::InitialiserParamProj(CString nomProj)
{
	m_repTravail = "Non spcifi";
	m_repResultats = "Non spcifi";
	m_repOuvrage = "Non spcifi";
	m_ficSauvegarde = "Non spcifi";
	m_ficXml = "Non spcifi";
	m_imLaboTrait = "Non spcifi";
	//m_listeImageClassif
	m_numEtapeAssist = 0;
	m_nomProjet = nomProj;

	m_seuilBinarisation = 150;
	m_binAuto = false;
	m_gdeCcLarg = 100;
	m_gdeCcHaut = 120;
	m_pteCcLarg = 5;
	m_pteCcHaut = 5;
	m_seuilH = 2000;
	m_seuilV = 4000;
	m_rapportMappage = 500;
	m_deltaDecoup = 0;
	m_traitTexte = false;
}

void CProjetParam::ViderParamProj()
{
	m_repTravail.Empty();
	m_repResultats.Empty();
	m_repOuvrage.Empty();
	m_ficSauvegarde.Empty();
	m_ficXml.Empty();
	m_imLaboTrait.Empty();
	m_listeImageClassif->RemoveAll();
	m_numEtapeAssist = 0;
	m_nomProjet.Empty();

	m_seuilBinarisation = 0;
	m_binAuto = false;
	m_gdeCcLarg = 0;
	m_gdeCcHaut = 0;
	m_pteCcLarg = 0;
	m_pteCcHaut = 0;
	m_seuilH = 0;
	m_seuilV = 0;
	m_rapportMappage = 0;
	m_deltaDecoup = 0;
	m_traitTexte = false;
}