/****************************************************************/
// Regle.cpp: implementation of the CRegle class.
// 
// C'est la classe mre de tous les autres types de rgles. Elle possde 
// les attributs communs  tout type de rgle et des fonctions virtuelles 
// qu'il est obligatoire d'implmenter dans les classes filles.
//
// Pour scnariser un traitement, il suffit de crer une nouvelle classe 
// qui hrite de CRegle. Ensuite il faut : 
// 1.ajouter les attributs caractristiques de la rgle et dfinir un constructeur
// surcharg
// 2. il faut redfinir la fonction "executer" avec le code  excuter lors de  
// l'appel de la rgle
// 3. Redefinir la fonction getDescription avec une description prcise du traitement
// effectu, celle-ci s'affichera dans la fentre de scnario.
// 4. Redfinir la fonction serialize avec les attributs  sauvegarder
// 5. Mettre un identifiant unique dans l'attribut balise de chaque constructeur
// 6. Dans la fonction charger de la classe scnarion, complter le code en
// fonction de la balise choisit en tape 5
//
/************************************************************************/


/******************************/
// INCLUSION
/******************************/

#include "stdafx.h"
#include "regle.h"
#include "mainfrm.h"
#include "myapp.h"

/******************************/
// PRECOMPILATION
/******************************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/******************************/
// CONSTRUCTEUR
/******************************/


CRegle::CRegle()
{

}

/*CRegle::CRegle(CString b, CString l, int n /*=0*//*)
{
	balise = b;
	libelle = l;
	numero = n;
}*/


/******************************/
// DESTRUCTEUR
/******************************/

CRegle::~CRegle()
{

}


/******************************/
// METHODES
/******************************/

/********************************************************************/
/* Nom mthode : getBalise                                     
/*                                                                  
/* Fonction : permet de lirre l'identifiant unique d'une rgle
/*                                                                 
/* 
/*                                                           
/********************************************************************/

CString CRegle::getBalise()
{
	return balise;
}

/********************************************************************/
/* Nom mthode : getNumero                                     
/*                                                                  
/* Fonction : permet de lire le numro de la rgle
/*                                                                 
/* 
/*                                                           
/********************************************************************/

int CRegle::getNumero()
{
	return numero;
}

/********************************************************************/
/* Nom mthode : setNumero                                     
/*                                                                  
/* Fonction : permet de donner un numro  la rgle
/*                                                                 
/* 
/*                                                           
/********************************************************************/

void CRegle::setNumero(int n)
{
	numero = n;
}

/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : 
/*                                                                 
/* 
/*                                                           
/********************************************************************/

void CRegle::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar<<balise<<numero;
	}
	else
	{
		ar>>balise>>numero;
	}
}

/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : permet de lancer le code  executer lors de l'appel
/*             la rgle                                                     
/*
/*                                                           
/********************************************************************/

void CRegle::Executer(CDocument *pDoc)
{
///fonction virtuelle !!!!->ne pas effacer	
}

/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : permet de donner un description du traitement, cette
/*            description sera affich dans la ListBox du scnario                                                    
/* 
/*                                                           
/********************************************************************/

CString CRegle::getDescription()
{
///fonction virtuelle !!!!->ne pas effacer	
	return CString("quelle rgle?");
}




