/*************************************************************************************************/
/* PFE 2006
/*************************************************************************************************/



/************************************************************************/
/* RegleAnalyseFine.cpp: implementation of the CRegleAnalyseFine class.
/*
/* Permet de scnariser les traitements d'analyse fine
/* 
/*
/************************************************************************/

/*****************/
/* INCLUSION
/*****************/
#include "stdafx.h"
#include "myapp.h"
#include "RegleAnalyseFine.h"
#include "myappdoc.h"
#include "myappview.h"



/*****************/
/* PRECOMPILATION
/*****************/
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif



/*****************/
/* CONSTRUCTEURS
/*****************/
CRegleAnalyseFine::CRegleAnalyseFine(CString type)
{
	balise = "RAF";
	type_zone = type;
}



CRegleAnalyseFine::CRegleAnalyseFine()
{
	balise = "RAF";
	type_zone = "TEXTE";
}



/*****************/
/* DESTRUCTEUR
/*****************/
CRegleAnalyseFine::~CRegleAnalyseFine()
{

}



/*****************/
/* METHODES
/*****************/

/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/
void CRegleAnalyseFine::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);

	CAtelier *atelier = ((CMyAppDoc *)pDoc)->atelier;
	atelier->AnalyseFineDesZonesTextes(type_zone);


}



/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/
void CRegleAnalyseFine::Serialize(CArchive& ar)
{

}



/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/
CString CRegleAnalyseFine::getDescription()
{

	CString desc;

	desc.Format("Analyse fine des zones de textes et sauvegarde des lignes du document");

	return desc; 

}
