/*************************************************************************/
// RegleContour.h: interface for the CRegleContour class.
//
// Permet de scnariser les traitements de dtection de composantes connexes
// et l'tude de leur taille
//
/*************************************************************************/

#if !defined(AFX_REGLECONTOUR_H__1719F089_F290_4E51_93D8_861FE10F3AA3__INCLUDED_)
#define AFX_REGLECONTOUR_H__1719F089_F290_4E51_93D8_861FE10F3AA3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Regle.h"

/******************/
// CLASSE
/******************/

class CRegleContour : public CRegle 
{

public:

	CRegleContour();
	CRegleContour(int PTE_CC_DX,int PTE_CC_DY,int GDE_CC_DX,int GDE_CC_DY);
	virtual ~CRegleContour();

	CString getDescription();
	void virtual Executer(CDocument *pDoc);
	void Serialize(CArchive& ar);

private:

	int pte_dx;
	int pte_dy;
	int gde_dx;
	int gde_dy;

};

#endif // !defined(AFX_REGLECONTOUR_H__1719F089_F290_4E51_93D8_861FE10F3AA3__INCLUDED_)
