/********************************************************************/
// RegleFusion.h: interface for the CRegleFusion class.
//
// Permet de scnariser les traitements de fusion des composantes
// connexes dans le sens horizontal ou vertical
//
/********************************************************************/

#if !defined(AFX_REGLEFUSION_H__707D6918_B66E_4A8E_BF57_12CC23CB3E9A__INCLUDED_)
#define AFX_REGLEFUSION_H__707D6918_B66E_4A8E_BF57_12CC23CB3E9A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include "Regle.h"

/******************/
// CLASSE
/******************/

class CRegleFusion : public CRegle  
{

public:

	CRegleFusion();
	CRegleFusion(char direction, int seuil, bool m_fusCdg, CString type="");
	void virtual Executer(CDocument *pDoc);
	void Serialize(CArchive& ar);
	CString getDescription();
	virtual ~CRegleFusion();

private:

	char direction;
	CString type;
	int seuil;
	bool fusCdg;

};



#endif // !defined(AFX_REGLEFUSION_H__707D6918_B66E_4A8E_BF57_12CC23CB3E9A__INCLUDED_)
