/****************************************************************/
// ReglePlage.cpp: implementation of the CReglePlage class.
//
// Permet de scnariser l'application de l'algorithme des plages
//
/********************************************************/


/*****************/
// INCLUSION
/*****************/

#include "stdafx.h"
#include "myapp.h"
#include "myappdoc.h"
#include "ReglePlage.h"



/*****************/
// PRECOMPILATION
/*****************/

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif



/*****************/
// CONSTRUCTEUR
/*****************/

CReglePlage::CReglePlage()
{
	balise="RPL";
}




/*****************/
// DESTRUCTEUR
/*****************/

CReglePlage::~CReglePlage()
{

}



/*****************/
// METHODES
/*****************/


/********************************************************************/
/* Nom mthode : Executer                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CReglePlage::Executer(CDocument *pDoc)
{
	//charger le doc:
	((CMyAppApp*)AfxGetApp())->ChargerDoc((CMyAppDoc*)pDoc);


	CAtelier *pAtelier = ((CMyAppDoc *)pDoc)->atelier;
	pAtelier->Plage();

}


/********************************************************************/
/* Nom mthode : Serialize                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

void CReglePlage::Serialize(CArchive& ar)
{

}


/********************************************************************/
/* Nom mthode : getDescription                                     
/*                                                                  
/* Fonction : redfinition de la mthode dj prsente dans la classe
/*            mre CRegle pour le traitement de cette rgle                                                    
/* 
/*                                                           
/********************************************************************/

CString CReglePlage::getDescription()
{

	CString desc;
	desc.Format("application de l'algorithme des plages (image courante modifie)");
	return desc;

}
