/**************************************************************/
// RegleSupType.h: interface for the CRegleSupType class.
//
// Permet de scnariser les traitements de suppression et/ou coloriage
// d'un type de zone
//
/**************************************************************/

#if !defined(AFX_REGLESUPTYPE_H__7F14C4E2_F175_4F11_B4FF_2655B9EB1E79__INCLUDED_)
#define AFX_REGLESUPTYPE_H__7F14C4E2_F175_4F11_B4FF_2655B9EB1E79__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include "Regle.h"

/******************/
// CLASSE
/******************/


class CRegleSupType : public CRegle  
{

public:

	CRegleSupType();
	CRegleSupType(CString type, UINT color, int s);
	virtual ~CRegleSupType();

	void virtual Executer(CDocument *pDoc);
	void Serialize(CArchive& ar);
	CString getDescription();

private:

	int suppression;
	UINT color;
	CString type;

};



#endif // !defined(AFX_REGLESUPTYPE_H__7F14C4E2_F175_4F11_B4FF_2655B9EB1E79__INCLUDED_)
