/****************************************************************/
// TypeClasse.cpp: implementation of the CTypeClasse class.
//
// Cette classe est utile pour creer une nouvelle description des zones
// Elle sert donc  crer un nouveau type en lui affectant un nom 
// et une couleur de representation
//
/********************************************************************/

/****************************/
// INCLUSION
/****************************/

#include "stdafx.h"
#include "myapp.h"
#include "TypeClasse.h"


/****************************/
// PRECOMPILATION
/****************************/


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/****************************/
// CONSTRUCTEUR
/****************************/

CTypeClasse::CTypeClasse()
{

}



CTypeClasse::CTypeClasse(CString nom, UINT color, int num)
{
	setNomClasse(nom);
	setColor(color);
	setNumClasse(num);
	seuil=0;
}
CTypeClasse::CTypeClasse(CString nom, double val)
{
	nom_classe=nom;
	seuil=val;
}
/****************************/
// DESSTRUCTEUR
/****************************/


CTypeClasse::~CTypeClasse()
{
	
}


/****************************/
// METHODES
/****************************/


/********************************************************************/
/* Nom mthode : setNomClasse                                     
/*                                                                  
/* Fonction : permet de donner un nom  la classe
/*                                                                 
/* nom : nom que l'on veut donner  la classe
/*                                                           
/********************************************************************/

void CTypeClasse::setNomClasse(CString nom)
{
	nom_classe = nom;
}



/********************************************************************/
/* Nom mthode : getNomClasse                                     
/*                                                                  
/* Fonction : permet de connaitre le nom de la classe
/*                                                                 
/* Sortie : le nom de la classe
/*                                                           
/********************************************************************/

CString CTypeClasse::getNomClasse()
{
	return nom_classe;
}



/********************************************************************/
/* Nom mthode : getColor                                     
/*                                                                  
/* Fonction : permet de connaitre la couleur de traage de la classe
/*                                                                 
/* Sortie : entier indiquant la couleur
/*                                                           
/********************************************************************/


UINT CTypeClasse::getColor()
{
	return color;
}



/********************************************************************/
/* Nom mthode : setColor                                     
/*                                                                  
/* Fonction : permet de donner une couleur de traage  la classe
/*                                                                 
/* Entre : en passe un entier indiquant la couleur
/*                                                           
/********************************************************************/

void CTypeClasse::setColor(UINT c)
{
	color = c;
}
