/********************************************************************/
//
// TypeClasse.h: interface for the CTypeClasse class.
//
// Cette classe est utile pour creer une nouvelle description des zones
// Elle sert donc  crer un nouveau type en lui affectant un nom 
// et une couleur de representation
//
/********************************************************************/


#if !defined(AFX_TYPECLASSE_H__5F42BB7F_65B6_40AB_B854_420BCDBAEED4__INCLUDED_)
#define AFX_TYPECLASSE_H__5F42BB7F_65B6_40AB_B854_420BCDBAEED4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/***************************/
// CLASSE
/***************************/


class CTypeClasse : public CObject 
{

public:

	void setColor(UINT c);
	UINT getColor();
	
	CString getNomClasse();
	void setNomClasse(CString nom);
	int getNumClasse(){return numClasse;}
	void setNumClasse(int num){numClasse = num;}
	int getNbElementsBorneInf(){return nbElementsBorneInf;}
	int getNbElementsBorneSup(){return nbElementsBorneSup;}
	void setNbElementsBornes(int borneInf, int borneSup){nbElementsBorneInf = borneInf; nbElementsBorneSup = borneSup;}
	int getLargeurZoneBorneInf(){return largeurZoneBorneInf;}
	int getLargeurZoneBorneSup(){return largeurZoneBorneSup;}
	void setLargeurZoneBornes(int borneInf, int borneSup){largeurZoneBorneInf = borneInf; largeurZoneBorneSup = borneSup;}
	int getHauteurZoneBorneInf(){return hauteurZoneBorneInf;}
	int getHauteurZoneBorneSup(){return hauteurZoneBorneSup;}
	void setHauteurZoneBornes(int borneInf, int borneSup){hauteurZoneBorneInf = borneInf; hauteurZoneBorneSup = borneSup;}

double seuil;

	CTypeClasse();
	CTypeClasse(CString nom, UINT color, int num);
	CTypeClasse(CString nom, double val);
	virtual ~CTypeClasse();

private:

	UINT color;
	CString nom_classe;
	int numClasse;
	
	int nbElementsBorneInf;
	int nbElementsBorneSup;
	int largeurZoneBorneInf;
	int largeurZoneBorneSup;
	int hauteurZoneBorneInf;
	int hauteurZoneBorneSup;
};





#endif // !defined(AFX_TYPECLASSE_H__5F42BB7F_65B6_40AB_B854_420BCDBAEED4__INCLUDED_)
