

#pragma once
#include "image.h"
#include "MyApp.h"
#include "MyAppDoc.h"
#include	<vector>

// Bote de dialogue CApercuProjet

class CApercuProjet : public CDialog
{
	DECLARE_DYNAMIC(CApercuProjet)

public:
	CApercuProjet(CWnd* pParent = NULL);   // constructeur standard
	virtual ~CApercuProjet();

// Donnes de bote de dialogue
	enum { IDD = IDD_DIALOG_APERCU_PROJET };

	CListCtrl	m_ListThumbnail;
	CString	m_strImageDir;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // Prise en charge DDX/DDV

	CImageList				m_ImageListThumb;		// image list holding the thumbnails
	std::vector<CString>	m_VectorImageNames;		// vector holding the image names
	int						m_nSelectedItem;
	int						projEnCours;			//num constante du labo en cours
	BOOL  GetImageFileNames(CObList* listeDocs);	// gather the image file names
	void  DrawThumbnails();		// draw the thumbnails in list control
public:
	void Charger();
	void Decharger();
	void DrawSelectedImage();
	void RafficherDocSelectionne();
	void SupprimerDoc(CMyAppDoc *pDoc);

public:
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedButtonDocSuiv();
	afx_msg void OnBnClickedButtonDocPrec();

	afx_msg void OnClickListThumb(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKeydownListThumb(NMHDR* pNMHDR, LRESULT* pResult);

	void setM_nSelectedItem(int num){m_nSelectedItem = num;}

	DECLARE_MESSAGE_MAP()
};
