

#include "stdafx.h"
#include "MyApp.h"
#include "CaracCV.h"
#include "MyAppDoc.h"
#include "Zone.h"
#include "Atelier.h"
#include "MainFrm.h"


CCaracCV::CCaracCV(void)
{
	classeVoisinGauche = "NULL";
	classeVoisinDroite = "NULL";
	classeVoisinHaut = "NULL";
	classeVoisinBas = "NULL";
	classeVoisinInclusDans = "NULL";
}

CCaracCV::~CCaracCV(void)
{
}


void CCaracCV::CalculerToutesLesCaracCV(CZone *zoneACalculer)
{
	if (zoneACalculer->getZone() != 0)
	{
		ChercheVoisins(zoneACalculer);
	}
		/*zoneACalculer->p_voisin_gauche->AssertValid();
		zoneACalculer->p_voisin_droite->AssertValid();
		zoneACalculer->p_voisin_haut->AssertValid();
		zoneACalculer->p_voisin_bas->AssertValid();
		zoneACalculer->p_inclus_dans->AssertValid();

		classeVoisinGauche = zoneACalculer->p_voisin_gauche->getClasse()->getNomClasse();
		classeVoisinGauche = zoneACalculer->p_voisin_droite->getClasse()->getNomClasse();
		classeVoisinGauche = zoneACalculer->p_voisin_haut->getClasse()->getNomClasse();
		classeVoisinGauche = zoneACalculer->p_voisin_bas->getClasse()->getNomClasse();
		classeVoisinGauche = zoneACalculer->p_inclus_dans->getClasse()->getNomClasse();*/

	/*if (zoneACalculer->p_voisin_gauche != NULL)
	{
		if((zoneACalculer->p_voisin_gauche->getZone() != -1)&&(zoneACalculer->p_voisin_gauche->getZone() != -17891602)&&(zoneACalculer->p_voisin_gauche->getZone() != 0))
		{
			classeVoisinGauche = zoneACalculer->p_voisin_gauche->getClasse()->getNomClasse();
		}
	}
	if (zoneACalculer->p_voisin_droite != NULL)
	{
		if((zoneACalculer->p_voisin_droite->getZone() != -1)&&(zoneACalculer->p_voisin_droite->getZone() != -17891602)&&(zoneACalculer->p_voisin_droite->getZone() != 0))
		{
			classeVoisinDroite = zoneACalculer->p_voisin_droite->getClasse()->getNomClasse();
		}
	}
	if (zoneACalculer->p_voisin_haut != NULL)
	{
		if((zoneACalculer->p_voisin_haut->getZone() != -1)&&(zoneACalculer->p_voisin_haut->getZone() != -17891602)&&(zoneACalculer->p_voisin_haut->getZone() != 0))
		{
			classeVoisinHaut = zoneACalculer->p_voisin_haut->getClasse()->getNomClasse();
		}
	}
	if (zoneACalculer->p_voisin_bas != NULL)
	{
		if((zoneACalculer->p_voisin_bas->getZone() != -1)&&(zoneACalculer->p_voisin_bas->getZone() != -17891602)&&(zoneACalculer->p_voisin_bas->getZone() != 0))
		{
			classeVoisinBas = zoneACalculer->p_voisin_bas->getClasse()->getNomClasse();
		}
	}
	if (zoneACalculer->p_inclus_dans != NULL)
	{
		if((zoneACalculer->p_inclus_dans->getZone() != -1)&&(zoneACalculer->p_inclus_dans->getZone() != -17891602)&&(zoneACalculer->p_inclus_dans->getZone() != 0))
		{
			classeVoisinInclusDans = zoneACalculer->p_inclus_dans->getClasse()->getNomClasse();
		}
	}*/
}


void CCaracCV::ChercheVoisins(CZone* zoneACalculer)
{
	CMyAppDoc* pDoc = (CMyAppDoc *)zoneACalculer->m_DocContenant;
	CAtelier* pAtelier = pDoc->atelier;
	CImage* Image = pAtelier->getImageCourante();
	CObList* liste = (CObList *)pAtelier->liste_de_zones->liste;

	int largeur = Image->getLargeur();
	int hauteur = Image->getHauteur();

	CPoint P1,P2;
	double delta_x,delta_y,distance;
	int xTL,yTL,xBR,yBR; 

	int min_G,min_D,min_H,min_B;
	double max_I;
	CZone *p_G,*p_D,*p_H,*p_B,*p_I;

	CRect *RG;
	CRect *RD;
	CRect *RH;
	CRect *RB;
	
	//POSITION p1;
	POSITION p2;

	//CProgressBar pg("Dtection du voisinage...",liste->GetCount());
	//CWaitCursor wc;

	//for (p1 = liste->GetHeadPosition();p1 != NULL;)
	//{

		min_G = 20000;min_D = 20000;min_H = 20000;min_B = 20000;max_I=0;
		p_G=NULL;p_D=NULL;p_H=NULL;p_B=NULL;p_I=NULL;

		//CZone *z = (CZone *)liste->GetNext(p1);
		CZone *z = zoneACalculer;
		P1 = *(z->getCdg());
		xTL = z->getRect()->TopLeft().x;
		yTL = z->getRect()->TopLeft().y;
		xBR = z->getRect()->BottomRight().x;
		yBR = z->getRect()->BottomRight().y; 

		RD = new CRect(P1.x,yTL,(largeur-P1.x),yBR);
		RG = new CRect(0,yTL,P1.x,yBR);
		RH = new CRect(xTL,0,xBR,P1.y);
		RB = new CRect(xTL,P1.y,xBR,(hauteur-P1.y));

		for (p2 = liste->GetHeadPosition(); p2 != NULL;)
		{

			CZone *zz = (CZone *)liste->GetNext(p2);

			if (z==zz)continue;

			P2 = *(zz->getCdg());
					
			delta_x = (P2.x - P1.x)*(P2.x - P1.x);
			delta_y = (P2.y - P1.y)*(P2.y - P1.y);
			distance = sqrt(delta_x + delta_y);

			CRect *rr=new CRect();


			//si le centre de gravite de la zone consideree est
			//et le rectangle droit
			//et si la distance qui le spare de l'autre cdg 
			//de la zone qui cherche ses voisins
			//est infrieure  la derniere distance mini trouvee
			if (rr->IntersectRect(RD,zz->getRect()) && distance < min_D)
			{

				for (int j=zz->getRect()->TopLeft().y;j<=zz->getRect()->BottomRight().y;j++)
				{

					CPoint p(zz->getRect()->TopLeft().x,j);

					if (RD->PtInRect(p))
					{

						//alors le pointeur sur le plus proche voisin de droite est ...
						p_D = zz;
						min_D = distance;
						break;

					}					
				}

				
			}

			//si le centre de gravite de la zone consideree est
			//et le rectangle gauche et ...
			if (rr->IntersectRect(RG,zz->getRect()) && distance < min_G)
			{

				for (int j=zz->getRect()->TopLeft().y;j<=zz->getRect()->BottomRight().y;j++)
				{

					CPoint p(zz->getRect()->BottomRight().x,j);
					if (RG->PtInRect(p))
					{

						//alors le pointeur sur le plus proche voisin de gauche est ...
						p_G = zz;
						min_G = distance;

					}					
				}
			}
			//si le centre de gravite de la zone consideree est
			//et le rectangle haut
			if (rr->IntersectRect(RH,zz->getRect()) && distance < min_H)
			{

				for (int i=zz->getRect()->TopLeft().x;i<=zz->getRect()->BottomRight().x;i++)
				{

					CPoint p(i,zz->getRect()->BottomRight().y);
					if (RH->PtInRect(p))
					{

						//alors le pointeur sur le plus proche voisin du haut est ...
						p_H = zz;
						min_H = distance;

					}					
				}
			}
			//si le centre de gravite de la zone consideree est
			//et le rectangle bas
			if (rr->IntersectRect(RB,zz->getRect()) && distance < min_B)
			{

				for (int i=zz->getRect()->TopLeft().x;i<=zz->getRect()->BottomRight().x;i++)
				{

					CPoint p(i,zz->getRect()->TopLeft().y);
					if (RB->PtInRect(p))
					{

						//alors le pointeur sur le plus proche voisin du bas est ...
						p_B = zz;
						min_B = distance;

					}					
				}
				
			}

			//si la zone est incluse dans une autre
			if (rr->IntersectRect(z->getRect(),zz->getRect()))
			{
				
				double rapport =  (double)(rr->Height()*rr->Width()) / (double)(z->getRect()->Height()*z->getRect()->Width());
				if (rapport > max_I)
				{
					p_I = zz;
					max_I = rapport;
				}
			}

			delete rr;
		}
		
		z->p_voisin_gauche = p_G;
		z->p_voisin_droite = p_D;
		z->p_voisin_haut = p_H;
		z->p_voisin_bas = p_B;
		z->p_inclus_dans = p_I;
		z->getCaracCG()->setDegreInclusion(max_I);

		if (p_G != NULL) 
		{
			classeVoisinGauche = p_G->getClasse()->getNomClasse();
		}else
		{
			classeVoisinGauche = "NULL";
		}


		if (p_D != NULL) 
		{
			classeVoisinDroite = p_D->getClasse()->getNomClasse();
		}else
		{
			classeVoisinDroite = "NULL";
		}


		if (p_H != NULL) 
		{
			classeVoisinHaut = p_H->getClasse()->getNomClasse();
		}else
		{
			classeVoisinHaut = "NULL";
		}


		if (p_B != NULL) 
		{
			classeVoisinBas = p_B->getClasse()->getNomClasse();
		}else
		{
			classeVoisinBas = "NULL";
		}


		if (p_I != NULL) 
		{
			classeVoisinInclusDans = p_I->getClasse()->getNomClasse();
		}else
		{
			classeVoisinInclusDans = "NULL";
		}
		
		
		
		

		//pg.m_progress.StepIt();

	//}	
}
