// DialogAssistTab.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "MyApp.h"
#include "DialogAssistTab.h"
#include "MainFrm.h"


// Bote de dialogue CDialogAssistTab

IMPLEMENT_DYNAMIC(CDialogAssistTab, CDialogBar)
CDialogAssistTab::CDialogAssistTab(CWnd* pParent /*=NULL*/)
	: CDialogBar()//(CDialogAssistTab::IDD, pParent)
{
	m_assist1 = NULL;
	m_assist2 = NULL;
	m_assist3 = NULL;
	m_assist4 = NULL;
}

CDialogAssistTab::~CDialogAssistTab()
{
}

void CDialogAssistTab::DoDataExchange(CDataExchange* pDX)
{
	CDialogBar::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogAssistTab)
	DDX_Control(pDX, IDC_TAB_ASSIST, c_tabAssistCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogAssistTab, CDialogBar)
	//{{AFX_MSG_MAP(CDialogAssistTab)
	ON_WM_PAINT()
	ON_MESSAGE(WM_INITDIALOG,OnInitDialog) 
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Gestionnaires de messages CDialogAssistTab

LONG CDialogAssistTab::OnInitDialog(UINT wParam, LONG lParam)
{
	//CDialogBar/*CDialog*/::OnInitDialog();
	// suppression de la commande par :
	BOOL bRet = HandleInitDialog(wParam, lParam);

    if (!UpdateData(FALSE))
    {
       TRACE0("Warning: UpdateData failed during dialog init.\n");
    }

	c_tabAssistCtrl.SetAutoSizePannel(); // retaille automatiquement les panneaux clients.

	//cration de tous les onglets
	CreerTab1();
	CreerTab2();
	CreerTab3();
	CreerTab4();

	//++++++++ premier onglet charg des l'initialisation
	//AfficherTab1();

	//+++++++++ onglets suivants pas affichs 
	//+++++++++  (pour les onglets 21,22,51,52,53)
	//+++++++++  car leur affichage s'effectue en fonction des choix de l'utilisateur



	//c_tabAssistCtrl.EnableTab(1, FALSE);
	

	//+++++++++++++++++++++++ customizing the tab control +++++++++++++++++++++++
	//c_tabAssistCtrl.SetDisabledColor(RGB(255, 0, 0));
	//c_tabAssistCtrl.SetBackGroundColor(RGB(193, 193, 255));
	//c_tabAssistCtrl.SetSelectedColor(RGB(0, 0, 255));
	//c_tabAssistCtrl.SetMouseOverColor(RGB(255, 0, 0));
	//SetDialogBkColor(RGB(193, 193, 255));

	return bRet;
}


void CDialogAssistTab::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

	}
	else
	{
		CDialogBar::OnPaint();
	}
}

void CDialogAssistTab::OnDestroy() 
{
	CDialogBar::OnDestroy();
	
	if (m_assist1) delete m_assist1;
	if (m_assist2) delete m_assist2;
	if (m_assist3) delete m_assist3;
	if (m_assist4) delete m_assist4;
}

void CDialogAssistTab::SupprimerAllTabs() 
{
	c_tabAssistCtrl.DeleteAllTabs();
}

void CDialogAssistTab::ActiverDesactiverOnglets(int indexTab)
{
	switch(indexTab)
	{
	case 0 :	
		c_tabAssistCtrl.EnableTab(0, TRUE);
		c_tabAssistCtrl.EnableTab(1, FALSE);
		c_tabAssistCtrl.EnableTab(2, FALSE);
		c_tabAssistCtrl.EnableTab(3, FALSE);
		c_tabAssistCtrl.SelectTab(0);
		break;
	case 1 : 	
		c_tabAssistCtrl.EnableTab(0, FALSE);
		c_tabAssistCtrl.EnableTab(1, TRUE);
		c_tabAssistCtrl.EnableTab(2, FALSE);
		c_tabAssistCtrl.EnableTab(3, FALSE);
		c_tabAssistCtrl.SelectTab(1);
		break;
	case 2 : 	
		c_tabAssistCtrl.EnableTab(0, FALSE);
		c_tabAssistCtrl.EnableTab(1, FALSE);
		c_tabAssistCtrl.EnableTab(2, TRUE);
		c_tabAssistCtrl.EnableTab(3, FALSE);
		c_tabAssistCtrl.SelectTab(2);
		break;
	case 3 : 	
		c_tabAssistCtrl.EnableTab(0, FALSE);
		c_tabAssistCtrl.EnableTab(1, FALSE);
		c_tabAssistCtrl.EnableTab(2, FALSE);
		c_tabAssistCtrl.EnableTab(3, TRUE);
		c_tabAssistCtrl.SelectTab(3);
		break;
	}
}

void CDialogAssistTab::CreerTab1() 
{
	m_assist1=new CDlgAssist1(this);
	m_assist1->Create(IDD_DIALOG_ASSIST1, &c_tabAssistCtrl);//&c_tabAssistCtrl
	c_tabAssistCtrl.AddTab(m_assist1, "         1      ", 0);
	m_assist1->m_pTab = &c_tabAssistCtrl;
}

void CDialogAssistTab::AfficherTab1() 
{
	ActiverDesactiverOnglets(0);
	//cacher le bouton etape suivante tant que l'ouvrage n'est pas choisi
	m_assist1->m_ctrlAssist1BtnEtpSuiv.ShowWindow(SW_HIDE);
	//indiquer le num de l'tape aux param du projet
	((CMyAppApp*)AfxGetApp())->projet->getParamProj()->setM_numEtapeAssist(1);
	c_tabAssistCtrl.ReSizeCurPannel();
}

void CDialogAssistTab::SupprimerTab1() 
{
	c_tabAssistCtrl.DeleteTab(0);
}

void CDialogAssistTab::CreerTab2() 
{
	m_assist2=new CDlgAssist2(this);
	m_assist2->Create(IDD_DIALOG_ASSIST2, &c_tabAssistCtrl);
	c_tabAssistCtrl.AddTab(m_assist2, "         2      ", 1);
	m_assist2->m_pTab = &c_tabAssistCtrl;
}

void CDialogAssistTab::AfficherTab2A() 
{
	ActiverDesactiverOnglets(1);
	//afficher le 2A (fait par dfaut)
	//cacher le 2B et le 2C
	m_assist2->m_ctrlAssist2LegB.ShowWindow(SW_HIDE);
	m_assist2->m_ctrlAssist2BtnEtpSuivB.ShowWindow(SW_HIDE);
	m_assist2->m_ctrlAssist2LegC.ShowWindow(SW_HIDE);
	m_assist2->m_ctrlAssist2BtnEtpSuivC.ShowWindow(SW_HIDE);
	m_assist2->m_ctrlAssist2BtnRAZBC.ShowWindow(SW_HIDE);

	//indiquer le num de l'tape aux param du projet
	((CMyAppApp*)AfxGetApp())->projet->getParamProj()->setM_numEtapeAssist(2);

	//charge l'image choisie pour le laboTrait :
	m_assist2->ChargerImageLaboTrait();

	//affiche les vignettes :
	((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.getM_apProjet()->Charger();
	c_tabAssistCtrl.ReSizeCurPannel();
}

void CDialogAssistTab::AfficherTab2B() 
{
	ActiverDesactiverOnglets(1);
	//(dsactiver le valider de 2A) et cacher le 2C:
	//m_assist2->m_ctrlAssist2BtnValA.EnableWindow(false);
	m_assist2->m_ctrlAssist2LegC.ShowWindow(SW_HIDE);
	m_assist2->m_ctrlAssist2BtnEtpSuivC.ShowWindow(SW_HIDE);
	//afficher le 2B:
	m_assist2->m_ctrlAssist2LegB.ShowWindow(SW_SHOW);
	m_assist2->m_ctrlAssist2BtnEtpSuivB.ShowWindow(SW_SHOW);
	m_assist2->m_ctrlAssist2BtnRAZBC.ShowWindow(SW_SHOW);

	//indiquer le num de l'tape aux param du projet
	((CMyAppApp*)AfxGetApp())->projet->getParamProj()->setM_numEtapeAssist(2);
	c_tabAssistCtrl.ReSizeCurPannel();
}

void CDialogAssistTab::AfficherTab2C() 
{
	ActiverDesactiverOnglets(1);
	//dsactiver le valider de 2A et cacher le 2B:
	//m_assist2->m_ctrlAssist2BtnValA.EnableWindow(false);
	m_assist2->m_ctrlAssist2LegB.ShowWindow(SW_HIDE);
	m_assist2->m_ctrlAssist2BtnEtpSuivB.ShowWindow(SW_HIDE);
	//afficher le 2C:
	m_assist2->m_ctrlAssist2LegC.ShowWindow(SW_SHOW);
	m_assist2->m_ctrlAssist2BtnEtpSuivC.ShowWindow(SW_SHOW);
	m_assist2->m_ctrlAssist2BtnRAZBC.ShowWindow(SW_SHOW);
	//indiquer le num de l'tape aux param du projet
	((CMyAppApp*)AfxGetApp())->projet->getParamProj()->setM_numEtapeAssist(2);
	c_tabAssistCtrl.ReSizeCurPannel();
}

void CDialogAssistTab::SupprimerTab2() 
{
	c_tabAssistCtrl.DeleteTab(1);
}

void CDialogAssistTab::CreerTab3() 
{
	m_assist3=new CDlgAssist3(this);
	m_assist3->Create(IDD_DIALOG_ASSIST3, &c_tabAssistCtrl);
	c_tabAssistCtrl.AddTab(m_assist3, "         3      ", 2);
	m_assist3->m_pTab = &c_tabAssistCtrl;
}

void CDialogAssistTab::AfficherTab3A() 
{
	ActiverDesactiverOnglets(2);
	//afficher le 3A (fait par dfaut)
	//cacher le 3B :
	m_assist3->m_ctrlAssist3LegB.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnEtpSuivB.ShowWindow(SW_HIDE);
	//cacher le 3C :
	m_assist3->m_ctrlAssist3LegC1.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3LabelEditC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3ListC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnLabelC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnSupprC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnRazC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnCouleurC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnPrevC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnModifC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnValC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqValC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree1C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree1C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree2C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree2C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree3C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree3C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree4C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree4C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree5C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree5C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree6C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree6C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree7C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree7C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree8C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree8C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree9C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree9C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree10C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree10C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree11C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree11C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree12C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree12C.SetWindowText("");
	m_assist3->m_ctrlAssist3BtnEtpSuivC.ShowWindow(SW_HIDE);

	//indiquer le num de l'tape aux param du projet
	((CMyAppApp*)AfxGetApp())->projet->getParamProj()->setM_numEtapeAssist(3);

	//charge les images choisies pour le laboClassif :
	m_assist3->ChargerImagesLaboClassif();

	//affiche les vignettes :
	((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.getM_apProjet()->Charger();
	c_tabAssistCtrl.ReSizeCurPannel();
}

void CDialogAssistTab::AfficherTab3B() 
{
	ActiverDesactiverOnglets(2);
	
	//dsactiver le valider du 3A :
	//m_assist3->m_ctrlAssist3BtnValA.EnableWindow(false);
	//afficher le 3B :
	m_assist3->m_ctrlAssist3LegB.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3BtnEtpSuivB.ShowWindow(SW_SHOW);
	//cacher le 3C :
	m_assist3->m_ctrlAssist3LegC1.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3LabelEditC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3ListC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnLabelC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnSupprC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnRazC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnCouleurC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnPrevC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnModifC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnValC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqValC.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree1C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree1C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree2C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree2C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree3C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree3C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree4C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree4C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree5C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree5C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree6C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree6C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree7C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree7C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree8C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree8C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree9C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree9C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree10C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree10C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree11C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree11C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree12C.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3TextEtiqCree12C.SetWindowText("");
	m_assist3->m_ctrlAssist3BtnEtpSuivC.ShowWindow(SW_HIDE);

	//indiquer le num de l'tape aux param du projet
	((CMyAppApp*)AfxGetApp())->projet->getParamProj()->setM_numEtapeAssist(3);
	c_tabAssistCtrl.ReSizeCurPannel();
}

void CDialogAssistTab::AfficherTab3C() 
{
	ActiverDesactiverOnglets(2);
	
	//dsactiver le valider du 3A :
	//m_assist3->m_ctrlAssist3BtnValA.EnableWindow(false);
	//cacher le 3B :
	m_assist3->m_ctrlAssist3LegB.ShowWindow(SW_HIDE);
	m_assist3->m_ctrlAssist3BtnEtpSuivB.ShowWindow(SW_HIDE);
	//afficher le 3C :
	m_assist3->m_ctrlAssist3LegC1.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3LabelEditC.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3ListC.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3BtnLabelC.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3BtnSupprC.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3BtnRazC.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3BtnCouleurC.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3BtnPrevC.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3BtnModifC.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3BtnValC.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqValC.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree1C.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree1C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree2C.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree2C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree3C.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree3C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree4C.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree4C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree5C.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree5C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree6C.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree6C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree7C.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree7C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree8C.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree8C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree9C.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree9C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree10C.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree10C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree11C.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree11C.SetWindowText("");
	m_assist3->m_ctrlAssist3TextEtiqCree12C.ShowWindow(SW_SHOW);
	m_assist3->m_ctrlAssist3TextEtiqCree12C.SetWindowText("");
	m_assist3->m_ctrlAssist3BtnEtpSuivC.ShowWindow(SW_SHOW);

	//indiquer le num de l'tape aux param du projet
	((CMyAppApp*)AfxGetApp())->projet->getParamProj()->setM_numEtapeAssist(3);
	c_tabAssistCtrl.ReSizeCurPannel();
}

void CDialogAssistTab::SupprimerTab3() 
{
	c_tabAssistCtrl.DeleteTab(2);
}

void CDialogAssistTab::CreerTab4() 
{
	m_assist4=new CDlgAssist4(this);
	m_assist4->Create(IDD_DIALOG_ASSIST4, &c_tabAssistCtrl);
	c_tabAssistCtrl.AddTab(m_assist4, "         4      ", 3);
	m_assist4->m_pTab = &c_tabAssistCtrl;
}

void CDialogAssistTab::AfficherTab4() 
{
	ActiverDesactiverOnglets(3);
	//indiquer le num de l'tape aux param du projet
	((CMyAppApp*)AfxGetApp())->projet->getParamProj()->setM_numEtapeAssist(4);

	//charge les images de l'ouvrage pour le laboProj :
	m_assist4->ChargerImagesLaboProj();

	//affiche les vignettes :
	((CMainFrame*)AfxGetMainWnd())->m_wndDlgTab.getM_apProjet()->Charger();
	c_tabAssistCtrl.ReSizeCurPannel();
}

void CDialogAssistTab::SupprimerTab4() 
{
	c_tabAssistCtrl.DeleteTab(3);
}
