#pragma once

#include "resource.h"
//+++++++++ inclure les 9 types de frame a inserer ++++++++++
#include "DlgAssist1.h"
#include "DlgAssist2.h"
#include "DlgAssist3.h"
#include "DlgAssist4.h"
#include "afxcmn.h"
#include "XTabCtrl.h"

// Bote de dialogue CDialogAssistTab

class CDialogAssistTab : public CDialogBar
{
	DECLARE_DYNAMIC(CDialogAssistTab)

public:
	CDialogAssistTab(CWnd* pParent = NULL);   // constructeur standard
	virtual ~CDialogAssistTab();

// Donnes de bote de dialogue
	enum { IDD = IDD_DIALOG_ASSIST_TAB };
	CXTabCtrl	c_tabAssistCtrl;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // Prise en charge DDX/DDV
	afx_msg LONG OnInitDialog(UINT wParam, LONG lParam);
	afx_msg void OnPaint();
	afx_msg void OnDestroy();

	DECLARE_MESSAGE_MAP()

private:
	//+++++++++ crer une variable par type de frame (9) +++++++++++++
	CDlgAssist1* m_assist1;
	CDlgAssist2* m_assist2;
	CDlgAssist3* m_assist3;
	CDlgAssist4* m_assist4;

public:
	//+++++++++ crer un accesseur par type de frame (9) +++++++++++++
	CDlgAssist1* getm_assist1(){return m_assist1;}
	CDlgAssist2* getm_assist2(){return m_assist2;}
	CDlgAssist3* getm_assist3(){return m_assist3;}
	CDlgAssist4* getm_assist4(){return m_assist4;}

	void ActiverDesactiverOnglets(int indexTab);

	void CreerTab1();
	void CreerTab2();
	void CreerTab3();
	void CreerTab4();

	void AfficherTab1();
	void AfficherTab2A();
	void AfficherTab2B();
	void AfficherTab2C();
	void AfficherTab3A();
	void AfficherTab3B();
	void AfficherTab3C();
	void AfficherTab4();

	void SupprimerTab1();
	void SupprimerTab2();
	void SupprimerTab3();
	void SupprimerTab4();
	void SupprimerAllTabs();
};
