#pragma once
#include "afxcmn.h"
#include "afxwin.h"
#include "ClassifAutoDonnees.h"


// Bote de dialogue CDialogClassifAuto

class CDialogClassifAuto : public CDialog
{
	DECLARE_DYNAMIC(CDialogClassifAuto)

public:
	CDialogClassifAuto(CClassifAutoDonnees *datasIn, CWnd* pParent = NULL);   // constructeur standard
	virtual ~CDialogClassifAuto();

// Donnes de bote de dialogue
	enum { IDD = IDD_DIALOG_CLASSIF_AUTO };
	CClassifAutoDonnees *datas;

	bool		m_radioNonIndep;
	bool		m_radioCaracMoy;
	bool		m_radioGeoMoy;
	int			m_valSliderCaracReg;
	int			m_valSliderCaracEcart;
	int			m_valSliderVoisReg;
	int			m_valSliderGeoE;
	int			m_valSliderGeoO;
	int			m_valSliderGeoC;
	int			m_valSliderGeoB;
	int			m_valSliderGeoH;
	int			m_valSliderGeoD;
	int			m_valSliderGeoG;

	BOOL		m_check1;
	BOOL		m_check2;
	BOOL		m_check3;
	BOOL		m_check4;
	BOOL		m_check5;
	BOOL		m_check6;
	BOOL		m_check7;
	BOOL		m_check10;
	BOOL		m_check11;
	BOOL		m_check12;
	BOOL		m_check13;
	BOOL		m_check14;
	BOOL		m_check15;
	BOOL		m_check16;
	BOOL		m_check17;
	BOOL		m_check18;
	BOOL		m_check19;
	BOOL		m_check20;
	BOOL		m_check21;

	double m_valMin1;
	int m_valMin2;
	double m_valMin3;
	int m_valMin4;
	int m_valMin5;
	double m_valMin6;
	int m_valMin7;
	double m_valMax1;
	int m_valMax2;
	double m_valMax3;
	int m_valMax4;
	int m_valMax5;
	double m_valMax6;
	int m_valMax7;

	int m_ordreCarac;
	int m_ordreGeo;
	int m_ordreVois;

	int m_initCaracTol;
	int m_initCaracEcart;
	int m_initVoisTol;

	CString	m_editTypeOrg;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // Prise en charge DDX/DDV
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedOk();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBnClickedRadioChoixModeNonIndep();
	afx_msg void OnBnClickedRadioChoixModeIndep();
	afx_msg void OnBnClickedRadioCaracMoy();
	afx_msg void OnBnClickedRadioCaracMed();
	afx_msg void OnBnClickedRadioGeoMoy();
	afx_msg void OnBnClickedRadioGeoMed();
	afx_msg void OnBnClickedCheck1();
	afx_msg void OnBnClickedCheck2();
	afx_msg void OnBnClickedCheck3();
	afx_msg void OnBnClickedCheck4();
	afx_msg void OnBnClickedCheck5();
	afx_msg void OnBnClickedCheck6();
	afx_msg void OnBnClickedCheck7();
	afx_msg void OnBnClickedCheck10();
	afx_msg void OnBnClickedCheck11();
	afx_msg void OnBnClickedCheck12();
	afx_msg void OnBnClickedCheck13();
	afx_msg void OnBnClickedCheck14();
	afx_msg void OnBnClickedCheck15();
	afx_msg void OnBnClickedCheck16();
	afx_msg void OnBnClickedCheck17();
	afx_msg void OnBnClickedCheck18();
	afx_msg void OnBnClickedCheck19();
	afx_msg void OnBnClickedCheck20();
	afx_msg void OnBnClickedCheck21();

	DECLARE_MESSAGE_MAP()

public:
	void InitPartMode();
	void InitPartCarac();
	void InitPartGeo();
	void InitPartVois();
	void InitPartOrdre();

	void MajInterface();
	void MajPartMode();
	void MajPartCarac();
	void MajPartGeo();
	void MajPartVois();
	void MajPartOrdre();

	void RemplirCasesMinCarac();
	void RemplirCasesMaxCarac();
	void RemplirCasesGeo();
	void RemplirCasesVois();
	void CocherReglesCarac(bool active);
	void CocherReglesGeo(bool active);
	void CocherReglesVois(bool active);
	void CocherReglesGlobal();
	void CocherRadiosOrdre();
	
	afx_msg void OnBnClickedRadioOrdreCarac1();
	afx_msg void OnBnClickedRadioOrdreCarac2();
	afx_msg void OnBnClickedRadioOrdreCarac3();
	afx_msg void OnBnClickedRadioOrdreCaracnul();
	afx_msg void OnBnClickedRadioOrdreGeo1();
	afx_msg void OnBnClickedRadioOrdreGeo2();
	afx_msg void OnBnClickedRadioOrdreGeo3();
	afx_msg void OnBnClickedRadioOrdreGeonul();
	afx_msg void OnBnClickedRadioOrdreVois1();
	afx_msg void OnBnClickedRadioOrdreVois2();
	afx_msg void OnBnClickedRadioOrdreVois3();
	afx_msg void OnBnClickedRadioOrdreVoisnul();
	afx_msg void OnBnClickedButtonRetValOrg();
};
