/****************************************************************/
// DialogClassifCar.cpp : implementation file
/****************************************************************/
#include "stdafx.h"
#include "myapp.h"
#include "MyAppDoc.h"
#include "DialogClassifCar.h"
#include "regle.h"
#include "constante.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/****************************************************************/
// CDialogClassifCar dialog
/****************************************************************/

CDialogClassifCar::CDialogClassifCar(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogClassifCar::IDD, pParent)
{
	pView = (CView *)pParent;
	color_si = 0;
	color_sinon = 0;
	//{{AFX_DATA_INIT(CDialogClassifCar)
	m_liste = _T("");
	m_check2 = FALSE;
	m_check3 = FALSE;
	m_check4 = FALSE;
	m_check5 = FALSE;
	HLmin = 0;
	HLmax = 0;
	NBCCmax = 0;
	NBCCmin = 0;
	HHmin = 0;
	HHmax = 0;
	Lmin = 0;
	Lmax = 0;
	Hmin = 0;
	Hmax = 0;
	m_check1 = FALSE;
	m_edit_si = _T("");
	m_edit_sinon = _T("");
	m_check6 = FALSE;
	DPBmax = 0.0;
	DPBmin = 0.0;
	DNdgmax = 0.0;
	DNdgmin = 0.0;
	m_check7 = FALSE;
	//}}AFX_DATA_INIT
}


void CDialogClassifCar::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogClassifCar)
	DDX_CBString(pDX, IDC_LISTE, m_liste);
	DDX_Check(pDX, IDC_CHECK2, m_check2);
	DDX_Check(pDX, IDC_CHECK3, m_check3);
	DDX_Check(pDX, IDC_CHECK4, m_check4);
	DDX_Check(pDX, IDC_CHECK5, m_check5);
	DDX_Text(pDX, IDC_MIN1, HLmin);
	DDV_MinMaxDouble(pDX, HLmin, 0., 10000.);
	DDX_Text(pDX, IDC_MAX1, HLmax);
	DDV_MinMaxDouble(pDX, HLmax, 0., 10000.);
	DDX_Text(pDX, IDC_MAX2, NBCCmax);
	DDV_MinMaxInt(pDX, NBCCmax, 0, 10000);
	DDX_Text(pDX, IDC_MIN2, NBCCmin);
	DDV_MinMaxInt(pDX, NBCCmin, 0, 10000);
	DDX_Text(pDX, IDC_MIN3, HHmin);
	DDV_MinMaxDouble(pDX, HHmin, 0., 10000.);
	DDX_Text(pDX, IDC_MAX3, HHmax);
	DDV_MinMaxDouble(pDX, HHmax, 0., 10000.);
	DDX_Text(pDX, IDC_MIN4, Lmin);
	DDV_MinMaxInt(pDX, Lmin, 0, 10000);
	DDX_Text(pDX, IDC_MAX4, Lmax);
	DDV_MinMaxInt(pDX, Lmax, 0, 10000);
	DDX_Text(pDX, IDC_MIN5, Hmin);
	DDV_MinMaxInt(pDX, Hmin, 0, 10000);
	DDX_Text(pDX, IDC_MAX5, Hmax);
	DDV_MinMaxInt(pDX, Hmax, 0, 10000);
	DDX_Check(pDX, IDC_CHECK1, m_check1);
	DDX_CBString(pDX, IDC_LISTE_SI, m_edit_si);
	DDX_CBString(pDX, IDC_LISTE_SINON, m_edit_sinon);
	DDX_Check(pDX, IDC_CHECK6, m_check6);
	DDX_Check(pDX, IDC_CHECK7, m_check7);
	DDX_Text(pDX, IDC_MAX6, DPBmax);
	DDV_MinMaxDouble(pDX, DPBmax, 0., 1.);
	DDX_Text(pDX, IDC_MIN6, DPBmin);
	DDV_MinMaxDouble(pDX, DPBmin, 0., 1.);
	DDX_Text(pDX, IDC_MIN7, DNdgmin);
	DDV_MinMaxInt(pDX, DNdgmin, 0, 10000);
	DDX_Text(pDX, IDC_MAX7, DNdgmax);
	DDV_MinMaxInt(pDX, DNdgmax, 0, 10000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogClassifCar, CDialog)
	//{{AFX_MSG_MAP(CDialogClassifCar)
	ON_BN_CLICKED(IDC_CLASSER, OnClasser)
	ON_BN_CLICKED(IDC_COLOR, OnColor)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_COLOR_SINON, OnColorSinon)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	ON_BN_CLICKED(IDC_CHECK7, OnCheck7)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************/
// CDialogClassifCar message handlers
/****************************************************************/

BOOL CDialogClassifCar::OnInitDialog() 
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	
	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	CComboBox *combo=(CComboBox *)GetDlgItem(IDC_LISTE);
	CComboBox *combo_si=(CComboBox *)GetDlgItem(IDC_LISTE_SI);
	CComboBox *combo_sinon=(CComboBox *)GetDlgItem(IDC_LISTE_SINON);
	CObList * liste;
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading ...");
		break;
	}

	POSITION pt = liste->GetHeadPosition();
	while (pt != NULL)
	{
		CTypeClasse *tp = (CTypeClasse *)liste->GetNext(pt);
		combo->InsertString(-1,tp->getNomClasse());
		combo_si->InsertString(-1,tp->getNomClasse());
		combo_sinon->InsertString(-1,tp->getNomClasse());
	}

	m_check1=false;
	m_check2=false;
	m_check3=false;
	m_check4=false;
	m_check5=false;
	m_check6=false;
	m_check7=false;

	return CDialog::OnInitDialog(); 

}

void CDialogClassifCar::OnClasser() 
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	
	if (!UpdateData(true)) return;
	if (m_liste.IsEmpty()) {AfxMessageBox("Please choose zones concerned");return;}
	if (m_edit_si.IsEmpty()) {AfxMessageBox("Please choose the label destination");return;}
	if (m_edit_sinon.IsEmpty()) {AfxMessageBox("Please choose the label if an error occured");return;}
	if (!m_check1&&!m_check2&&!m_check3&&!m_check4&&!m_check5&&!m_check6) {AfxMessageBox("Choose at least one rule to apply !");return;}


	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	//va chercher directement dans le labo Classif car cette boite de dialogue n'est accessible 
	//qu' partir du menu Classification->ClassifVoisinage
	bool typeSiExiste = pAppTemp->projet->getLaboClassif()->findElemListeTypesClasse(m_edit_si);
	bool typeSinonExiste = pAppTemp->projet->getLaboClassif()->findElemListeTypesClasse(m_edit_sinon);

	if (!typeSiExiste)
	{
		CRegleType *r1=new CRegleType(m_edit_si,color_si);
		((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r1);
		CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getListeDocsLaboClassif();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			r1->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
		}
	}

	if (!typeSinonExiste)
	{
		CRegleType *r2=new CRegleType(m_edit_sinon,color_sinon);
		((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r2);
		CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getListeDocsLaboClassif();
		POSITION posDoc = listDocs->GetHeadPosition();
		while (posDoc)
		{
			r2->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
		}
	}
	
	if (!m_check1) {HLmin=-1;HLmax=-1;}
	if (!m_check2) {NBCCmin=-1;NBCCmax=-1;}
	if (!m_check3) {HHmin=-1;HHmax=-1;}
	if (!m_check4) {Lmin=-1;Lmax=-1;}
	if (!m_check5) {Hmin=-1;Hmax=-1;}
	if (!m_check6) {DPBmin=-1;DPBmax=-1;}
	if (!m_check7) {DNdgmin=-1;DNdgmax=-1;}

	CRegleCC *r3 = new CRegleCC(m_liste,m_edit_si,m_edit_sinon,HLmin,HLmax,NBCCmin,NBCCmax,HHmin,HHmax,Lmin,Lmax,Hmin,Hmax,DPBmin,DPBmax,DNdgmin,DNdgmax);
	((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r3);
	CObList* listDocs = ((CMyAppApp*)AfxGetApp())->projet->getLaboClassif()->getListeDocsLaboClassif();
	POSITION posDoc = listDocs->GetHeadPosition();
	while (posDoc)
	{
		r3->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
	}

	//ajouter la regle de calcul des caracteristiques
	CRegleCarac *r4=new CRegleCarac();
	pAppTemp->projet->getLaboClassif()->getScenarioClassif()->Ajouter(r4);
	posDoc = listDocs->GetHeadPosition();
	while (posDoc)
	{
		r4->Executer((CMyAppDoc*)listDocs->GetNext(posDoc));
	}
	
	OnOK();
}

void CDialogClassifCar::OnColor() 
{
	CColorDialog * colordialog = new CColorDialog();
	colordialog->DoModal();	
	color_si = colordialog->GetColor();
}

void CDialogClassifCar::OnColorSinon() 
{
	CColorDialog * colordialog = new CColorDialog();
	colordialog->DoModal();	
	color_sinon = colordialog->GetColor();
}


void CDialogClassifCar::OnCheck1() 
{
	m_check1=!m_check1;
	CEdit *e;
	e = (CEdit *)GetDlgItem(IDC_MIN1);e->EnableWindow(m_check1);
	e = (CEdit *)GetDlgItem(IDC_MAX1);e->EnableWindow(m_check1);	
}

void CDialogClassifCar::OnCheck2() 
{
	m_check2=!m_check2;
	CEdit *e;
	e = (CEdit *)GetDlgItem(IDC_MIN2);e->EnableWindow(m_check2);
	e = (CEdit *)GetDlgItem(IDC_MAX2);e->EnableWindow(m_check2);	
}

void CDialogClassifCar::OnCheck3() 
{
	m_check3=!m_check3;
	CEdit *e;
	e = (CEdit *)GetDlgItem(IDC_MIN3);e->EnableWindow(m_check3);
	e = (CEdit *)GetDlgItem(IDC_MAX3);e->EnableWindow(m_check3);
}

void CDialogClassifCar::OnCheck4() 
{
	m_check4=!m_check4;
	CEdit *e;
	e = (CEdit *)GetDlgItem(IDC_MIN4);e->EnableWindow(m_check4);
	e = (CEdit *)GetDlgItem(IDC_MAX4);e->EnableWindow(m_check4);	
}

void CDialogClassifCar::OnCheck5() 
{
	m_check5=!m_check5;
	CEdit *e;
	e = (CEdit *)GetDlgItem(IDC_MIN5);e->EnableWindow(m_check5);
	e = (CEdit *)GetDlgItem(IDC_MAX5);e->EnableWindow(m_check5);	
}



void CDialogClassifCar::OnCheck6() 
{
	m_check6=!m_check6;
	CEdit *e;
	e = (CEdit *)GetDlgItem(IDC_MIN6);e->EnableWindow(m_check6);
	e = (CEdit *)GetDlgItem(IDC_MAX6);e->EnableWindow(m_check6);	
	
}

void CDialogClassifCar::OnCheck7() 
{
	m_check7=!m_check6;
	CEdit *e;
	e = (CEdit *)GetDlgItem(IDC_MIN7);e->EnableWindow(m_check7);
	e = (CEdit *)GetDlgItem(IDC_MAX7);e->EnableWindow(m_check7);	
	
}
