/****************************************************************/
// DialogSuppInt.cpp : implementation file
/****************************************************************/

#include "stdafx.h"
#include "myapp.h"
#include "DialogSuppInt.h"
#include "MyAppDoc.h"
#include "constante.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/****************************************************************/
// CDialogSuppInt dialog
/****************************************************************/

CDialogSuppInt::CDialogSuppInt(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogSuppInt::IDD, pParent)
{
	pView = (CView *)pParent;
	//{{AFX_DATA_INIT(CDialogSuppInt)
	m_liste = _T("");
	//}}AFX_DATA_INIT
}


void CDialogSuppInt::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogSuppInt)
	DDX_CBString(pDX, IDC_LISTE, m_liste);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogSuppInt, CDialog)
	//{{AFX_MSG_MAP(CDialogSuppInt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************/
// CDialogSuppInt message handlers
/****************************************************************/

BOOL CDialogSuppInt::OnInitDialog() 
{
	//recuperer le pointeur sur l'application :
	CMyAppApp* pAppTemp = (CMyAppApp*)AfxGetApp();
	
	CDialog::OnInitDialog();
	
	CMyAppDoc *pDoc=(CMyAppDoc *)pView->GetDocument();
	ASSERT_VALID(pDoc);

	CComboBox *combo=(CComboBox *)GetDlgItem(IDC_LISTE);
	CObList * liste;
	int typeLabo = 0;
	typeLabo = pAppTemp->projet->QuelLaboEnCours();

	switch (typeLabo)
	{
	case LABOTRAIT :
		liste = pAppTemp->projet->getLaboTrait()->getListeTypesClasse();
		break;
	case LABOCLASSIF :
		liste = pAppTemp->projet->getLaboClassif()->getListeTypesClasse();
		break;
	case LABOPROJET :
		liste = pAppTemp->projet->getLaboProj()->getListeTypesClasse();
		break;
	default :
		AfxMessageBox("Error while loading types");
		break;
	}
	
	POSITION pt = liste->GetHeadPosition();
	while (pt != NULL)
	{
		CTypeClasse *tp = (CTypeClasse *)liste->GetNext(pt);
		int a=combo->InsertString(-1,tp->getNomClasse());
	}
	
	
	CDialog::OnInitDialog();
	combo->SetCurSel(0);
	
	return TRUE;
}
