// DialogTab.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "MyApp.h"
#include "DialogTab.h"
#include "MainFrm.h"


// Bote de dialogue CDialogTab

IMPLEMENT_DYNAMIC(CDialogTab, CDialogBar)
CDialogTab::CDialogTab(CWnd* pParent /*=NULL*/)
	: CDialogBar()//(CDialogTab::IDD, pParent)
{
}

CDialogTab::~CDialogTab()
{
}

void CDialogTab::DoDataExchange(CDataExchange* pDX)
{
	CDialogBar::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialogTab)
	DDX_Control(pDX, IDC_TAB_CTRL, c_tabCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDialogTab, CDialogBar)
	//{{AFX_MSG_MAP(CDialogTab)
	ON_WM_PAINT()
	ON_MESSAGE(WM_INITDIALOG,OnInitDialog) 
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// Gestionnaires de messages CDialogTab

LONG CDialogTab::OnInitDialog(UINT wParam, LONG lParam)
{
	//CDialogBar/*CDialog*/::OnInitDialog();
	// suppression de la commande par :
	BOOL bRet = HandleInitDialog(wParam, lParam);

    if (!UpdateData(FALSE))
    {
       TRACE0("Warning: UpdateData failed during dialog init.\n");
    }

	c_tabCtrl.SetAutoSizePannel(); // retaille automatiquement les panneaux clients.

	//++++++++ les 3 onglets chargs ds l'initialisation
	m_apProjet=new CApercuProjet(this);
	m_apProjet->Create(IDD_DIALOG_APERCU_PROJET, &c_tabCtrl);
	c_tabCtrl.AddTab(m_apProjet, "Projet", 0);

	m_journal=new CJournal(this);
	m_journal->Create(IDD_JOURNAL, &c_tabCtrl);
	c_tabCtrl.AddTab(m_journal, "Journal", 1);

	//c_tabCtrl.EnableTab(1, FALSE);
	

	//+++++++++++++++++++++++ customizing the tab control +++++++++++++++++++++++
	//c_tabCtrl.SetDisabledColor(RGB(255, 0, 0));
	//c_tabCtrl.SetBackGroundColor(RGB(193, 193, 255));
	//c_tabCtrl.SetSelectedColor(RGB(0, 0, 255));
	//c_tabCtrl.SetMouseOverColor(RGB(255, 0, 0));
	//SetDialogBkColor(RGB(193, 193, 255));

	return bRet;
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDialogTab::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

	}
	else
	{
		CDialogBar::OnPaint();
	}
}