// DlgAssist1.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "MyApp.h"
#include "DlgAssist1.h"
#include ".\dlgassist1.h"
#include "DialogAssistTab.h"
#include "MainFrm.h"
#include "DialogSelFichiers.h"
#include "PathDialog.h"
#include "ProjetParam.h"


// Bote de dialogue CDlgAssist1

IMPLEMENT_DYNAMIC(CDlgAssist1, CDialog)
CDlgAssist1::CDlgAssist1(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAssist1::IDD, pParent)
{
	m_pTab = NULL;
}

CDlgAssist1::~CDlgAssist1()
{
}

void CDlgAssist1::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_ASSIST1_CHOISIR, m_ctrlAssist1BtnChoisir);
	DDX_Control(pDX, IDC_BUTTON_ASSIST1_ETPSUIV, m_ctrlAssist1BtnEtpSuiv);
}


BEGIN_MESSAGE_MAP(CDlgAssist1, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_ASSIST1_CHOISIR, OnBnClickedButtonAssist1Choisir)
	ON_BN_CLICKED(IDC_BUTTON_ASSIST1_ETPSUIV, OnBnClickedButtonAssist1Etpsuiv)
END_MESSAGE_MAP()


// Gestionnaires de messages CDlgAssist1

void CDlgAssist1::OnBnClickedButtonAssist1Choisir()
{
	//Obtenir un pointeur sur l'objet contenant les paramtres du projet
	CProjetParam* paramProjTmp = ((CMyAppApp*)AfxGetApp())->projet->getParamProj();

	CPathDialog  dlg( TEXT("Choix de l'ouvrage"), 
		TEXT("Veuillez slectionner le rpertoire contenant les images de l'ouvrage :"),
					  paramProjTmp->getM_repOuvrage());

	// show path dialog
	if ( dlg.DoModal() == IDOK )
	{
		paramProjTmp->setM_repOuvrage(dlg.GetPathName());
		//AfxMessageBox(paramProjTmp->getM_repOuvrage()); //test
		//affiche le bouton etape suivante :
		m_ctrlAssist1BtnEtpSuiv.ShowWindow(SW_SHOW);
	}
}

void CDlgAssist1::OnBnClickedButtonAssist1Etpsuiv()
{
	//apres confirmation ouvrir boite de dlg slection d'1 exemple pour les traitements
	CDialogSelFichiers dlg(true);
	if ( dlg.DoModal() == IDOK )
	{
		((CMainFrame*)AfxGetMainWnd())->m_wndDlgAssistTab.AfficherTab2A();
	}
}
