#pragma once

#include "MyApp.h"
#include "MyAppDoc.h"


class CLaboTrait
{
private:

	CObList* listeDocsLaboTrait;
	CScenario* scenarioTrait;

	CObList *listeTypesClasse;

public:

	void ModeZoom();
	void UpdateModeZoom(CCmdUI* pCmdUI);

	CScenario* getScenarioTrait(void){return scenarioTrait;}
	void setScenarioTrait(CScenario* scenarIn);
	
	CObList* getListeTypesClasse(){return listeTypesClasse;}
	void setListeTypesClasse(CObList* listeIn);
	void addElemListeTypesClasse(CTypeClasse* typeIn);
	bool findElemListeTypesClasse(CString t);
	bool supprElemListeTypesClasse(CTypeClasse* typeIn);
	void supprAllListeTypesClasse();

	CObList* getListeDocsLaboTrait(){return listeDocsLaboTrait;}
	void setListeDocuments(CObList* listeIn);
	void addElemListeDocuments(CMyAppDoc* docIn);
	bool supprElemListeDocuments(CMyAppDoc* docIn);
	void supprAllListeDocuments();

	void AfficherDocSuivant();
	void AfficherDocPrecedent();
	void RendreLeFocusALImageActive();

	void MajMenu();
	void OuvrirImageLaboTrait();
	void TraitementsAuto(); 

	void ViderLabo();
	void RechargerDocument();

	CLaboTrait(void);
	~CLaboTrait(void);
};
