// MyApp.h : main header file for the MYAPP application
//

#if !defined(AFX_MYAPP_H__B70E8BC0_EBB2_4FF6_8185_DBC25EEB332C__INCLUDED_)
#define AFX_MYAPP_H__B70E8BC0_EBB2_4FF6_8185_DBC25EEB332C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
#include "ListeCC.h"
#include "Projet.h"

#include <gdiplus.h>
using namespace Gdiplus;

/////////////////////////////////////////////////////////////////////////////
// CMyAppApp:
// See MyApp.cpp for the implementation of this class
//

class CMyAppApp : public CWinApp
{
public:

	CMyAppApp();


	bool m_boutonToolbarEnregistrer;
	bool m_boutonToolbarAddImages;
	bool m_boutonToolbarReconnaissance;
	bool m_boutonToolbarZoom; 
	bool m_menuProjetParam;
	bool m_menuProjetFermer;
	bool m_menuAffichageBarreAssistant;
	bool m_menuAffichageBarreProjet;

	CProjet *projet;
	CMyAppDoc *pDocCharge;
	bool docCharge;

	void isProjetOpen();
	void isProjetClosed();
	bool OnFileChoisirOuvrage();
	void OuvrirDocument(CString nomDoc, int typeLabo);
	bool FermerDocument(CMyAppDoc* pDocIn);
	void FermerTousDocuments();
	void ChargerDoc(CMyAppDoc* pDocACharger);
	void ChargerDocSelectionne();
	void DechargerDoc(CMyAppDoc* pDocADecharger);

	//pour l'affichage des vignettes
	ULONG_PTR	m_gdiplusToken;


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMyAppApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CMyAppApp)
	afx_msg void OnAppAbout();
	
	afx_msg void OnMenuProjNew();
	afx_msg void OnMenuProjOpen();
	afx_msg void OnMenuProjSave();
	afx_msg void OnUpdateMenuProjSave(CCmdUI* pCmdUI);
	afx_msg void OnMenuProjParam();
	afx_msg void OnUpdateMenuProjParam(CCmdUI* pCmdUI);
	afx_msg void OnMenuProjFermer();
	afx_msg void OnUpdateMenuProjFermer(CCmdUI* pCmdUI);
	afx_msg void OnMenuProjQuitter();

	afx_msg void OnMenuAffZoom();
	afx_msg void OnUpdateMenuAffZoom(CCmdUI* pCmdUI);
	afx_msg void OnMenuAffBarreProjet();
	afx_msg void OnUpdateMenuAffBarreProjet(CCmdUI* pCmdUI);
	afx_msg void OnMenuAffBarreEtat();
	afx_msg void OnUpdateMenuAffBarreEtat(CCmdUI* pCmdUI);
	afx_msg void OnMenuAffBarreOutils();
	afx_msg void OnUpdateMenuAffBarreOutils(CCmdUI* pCmdUI);
	afx_msg void OnMenuAffBarreAssistant();
	afx_msg void OnUpdateMenuAffBarreAssistant(CCmdUI* pCmdUI);
	
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYAPP_H__B70E8BC0_EBB2_4FF6_8185_DBC25EEB332C__INCLUDED_)
