#pragma once

#include <afxtempl.h>

class CProjetParam
{
private:
	CString m_repTravail; //le rep de l'application (ne sert pas a grand chose)
	CString m_repResultats;//repertoire qui contiendra les rsultats
	CString m_repOuvrage;//repertoire qui contient les images  traiter
	CString m_ficSauvegarde;//fichier de serialisation de la variable projet
	CString m_ficXml;//fichier xml rassemblant tous les parametres
	CString m_imLaboTrait;//image qui permet d'effectuer les traitements et fusions
	CList<CString,CString>* m_listeImageClassif;//lite d'images qui permettent d'effectuer la classification
	int m_numEtapeAssist;//numero de l'tape d'assistant o l'utilisateur se situe lors de l'enregistrement
	CString m_nomProjet;

	int m_seuilBinarisation;
	bool m_binAuto;
	int m_gdeCcLarg; //largeur d'une gde CC (DX)
	int m_gdeCcHaut; //hauteur d'une gde CC (DY)
	int m_pteCcLarg; //largeur d'une pte CC (DX)
	int m_pteCcHaut; //hauteur d'une pte CC (DY)
	int m_seuilH;
	int m_seuilV;
	int m_rapportMappage;
	int m_deltaDecoup;
	bool m_traitTexte;

public:

	CString getM_repTravail(){return m_repTravail;}
	CString getM_repResultats(){return m_repResultats;}
	CString getM_repOuvrage(){return m_repOuvrage;}
	CString getM_ficSauvegarde(){return m_ficSauvegarde;}
	CString getM_ficXml(){return m_ficXml;}
	CString getM_imLaboTrait(){return m_imLaboTrait;}
	CString getM_nomProjet(){return m_nomProjet;}
	CList<CString,CString>* getM_listeImageClassif(){return m_listeImageClassif;}
	int getM_numEtapeAssist(){return m_numEtapeAssist;}
	int getM_seuilBinarisation(){return m_seuilBinarisation;}
	bool getM_binAuto(){return m_binAuto;}
	int getM_gdeCcLarg(){return m_gdeCcLarg;}
	int getM_gdeCcHaut(){return m_gdeCcHaut;}
	int getM_pteCcLarg(){return m_pteCcLarg;}
	int getM_pteCcHaut(){return m_pteCcHaut;}
	int getM_seuilH(){return m_seuilH;}
	int getM_seuilV(){return m_seuilV;}
	int getM_rapportMappage(){return m_rapportMappage;}
	int getM_deltaDecoup(){return m_deltaDecoup;}
	bool getM_traitTexte(){return m_traitTexte;}

	void setM_repTravail(CString val){m_repTravail.Empty(); m_repTravail = val;}
	void setM_repResultats(CString val){m_repResultats.Empty(); m_repResultats = val;}
	void setM_repOuvrage(CString val){m_repOuvrage.Empty(); m_repOuvrage = val;}
	void setM_ficSauvegarde(CString val){m_ficSauvegarde.Empty(); m_ficSauvegarde = val;}
	void setM_ficXml(CString val){m_ficXml.Empty(); m_ficXml = val;}
	void setM_imLaboTrait(CString val){m_imLaboTrait.Empty(); m_imLaboTrait = val;}
	void setM_nomProjet(CString val){m_nomProjet.Empty(); m_nomProjet = val;}
	void setM_listeImageClassif(CList<CString,CString>* listeIn);
	void addM_listeImageClassif(CString elem){m_listeImageClassif->AddTail(elem);}
	void setM_numEtapeAssist(int val){m_numEtapeAssist = val;}
	void setM_seuilBinarisation(int val){m_seuilBinarisation = val;}
	void setM_binAuto(bool val){m_binAuto = val;}
	void setM_gdeCcLarg(int val){m_gdeCcLarg = val;}
	void setM_gdeCcHaut(int val){m_gdeCcHaut = val;}
	void setM_pteCcLarg(int val){m_pteCcLarg = val;}
	void setM_pteCcHaut(int val){m_pteCcHaut = val;}
	void setM_seuilH(int val){m_seuilH = val;}
	void setM_seuilV(int val){m_seuilV = val;}
	void setM_rapportMappage(int val){m_rapportMappage = val;}
	void setM_deltaDecoup(int val){m_deltaDecoup = val;}
	void setM_traitTexte(bool val){m_traitTexte = val;}

	void InitialiserParamProj(CString nomProj);
	void ViderParamProj();

	CProjetParam(void);
	~CProjetParam(void);
};
