/************************************************************************/
// Regle.h: interface for the CRegle class.
// 
// C'est la classe mre de tous les autres types de rgles. Elle possde 
// les attributs communs  tout type de rgle et des fonctions virtuelles 
// qu'il est obligatoire d'implmenter dans les classes filles.
//
// Pour scnariser un traitement, il suffit de crer une nouvelle classe 
// qui hrite de CRegle. Ensuite il faut : 
// 1.ajouter les attributs caractristiques de la rgle et dfinir un constructeur
// surcharg
// 2. il faut redfinir la fonction "executer" avec le code  excuter lors de  
// l'appel de la rgle
// 3. Redefinir la fonction getDescription avec une description prcise du traitement
// effectu, celle-ci s'affichera dans la fentre de scnario.
// 4. Redfinir la fonction serialize avec les attributs  sauvegarder
// 5. Mettre un identifiant unique dans l'attribut balise de chaque constructeur
// 6. Dans la fonction charger de la classe scnarion, complter le code en
// fonction de la balise choisit en tape 5
//
/************************************************************************/


#include "regletype.h"


#if !defined(AFX_REGLE_H__FD58C864_85C2_47E6_9CE2_2EB7B735E8DC__INCLUDED_)
#define AFX_REGLE_H__FD58C864_85C2_47E6_9CE2_2EB7B735E8DC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/******************************/
// CLASSE
/******************************/

class CRegle  : public CObject
{

protected:

	CString balise;

public:
	
	void Serialize(CArchive& ar);
	void setNumero(int n);
	int getNumero();
	CString getBalise();

	CRegle();
	//CRegle(CString b, CString l, int n=0);
	virtual ~CRegle();

	void virtual Executer(CDocument *pDoc);
	CString virtual getDescription();

private:

	int numero;

};



#endif // !defined(AFX_REGLE_H__FD58C864_85C2_47E6_9CE2_2EB7B735E8DC__INCLUDED_)
