/******************************************************************/
// RegleCC.h: interface for the CRegleCC class.
//
// Permet la gestion des rgle de classification selon les
// les caractristique des zones
//
/******************************************************************/

#if !defined(AFX_REGLECC_H__34F81CFE_6608_425C_B966_8C9D5515705D__INCLUDED_)
#define AFX_REGLECC_H__34F81CFE_6608_425C_B966_8C9D5515705D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "Regle.h"

/******************/
// CLASSE
/******************/

class CRegleCC : public CRegle  
{
public:

	CString getDescription();
	CRegleCC();
	CRegleCC(CString org, CString dest, CString dest_sinon, double HLmin,double HLmax,int NBCCmin,int NBCCmax,double HHmin,double HHmax,int Lmin,int Lmax,int Hmin,int Hmax, double pDPBmin, double pDPBmax, int pDNdgmin, int pDNdgmax);
	virtual ~CRegleCC();
	void virtual Executer(CDocument *pDoc);
	void Serialize(CArchive& ar);

private:

	void Classification_Caracteristiques(CDocument *pDoc);

private:

	CString type_org;
	CString type_dest;
	CString type_dest_sinon;
	double HLmin;
	double HLmax;
	int NBCCmin;
	int NBCCmax;
	double HHmin;
	double HHmax;
	int Lmin;
	int Lmax;
	int Hmin;
	int Hmax;
	double DPBmin;
	double DPBmax;
	int DNdgmin;
	int DNdgmax;

};



#endif // !defined(AFX_REGLECC_H__34F81CFE_6608_425C_B966_8C9D5515705D__INCLUDED_)
