/*************************************************************/
// RegleCG.h: interface for the CRegleCG class.
//
// Permet la gestion des rgles de classification gographique
//
/*************************************************************/

#if !defined(AFX_REGLECG_H__8BE23FCC_B9D0_4B5C_846E_CBF02204FC4E__INCLUDED_)
#define AFX_REGLECG_H__8BE23FCC_B9D0_4B5C_846E_CBF02204FC4E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include "Regle.h"
#include "image.h"


/******************/
// CLASSE
/******************/

class CRegleCG : public CRegle  
{

public:
	
	CRegleCG();
	CRegleCG(CString o, char di,int pourcent, CString dsi, CString dsinon);
	virtual ~CRegleCG();

	void virtual Executer(CDocument *pDoc);
	void Serialize(CArchive& ar);
	CString getDescription();

private:

	void Classification_Geographique(CDocument *pDoc, CString classe_source,char pos,int value, CString dest_si, CString dest_sinon);

private:

	int pourcent;
	char dir;
	CString dest_si;
	CString dest_sinon;
	CString org;

};



#endif // !defined(AFX_REGLECG_H__8BE23FCC_B9D0_4B5C_846E_CBF02204FC4E__INCLUDED_)
