/**************************************************************/
// RegleChangeType.h: interface for the CRegleChangeType class.
//
// Permet de scnariser les traitements de suppression et/ou coloriage
// d'un type de zone
//
/**************************************************************/

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include "Regle.h"

/******************/
// CLASSE
/******************/


class CRegleChangeType : public CRegle  
{

public:

	CRegleChangeType();
	CRegleChangeType(CString pTypeOrg, CString pTypeDest, bool pSuppressionTypeOrg);
	virtual ~CRegleChangeType();

	void virtual Executer(CDocument *pDoc);
	void Serialize(CArchive& ar);
	CString getDescription();

private:

	CString typeOrg;
	CString typeDest;
	bool suppressionTypeOrg;

};

