/****************************************************************/
// RegleMorph.h: interface for the CRegleMorph class.
//
// Permet de scnariser les traitements dits morphologiques tels que
// ouverture, fermeture, erosion, dilatation, inversion
//
/****************************************************************/


#if !defined(AFX_REGLEMORPH_H__3C602A6B_CE21_4303_B846_24CDBEECB89F__INCLUDED_)
#define AFX_REGLEMORPH_H__3C602A6B_CE21_4303_B846_24CDBEECB89F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include "Regle.h"


/******************/
// CLASSE
/******************/


class CRegleMorph : public CRegle 
{

public:

	CRegleMorph();
	CRegleMorph(CString op);
	virtual ~CRegleMorph();

	CString getDescription();
	void virtual Executer(CDocument *pDoc);
	void Serialize(CArchive& ar);

private:

	CString operation;

};


#endif // !defined(AFX_REGLEMORPH_H__3C602A6B_CE21_4303_B846_24CDBEECB89F__INCLUDED_)
