/******************************************************************************/
// RegleTAO.h: interface for the RegleTAO class.
//
// Permet de scnariser le traitement de TAO
//
/******************************************************************************/

#if !defined(AFX_REGLETAO_H__9D4571A7_F855_4FF9_9F95_9FF1D7896675__INCLUDED_)
#define AFX_REGLETAO_H__9D4571A7_F855_4FF9_9F95_9FF1D7896675__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "Regle.h"

/******************/
// CLASSE
/******************/

class CRegleTAO : public CRegle  
{

private:

	CString type_zone;
	double seuil_dico;

public:

	CString getDescription();
	void virtual Executer(CDocument *pDoc);
	void Serialize(CArchive& ar);

	CRegleTAO();
	CRegleTAO(CString tz, double seuil);
	virtual ~CRegleTAO();

};


#endif // !defined(AFX_REGLETAO_H__9D4571A7_F855_4FF9_9F95_9FF1D7896675__INCLUDED_)
